﻿var ExamCenterCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            //广告页尺寸为5:2
            document.getElementById("exam_ad").style.height = document.getElementById("exam_ad").offsetWidth * 0.4 + "px";

            //获取数据
            Util.ajax({
                method: "POST",
                data: {
                    propType: enumKey.Ad.Game,
                    userType: enumKey.UserType.Student,
                    userId: Cache.getCache("LoginUserInfo").UserId
                },
                url: Util.getApiUrl("ListHomePage")
            }, function (data) {
                that.dataObj = data;
                that.render();
            });
        },

        //页面数据渲染
        render: function () {
            //广告
            if (that.dataObj.AdvertisementList) {
                for (var i = 0; i < that.dataObj.AdvertisementList.length; i++) {
                    (function (ad) {
                        var fg = document.createElement("figure");
                        fg.style.margin = "0";
                        fg.style.height = "0";
                        var img = new Image();
                        img.src = ad.AdImgStr;
                        img.className = "exam_ad_img";
                        img.style.height = document.getElementById("exam_ad").offsetHeight + "px";
                        img.onclick = function () {

                        }
                        fg.appendChild(img);
                        document.getElementById("exam_ad_sw").appendChild(fg);
                    })(that.dataObj.AdvertisementList[i]);
                }
                var adSlider = new Swipe(document.getElementById('exam_ad'), {
                    speed: 600,
                    auto: 3000,
                    continuous: true,
                    disableScroll: true,
                    stopPropagation: false,
                    callback: function (pos) {

                    }
                });
            }
        },

        doAwait: function () {
            Util.info("敬请期待", false);
        },

        doMusic: function () {
            var MusicSong = JSON.stringify({ GameType: 1 });
            Cache.setCache("SongMusicInfo", MusicSong);
            toPage("pnl_songMusic");
        },
        
        doSong: function () {
            var MusicSong = JSON.stringify({ GameType: 2 });
            Cache.setCache("SongMusicInfo", MusicSong);
            toPage("pnl_songMusic");
        },
    };
    return new obj();
})();