﻿var HomeworkDetailDanceCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginInfo = Cache.getCache("LoginUserInfo");
            that.homeworkId = Cache.getCache("HomeworkDetail_HomeworkId");
            that.correntList = [];
            $("#ulList").html("");
            that.init();
        },

        //返回
        goBack: function () {
            if (typeof (homeWork) != "undefined") {
                homeWork.remove();
                homeWork.stopPlay();//fixedby lijq 2016/11/11
            }

            $("#zebra.fm").hide();

            var popWin = document.getElementById("ZebDance_shape_popup_icon_lastornext");
            if (popWin) {
                document.body.removeChild(popWin);
            }
            $("canvas").show();
            // fixed by lujf 2016-12-1 改用原生的video start 
            // 如果是查看批注的状态，还原页面样式
            if ($("#sLookCorretBtn").html() != "查看批注") {
                that.previewBtnHideClick();
                $("#sLookCorretBtn").html('查看批注');
                that.clean();
            }
            //$("#loadingbar").hide();
            that.exitFlag = true;// add by lujf 2016-12-1 退出是记录状态
            // fixed by lujf 2016-12-1 改用原生的video end 
            videoPageBack("hdd_videoshow");
        },

        //初始化
        init: function () {
            $(".hdd_video_div").height(window.innerHeight - $(".hdd_video_div").offset().top - $(".hdd_look_correct_div").height());// add by lujf 2016-11-30 设置video高度
            // fixed by lujf 2016-11-30 改用原生的video start
            that.video = document.getElementById("hdd_videoshow");
            that.video.controls = true;
            //如果不是ios系统，则添加唤醒进度条的功能
            that.exitFlag = false;
            if (Util.getSystemType() != "IOS") {
                that.setControl();
            }
            // fixed by lujf 2016-11-30 改用原生的video end
            Util.ajaxL({
                method: "POST",
                data: {
                    homeworkId: that.homeworkId
                },
                url: Util.getApiUrl("CorrectingHomeworkDetail")
            }, function (resultData) {
                //Fixedby lijq 2016/4/26 添加学生id
                that.studentId = resultData.UserId;

                that.VideoUrlInfo = resultData.VideoUrlInfo;
                //加载视频
                $("#hdd_videoshow").attr("src", resultData.VideoUrlInfo);
                //fixed by lujf 2016-12-1 改用原生的video
                //video.init({
                //    videoObj: $("#videoshow"),//video组件的dom
                //    loadingobj: $("#loadingobj"),//loading的dom
                //    current: $("#current"),//视频播放当前时间的dom
                //    duration: $("#duration"),//记录视频播放总时间的dom
                //    timeBar: $("#timeBar"),//播放时间条的dom
                //    btnStop: $("#btnStop"),//播放停止按钮dom
                //    btnPlay: $("#btnPlay"),//播放按钮dom
                //    bufferBar: $("#bufferBar"),//播放按钮dom
                //    progress: $("#progress"),//进度条
                //    speedX1: $("#btnx1"),//播放按钮dom
                //    speedX3: $("#btnx3"),//进度条
                //    control: $("#control"),//进度条
                //    playBtn: $("#playBtn"),//进度条
                //});

                zebra.ready(function () {
                    homeWork = new ZebDance.happymusic.homework(true, that.noti, 48, 48);//不可编辑画布-定义全局变量
                    $("canvas").hide();
                    document.getElementById("zebra.fm").style.display = "none";
                });

                if (resultData.HomeworkStatus == 2)//已批改
                {
                    that.correctScore = resultData.Correct.CorrectScore == "" ? 0 : resultData.Correct.CorrectScore;
                    that.correctComment = resultData.Correct.CorrectComment;
                    that.correntList = JSON.parse(resultData.Correct.CorrectContent);
                    that.EditPreview(true, false, that.correntList);                    
                }

                that.log = 0;
                $("#ulList").undelegate();//解除之前委托
                //托管删除
                $("#ulList").delegate("a", "click", function (event) {
                    if (typeof $(this).attr("data-id") == "undefined") {
                        return;
                    }
                    that.correntList.remove($(this).attr("data-id"), "key");//数组定点删除
                    //根据data-id 获取该批改-并删除
                    $(this.parentElement).remove();
                    that.log = 1;

                });
                $("#ulList").delegate("li", "click", function (event) {
                    if (that.log == 1) {
                        that.log = 0;
                        return;
                    }
                    if (typeof $(this).attr("data-id") == "undefined") {
                        return;
                    }
                    //根据data-id 获取该批改并显示
                    that.selectObj = that.correntList.getObj($(this).attr("data-id"), "key");
                    that.selectClick();

                    $("#hdd_videoshow").attr("width", "100%");
                    $("#hdd_videoshow").attr("height", "100%");
                });

            }, function () {

            });
        },

        //fixedby lujf 2016/11/29 安卓手机，播放视频时，controllers 进度条一直显示
        setControl: function () {
            if ($("#sLookCorretBtn").html() == "查看批注") {
                that.video.controls = true;
            }
            else {
                that.video.controls = false;
            }
            setTimeout(function () {
                // 退出页面时不再显示
                if (!that.exitFlag) {
                    that.setControl();
                }
            }, 10);
        },

        //弹出信息
        noti: function (msg) {
            Util.info(msg);
        },

        //清空
        clean: function () {
            if (homeWork) {
                homeWork.clearCanvas();
            }
        },

        // 显示批改内容
        showCorrect: function (time) {
            // fixed by lujf 2016-12-1 改用原生的video start
            //var video = $("#showVideo");
            //if (video) {
            //    video.currentTime = time;
            //    $('.btnPlay').removeClass('paused');
            //    video.pause();
            //}
            that.video.pause();
            that.video.currentTime = time;
            // fixed by lujf 2016-12-1 改用原生的video end
            var resultList = null;
            var position = null;
            for (var i = 0; i < correntList.length; i++) {
                if (time == correntList[i].time) {
                    resultList = correntList[i].resultList;
                    position = correntList[i].Position
                }
            }
            if (homeWork != null && resultList != null) {
                homeWork.clearCanvas();
                homeWork.reducteCompList(resultList, position);
            }
        },

        //暂停视频播放
        pause: function () {
            var video = $("#showVideo");
            if (video) {
                video.pause();
                $('.btnPlay').removeClass('paused');
            }
        },

        //设置权限
        setReadOnly: function (isReadOnly) {
            if (isReadOnly == true) {
                $("canvas").hide();
            } else if (isReadOnly == false) {
                $("canvas").show();
            }
            if (typeof homeWork != "undefined") {
                homeWork.setReadOnly(isReadOnly);
            }
        },

        //显示选择
        selectClick: function () {
            if (typeof homeWork != "undefined" && that.selectObj) {
                that.clean();
                homeWork.reducteCompList(that.selectObj.resultList, that.selectObj.Position);
                //video.setCurrentTime(that.selectObj.time);
                that.video.currentTime = that.selectObj.time;// fixed by lujf 2016-11-30 改用原生的video 
                that.setReadOnly(true);
                that.previewBtnHideClick();//隐藏预览
                console.log("progressEvent.loaded --> " + JSON.stringify(that.correntList));
                console.log("selectObj--> " + JSON.stringify(that.selectObj));
                that.popupIconLastornext();
            }
        },

        //已批改完查看批阅
        sLookCorretBtnClick: function () {
            if ($("#sLookCorretBtn").html() != "查看批注") {
                that.previewBtnHideClick();
                $("#sLookCorretBtn").html('查看批注');
                that.clean();
                //video.showVideobar();//fixed by lujf 2016-12-1 改用原生的video
                var popWin = document.getElementById("ZebDance_shape_popup_icon_lastornext");
                if (popWin) {
                    document.body.removeChild(popWin);
                }
                that.video.controls = true;//fixed by lijq 2016-12-1 改用原生的video
                return;
            }
            else {
                that.video.controls = false;//fixed by lujf 2016-12-1 改用原生的video
            }
            //video.videoload();
            //video.hideVideobar();
            that.video.pause();//fixed by lujf 2016-12-1 改用原生的video          
            that.previewBtnshowClick();
            $("#sLookCorretBtn").html("取消查看");
        },

        //关闭评论框
        popupIconLastornext: function () {
            var popWin = document.getElementById("ZebDance_shape_popup_icon_lastornext");
            if (!popWin) {
                popWin = document.createElement("div");
                popWin.id = "ZebDance_shape_popup_icon_lastornext";
                popWin.style.zIndex = 500;
                popWin.style.position = "absolute";
                popWin.style.fontFamily = "微软雅黑";
                popWin.style.width = '100%';
                popWin.style.height = 'auto';
                popWin.style.bottom = '48px';
                var contentHtml = '<div>';
                contentHtml += '<img id="ZebDance_shape_popup_icon_last" src="images/homework/icon_last.png" class="ZebDance_shape_popup_icon_last">';
                contentHtml += '<img id="ZebDance_shape_popup_icon_next" src="images/homework/icon_next.png" class="ZebDance_shape_popup_icon_next">';
                contentHtml += '</div>';
                popWin.innerHTML = contentHtml;
                document.body.appendChild(popWin);
                var curindex = 0;
                for (var i = 0; i < that.correntList.length; i++) {
                    if (that.selectObj.key == that.correntList[i].key) {
                        curindex = i;
                    }
                }
                if (curindex != 0) {
                    $("#ZebDance_shape_popup_icon_last").show();
                } else {
                    $("#ZebDance_shape_popup_icon_last").hide();
                }
                if (curindex != (that.correntList.length - 1)) {
                    $("#ZebDance_shape_popup_icon_next").show();
                } else {
                    $("#ZebDance_shape_popup_icon_next").hide();
                }


                document.getElementById('ZebDance_shape_popup_icon_last').addEventListener('click', function () {
                    for (var i = 0; i < that.correntList.length; i++) {
                        if (that.selectObj.key == that.correntList[i].key) {
                            if ((i - 1) != -1) {
                                that.selectObj = that.correntList[i - 1];
                                that.clean();
                                homeWork.reducteCompList(that.selectObj.resultList, that.selectObj.Position);
                                //video.setCurrentTime(that.selectObj.time);
                                that.video.currentTime = that.selectObj.time;// fixed by lujf 2016-11-30 改用原生的video 
                                $("#ZebDance_shape_popup_icon_next").show();
                                if ((i - 1) != 0) {
                                    $("#ZebDance_shape_popup_icon_last").show();
                                } else {
                                    $("#ZebDance_shape_popup_icon_last").hide();
                                }
                                return;
                            }
                        }
                    }

                });
                document.getElementById('ZebDance_shape_popup_icon_next').addEventListener('click', function () {
                    for (var i = 0; i < that.correntList.length; i++) {
                        if (that.selectObj.key == that.correntList[i].key) {
                            if ((i + 1) != (that.correntList.length)) {
                                that.selectObj = that.correntList[i + 1];
                                that.clean();
                                homeWork.reducteCompList(that.selectObj.resultList, that.selectObj.Position);
                                //video.setCurrentTime(that.selectObj.time);
                                that.video.currentTime = that.selectObj.time;// fixed by lujf 2016-11-30 改用原生的video 
                                $("#ZebDance_shape_popup_icon_last").show();
                                if ((i + 1) != (that.correntList.length - 1)) {
                                    $("#ZebDance_shape_popup_icon_next").show();
                                } else {
                                    $("#ZebDance_shape_popup_icon_next").hide();
                                }
                                return;
                            }
                        }
                    }
                });
            } else {
                var curindex = 0;
                for (var i = 0; i < that.correntList.length; i++) {
                    if (that.selectObj.key == that.correntList[i].key) {
                        curindex = i;
                    }
                }
                if (curindex != 0) {
                    $("#ZebDance_shape_popup_icon_last").show();
                } else {
                    $("#ZebDance_shape_popup_icon_last").hide();
                }
                if (curindex != (that.correntList.length - 1)) {
                    $("#ZebDance_shape_popup_icon_next").show();
                } else {
                    $("#ZebDance_shape_popup_icon_next").hide();
                }
            }
        },

        //预览一览
        EditPreview: function (isStudent, cleanAll, list) {
            //将视频变小
            var htmlObj = $("#ulList");
            var html = "";
            $.each(list, function (index, item) {
                html += '<li data-id="' + item.key + '" >';
                if (isStudent != true) {
                    html += '<a data-id="' + item.key + '">*</a>';
                }
                html += '<img src="' + that.VideoUrlInfo + '?vframe/png/offset/' + item.time + '/rotate/90/w/300"/></li>';
            });
            if (cleanAll == true) {
                htmlObj.html(html);
            } else {
                htmlObj.append(html);
            };
        },

        //显示预览
        previewBtnshowClick: function (event) {
            //ios-if视频未播放视频加载
            $("#content1").hide();
            $("#content2").show();
            $("#correctContent").css("bottom", "48px");
        },

        //隐藏预览
        previewBtnHideClick: function (event) {
            $("#content1").show();
            $("#content2").hide();
            $("#correctContent").css("bottom", "-200px");
        },

        //显示总评论
        showCommentPanel: function () {
            var payPanelId = "hdd_comment_panel";
            var payPanel = document.createElement('div');
            document.body.appendChild(payPanel);
            payPanel.className = "hdd_comment";
            payPanel.id = payPanelId;

            var html = '     <div class="hdd_comment_title">'
            if (that.correctScore >= 1) {
                html += '      <img src="images/homeworkTe/star.png"/>'
            } else {
                html += '      <img src="images/homeworkTe/star_empty.png"/>'
            }
            if (that.correctScore >= 2) {
                html += '      <img src="images/homeworkTe/star.png"/>'
            } else {
                html += '      <img src="images/homeworkTe/star_empty.png"/>'
            }
            if (that.correctScore >= 3) {
                html += '      <img src="images/homeworkTe/star.png"/>'
            } else {
                html += '      <img src="images/homeworkTe/star_empty.png"/>'
            }
            if (that.correctScore >= 4) {
                html += '      <img src="images/homeworkTe/star.png"/>'
            } else {
                html += '      <img src="images/homeworkTe/star_empty.png"/>'
            }
            if (that.correctScore >= 5) {
                html += '      <img src="images/homeworkTe/star.png"/>'
            } else {
                html += '      <img src="images/homeworkTe/star_empty.png"/>'
            }
            html += '         <div class="hdd_comment_close" onclick="HomeworkDetailDanceCtrl.hideCommentPanel()">'
            html += '             <img src="images/homeworkTe/close.png"/>'
            html += '         </div>'
            html += '     </div>'
            html += '  <div class="hdd_comment_content">' + that.correctComment + '</div>';

            payPanel.innerHTML = html;
            payPanel.style.display = 'block';
            showHomeworkBg();
        },

        //隐藏总评论
        hideCommentPanel: function () {
            hideHomeworkBg();
            $("#hdd_comment_panel").remove();
        }
    };
    return new obj();
})();