﻿var MyHomeworkCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {            
            that.loginUser = Cache.getCache("LoginUserInfo");
            document.getElementById("mh_receive_list_content").style.height = document.getElementById("content").offsetHeight - $("#mh_top_div").height() + "px";
            document.getElementById("mh_homework_list_content").style.height = document.getElementById("content").offsetHeight - $("#mh_top_div").height() + "px";

            //初始化收到的作业列表
            that.listReceivedScroll = new devAfScroller("mh_receive_list_content", {
                refreshFunc: that.loadReceived,
                loadMoreFunc: that.loadReceivedMore
            });
            //初始化作业列表
            that.listHomeworkScroll = new devAfScroller("mh_homework_list_content", {
                refreshFunc: that.loadHomework,
                loadMoreFunc: that.loadHomeworkMore
            });

            that.listReceivedScroll.scrollTo({ x: 0, y: 0 });
            that.listHomeworkScroll.scrollTo({ x: 0, y: 0 });

            that.receivedDataList = [];
            that.homeworkDataList = [];

            var tabIndex = Cache.getCache("MyHomework_index");
            that.changeTab(tabIndex);
        },

        //改变选择内容
        changeTab: function (index) {
            $("#mh_top_tab_upload").css('border-bottom', 'none');
            $("#mh_top_receive").css('border-bottom', 'none');
            $("#mh_top_homework").css('border-bottom', 'none');
            $("#mh_receive_list_content").css('display', 'none');
            $("#mh_homework_list_content").css('display', 'none');

            if (index == 1)
            {
                //切换按钮的横线有无
                $("#mh_top_div").css('border-bottom', 'none');
                //相关按钮的颜色变更
                $("#mh_top_tab_upload").css('border-bottom', '1px solid #FF6E6E');
                //有无背景图
                $("#mh_content").addClass('mh_content');
                //是否添加点击按钮
                $("#mh_uplaod_btn").addClass('mh_upload_button');
            }
            else if (index == 2)
            {
                $("#mh_top_div").css('border-bottom', '1px solid #828282');
                $("#mh_top_receive").css('border-bottom', '1px solid #FF6E6E');
                $("#mh_content").removeClass('mh_content');
                $("#mh_uplaod_btn").removeClass('mh_upload_button');

                $("#mh_receive_list_content").css('display', 'block');
                that.loadReceived();
                that.listReceivedScroll.scrollTo({ x: 0, y: 0 });
            }
            else {
                $("#mh_top_div").css('border-bottom', '1px solid #828282');
                $("#mh_top_homework").css('border-bottom', '1px solid #FF6E6E');
                $("#mh_content").removeClass('mh_content');
                $("#mh_uplaod_btn").removeClass('mh_upload_button');

                $("#mh_homework_list_content").css('display', 'block');
                that.loadHomework();
                that.listHomeworkScroll.scrollTo({ x: 0, y: 0 });
            }
        },

        //加载收到的作业
        loadReceived: function () {
            // 判断课本表是否初始化
            var checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_publish'";
            db.fetchAll(checkInitSql, function (ret) {
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            userId: that.loginUser.UserId,
                            lastTime:""
                        },
                        url: Util.getApiUrl("StudentHomeworkList404")// fixed by 2016-11-24 增加获取字段
                    }, function (data) {
                        //  清空列表                     
                        $("#mh_receive_list_item").html("");
                        
                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = data.slice(0, 10);
                            that.receivedDataList = dataList;
                            // 显示数据
                            that.showReceivedList(dataList);
                           
                            that.listReceivedScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.listReceivedScroll.pullback();
     
                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                                var it = data[i];
                                var sql2 = "insert into t_publish(PublishId,VideoId,VideoName,RealName,CreateTimeStr,Status,CustomType,BookId,BookName,BookType)" +
                                   " values (" + it.PublishId + ","
                                   + it.VideoId + ",'"
                                   + it.VideoName + "','"
                                   + it.RealName + "','"
                                   + it.CreateTimeStr + "',0,"
                                   + it.CustomType + ","
                                   + it.BookId + ",'"
                                   + it.BookName + "',"
                                   + it.BookType
                                   + ")";// fixed by lujf 2016-11-24 增加获取的字段
                                  db.query(sql2);
                                
                               
                            }
                            // 保存最后更新时间
                            sql = "insert into t_manage(tbl_nm,last_update_time) values('t_publish','" + data[0].CreateTimeDateStr + "')";
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.receivedDataList = [];
                        }
                    });
                } else {// 已经初始化 
                    // 取出本地数据
                    that.getDataList(2,0, 10, function (dataList) {
                        //  清空列表                       
                        $("#mh_receive_list_item").html("");
                       
                        that.receivedDataList = dataList;
                        // 显示数据
                        that.showReceivedList(dataList);

                        // 设置scroller
                        that.listReceivedScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listReceivedScroll.pullback();

                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                userId: that.loginUser.UserId,
                                lastTime: ret[0].last_update_time //fixedby lijq 2016/11/7 已有的要添加更新时间
                            },
                            url: Util.getApiUrl("StudentHomeworkList404")// fixed by 2016-11-24 增加获取字段
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            var it;
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    it = data[i];                                   
                                    //验证数据是否已存在
                                    var checkSql = "select count(*) as ct from t_publish where PublishId = " + it.PublishId;
                                    db.fetchAll(checkSql, function (ret) {
                                        if (ret[0].ct <= 0) {
                                            // 新增
                                            if (!it.IsDeleted) {
                                                var insertsql = "insert into t_publish(PublishId,VideoId,VideoName,RealName,CreateTimeStr,Status,CustomType,BookId,BookName,BookType)" +
                                                " values (" + it.PublishId + ","
                                                + it.VideoId + ",'"
                                                + it.VideoName + "','"
                                                + it.RealName + "','"
                                                + it.CreateTimeStr + "',0,"
                                                + it.CustomType + ","
                                                + it.BookId + ",'"
                                                + it.BookName + "',"
                                                + it.BookType
                                                + ")";// fixed by lujf 2016-11-24 增加获取的字段
                                                db.query(insertsql);
                                            }
                                        }
                                    });                                                                       
                                }

                                // 保存最后更新时间
                                var sql = "update t_manage set last_update_time = '" + data[0].CreateTimeDateStr + "' where tbl_nm = 't_publish'";
                                db.query(sql);
                            }
                        });
                    }, function () {
                        // 设置scroller
                        that.listReceivedScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listReceivedScroll.pullback();
                    });
                }
            });         
        },

        // 加载更多
        loadReceivedMore: function () {
            if (that.receivedDataList.length < 10) { return; }
            that.getDataList(2,that.receivedDataList.length, 10, function (receivedDataList) {
                that.receivedDataList = that.receivedDataList.concat(receivedDataList);
                that.showReceivedList(receivedDataList);
                that.listReceivedScroll.setMoreRecord(receivedDataList.length == 10 ? true : false);
                that.listReceivedScroll.pullback();
            }, function () {
                that.listReceivedScroll.setMoreRecord(true);
                that.listReceivedScroll.pullback();
            });
        },

        //加载作业列表
        loadHomework: function () {
            // 判断课本表是否初始化
            var checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_homework'";
            console.log(checkInitSql);
            db.fetchAll(checkInitSql, function (ret) {
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            userId: that.loginUser.UserId,
                            status: 0,
                            videoName:"",
                            lastTime: ""
                        },
                        url: Util.getApiUrl("HomeworkList")
                    }, function (data) {
                        //  清空列表                     
                        $("#mh_homework_list_item").html("");

                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = data.slice(0, 10);
                            that.homeworkDataList = dataList;
                            // 显示数据
                            that.showHomeworkList(dataList);

                            that.listHomeworkScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.listHomeworkScroll.pullback();

                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                               var it = data[i];
                                var sql = "insert into t_homework(HomeworkId,VideoId,VideoName,CreateTimeStr,HomeworkStatus,CustomType)" +
                                  " values (" + it.HomeworkId + ","
                                  + it.VideoId + ",'"
                                  + it.VideoName + "','"
                                  + it.CreateTimeStr + "',"
                                  + it.HomeworkStatus + ","
                                  + it.CustomType + ")";
                                db.query(sql);
                              
                            }
                            // 保存最后更新时间
                            sql = "insert into t_manage(tbl_nm,last_update_time) values('t_homework','" + data[0].UpdateTimeStr + "')";
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.homeworkDataList = [];
                        }
                    });
                } else {// 已经初始化 
                    // 取出本地数据
                    that.getDataList(3, 0, 10, function (dataList) {
                        //  清空列表                       
                        $("#mh_homework_list_item").html("");

                        that.homeworkDataList = dataList;
                        // 显示数据
                        that.showHomeworkList(dataList);

                        // 设置scroller
                        that.listHomeworkScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listHomeworkScroll.pullback();

                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                userId: that.loginUser.UserId,
                                status: 0,
                                videoName: "",
                                lastTime: ret[0].last_update_time
                            },
                            url: Util.getApiUrl("HomeworkList")
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    (function (it) {
                                        //验证数据是否已存在
                                        var checkSql = "select count(*) as ct from t_homework where HomeworkId = " + it.HomeworkId;
                                        db.fetchAll(checkSql, function (ret) {
                                            if (ret[0].ct <= 0) {
                                                // 新增
                                                if (!it.IsDeleted) {
                                                    var sql = "insert into t_homework(HomeworkId,VideoId,VideoName,CreateTimeStr,HomeworkStatus,CustomType)" +
                                                           " values (" + it.HomeworkId + ","
                                                           + it.VideoId + ",'"
                                                           + it.VideoName + "','"
                                                           + it.CreateTimeStr + "',"
                                                           + it.HomeworkStatus + ","
                                                           + it.CustomType + ")";
                                                    db.query(sql);
                                                }
                                            }
                                            else {
                                                //  删除
                                                if (it.IsDeleted) {
                                                    var delsql = "delete from t_homework where HomeworkId=" + it.HomeworkId;
                                                    db.query(delsql);
                                                } else {
                                                    // 更新 
                                                    var updatesql = "update t_homework set HomeworkStatus = " + it.HomeworkStatus
                                                                + ",UploadTime = '" + it.UpdateTimeStr
                                                                + "' where HomeworkId = " + it.HomeworkId;
                                                    db.query(updatesql);
                                                }
                                            }
                                        });

                                    })(data[i]);
                                }

                                // 保存最后更新时间
                                var sql = "update t_manage set last_update_time = '" + data[0].UpdateTimeStr + "' where tbl_nm = 't_homework'";
                                db.query(sql);
                            }
                        });
                    }, function () {
                        // 设置scroller
                        that.listHomeworkScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listHomeworkScroll.pullback();
                    });
                }
            });
        },

        // 加载更多
        loadHomeworkMore: function () {
            if (that.homeworkDataList.length < 10) { return; }
            that.getDataList(3, that.homeworkDataList.length, 10, function (homeworkDataList) {
                that.homeworkDataList = that.homeworkDataList.concat(homeworkDataList);
                that.showHomeworkList(homeworkDataList);
                that.listHomeworkScroll.setMoreRecord(homeworkDataList.length == 10 ? true : false);
                that.listHomeworkScroll.pullback();
            }, function () {
                that.listHomeworkScroll.setMoreRecord(true);
                that.listHomeworkScroll.pullback();
            });
        },

        //收到的作业列表
        showReceivedList: function (dataList) {
            for (var i = 0; i < dataList.length; i++) {
                var html = "<div class='mh_receive_list_item'>";
                html += "<div class='mh_receive_new_message' id='mh_" + dataList[i].PublishId + "'>";
                if (dataList[i].Status == 0)
                {
                    html += "<div class='mh_receive_new_message_div'>";
                    html += "<img src='images/homework/homework_new.png'/>";
                    html += "</div>";
                }
                html += "</div>";
                html += "<div class='mh_receive_content'>";
                html += "<div class='mh_receive_lable'>你收到一条新作业啦！</div>";
                html += "<div class='mh_receive_video_name'>作业：" + dataList[i].VideoName + "</div>";
                html += "<div class='mh_receive_time_div'>";
                html += "<div class='mh_receive_time'>" + dataList[i].CreateTimeStr+ "</div>";
                html += "<div class='mh_receive_teacher'>来自" + dataList[i].RealName+ "</div>";
                html += "</div>";
                html += "</div>";
                html += "<div class='mh_receive_button_div'>";
                html += "<div class='mh_receive_button mh_receive_button_click' data='" + dataList[i].PublishId + "*" + dataList[i].VideoId + "*" + dataList[i].CustomType + "*" + dataList[i].VideoName + "' >观看视频</div>";
                html += "<div class='mh_receive_button mh_receive_button_showPop_click' style='margin-top:10px;' data='" + dataList[i].PublishId + "' >上传作业</div>";
                html += "</div>";
                html += "</div>";
                $("#mh_receive_list_item").append(html);
            }
            if(dataList.length>0){
                CommonClickEvent(".mh_receive_button_click", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            var strs = new Array();
                            strs = data.split("*");
                            that.toPageVideo(parseInt(strs[0]), parseInt(strs[1]), parseInt(strs[2]), strs[3]);
                        }
                    }

                });
                CommonClickEvent(".mh_receive_button_showPop_click", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            that.showPop(parseInt(data));
                        }
                    }
                });
            }
          
        },        

        //作业列表
        showHomeworkList: function (dataList) {
            var isUnRenderingCount = 0;
            var isRenderingCount = 0;
            for (var i = 0; i < dataList.length; i++) {
                var html = "<div class='mh_homework_list_item'>";
                html += " <div class='mh_hl_first_div'>";
                html += "<div class='mh_hl_name'>" + dataList[i].VideoName + "</div>";
                html += " <div class='mh_hl_time'>" + dataList[i].CreateTimeStr + "</div>";
                html += "</div>";
                html += " <div class='mh_hl_second_div'>";
                if (dataList[i].HomeworkStatus == enumKey.HomeworkStatus.UnRendering) {
                    ++isUnRenderingCount;
                    html += " <div class='mh_click_unRendering' data='" + dataList[i].HomeworkId + "' >未批改<img src='images/homework/homework_look.png'/></div>";
                }
                else if (dataList[i].HomeworkStatus == enumKey.HomeworkStatus.Rendering) {
                    ++isRenderingCount;
                    html += " <div class='mh_click_rendering' data='" + dataList[i].HomeworkId + "*" + dataList[i].CustomType + "' >已批改<img src='images/homework/homework_look.png'/></div>";
                }
                html += " </div>";
                $("#mh_homework_list_item").append(html);
            }
            if (isUnRenderingCount>0) {
                CommonClickEvent(".mh_click_unRendering", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            that.sendMessageToTeacher(parseInt(data));
                        }
                    }
                });
            }
            if (isRenderingCount>0) {
                CommonClickEvent(".mh_click_rendering", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            var strs = new Array();
                            strs = data.split("*");
                            that.toPageCorrected(parseInt(strs[0]), parseInt(strs[1]));
                        }
                    }
                });
            }
        },       

        //获取数据一览
        getDataList: function (index, pageIndex, pageCount, callback, errCallback) {                     
            var getDataSql = "";
          
            if (index == 2)//收到的作业
            {
                getDataSql = "select PublishId,VideoId,VideoName,RealName,CreateTimeStr,Status,CustomType from t_publish order by CreateTimeStr desc,PublishId desc limit " + pageIndex + "," + pageCount;
            }
            else if (index == 3)//作业列表
            {
                getDataSql = "select HomeworkId,VideoId,VideoName,CreateTimeStr,HomeworkStatus,CustomType from t_homework order by CreateTimeStr desc,HomeworkId desc limit " + pageIndex + "," + pageCount;
            }

            // 取出本地数据

            db.fetchAll(getDataSql, function (ret_1) {
                if (typeof callback == 'function') {
                    callback(ret_1);
                }
            }, function () {
                errCallback();
            });
        },

        //跳转到播放视频画面
        toPageVideo: function (publishId, videoId, type, videoName) {
            //更新已读状态
            that.changeReadStatus(publishId);
            //var videoInfo = JSON.stringify({ BookId: 0, BookType: 0, VideoId: videoId, VideoName: videoName });
            //lookVideo(videoId, function (res) {
            //    if (!res) { return; }
            //    //乐器类
            //    if (type == 1) {
            //        lookVideo(videoId, function (result) {
            //            if (result) {
            //                Cache.setCache("MusicVideoDetail_videoInfo", videoInfo);
            //                toPage("pnl_musicVideoDetail");
            //            }
            //        });
            //    }
            //    //舞蹈类
            //    if (type == 2) {
            //        lookVideo(videoId, function (result) {
            //            if (result) {
            //                Cache.setCache("DanceVideoDetail_videoInfo", videoInfo);
            //                toPage("pnl_danceVideoDetail");
            //            }
            //        });
            //    }
            //});

            // fixed by lyl 2016-12-22 记录作业路径 start
            var getDataSql = "select VideoId,VideoName,BookId,BookName,BookType from t_publish where PublishId =" + publishId;
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                var videoInfo = JSON.stringify({
                    BookId: ret[0].BookId,
                    BookName: ret[0].BookName,
                    BookType: ret[0].BookType,
                    VideoId: videoId,
                    VideoName: videoName
                });
                lookVideo(videoId, function (res) {
                    if (!res) { return; }
                    //乐器类
                    if (type == 1) {
                        lookVideo(videoId, function (result) {
                            if (result) {
                                debugger;
                                Cache.setCache("MusicVideoDetail_videoInfo", videoInfo);
                                toPage("pnl_musicVideoDetail");
                            }
                        });
                    }
                    //舞蹈类
                    if (type == 2) {
                        lookVideo(videoId, function (result) {
                            if (result) {
                                Cache.setCache("DanceVideoDetail_videoInfo", videoInfo);
                                toPage("pnl_danceVideoDetail");
                            }
                        });
                    }
                });
            }, function () {
            });
            // fixed by lyl 2016-12-22 记录作业路径 end
        },

        //查看已批改好的作业页面
        toPageCorrected: function (homeworkId, type) {
            Cache.setCache("HomeworkDetail_HomeworkId", homeworkId);
            //1.乐器 2舞蹈
            if (type == 1) {
                toPage("pnl_homeworkDetail");
            }
            else {
                toPage("pnl_homeworkDetailDance");
            }          
        },

        //弹出选择框
        showPop: function (publishId) {
            if (publishId > 0) {
                that.changeReadStatus(publishId);
                debugger;
                // fixed by lujf 2016-11-24 记录上传作业路径 start
                var getDataSql = "select VideoId,VideoName,BookId,BookName,BookType from t_publish where PublishId =" + publishId;
                // 取出本地数据
                db.fetchAll(getDataSql, function (ret) {
                    var videoInfo = {
                        BookId: ret[0].BookId,
                        BookName: ret[0].BookName,
                        BookType: ret[0].BookType,
                        VideoId: ret[0].VideoId,
                        VideoName: ret[0].VideoName
                    };
                    showHomeworkPop(videoInfo, function () { });
                }, function () {
                });
                // fixed by lujf 2016-11-24 记录上传作业路径 end
            }
            else {
                showHomeworkPop(null, function () { });
            }
            
        },

        changeReadStatus: function (publishId) {
            $("#mh_" + publishId).hide();
            //更新已读状态
            var updateSql = "update t_publish set status=1 where PublishId = " + publishId;
            db.query(updateSql);
        },

        sendMessageToTeacher: function (homeworkId) {
            //提醒老师
            Util.popConfirm("确认", "将向老师发送批改提醒", function (result) {
                if (result) {
                    Util.ajax({
                        method: "POST",
                        data: {
                            userId: Cache.getCache("LoginUserInfo").UserId,
                            userName: Cache.getCache("LoginUserInfo").RealName,
                            teacherId: 0,
                            homeworkId: homeworkId
                        },
                        url: Util.getApiUrl("AddHomeworkRemindMessage")
                    }, function (data) {
                        Util.info("已发送提醒", true);

                    });
                }
            }, false);
        },
    };
    return new obj();
})();





