﻿var UploadHomeworkCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.bookList = [];
            that.videoList = [];
            that.typeName = "";
            that.bookName = "";
            that.videoName = "";
            $("#uh_title").html("请选择。。。");//清空上传作业的题目  byzhusj 2016/12/12

            that.loginUser = Cache.getCache("LoginUserInfo");
            //fixedStart liyl 2017/1/11 拼接机构字符串
            that.orgIdStr = "";
            for (var i = 0; i < that.loginUser.OrganizationList.length; i++) {
                that.orgIdStr += that.loginUser.OrganizationList[i].OrgId + ",";
            }
            if (that.orgIdStr != "") {
                that.orgIdStr = that.orgIdStr.substring(0, (that.orgIdStr.length - 1));
            }
            //fixedEnd

            $("#uh_bookList_panel").height(window.innerHeight - $("#uh_bookList_panel").offset().top);
            $("#uh_videoList_panel").height(window.innerHeight - $("#uh_videoList_panel").offset().top);
            $("#uh_typeList_panel").height(window.innerHeight - $("#uh_typeList_panel").offset().top);
            that.fileName = Cache.getCache("UploadHomework_key");

            // 初始化类别Scroller
            that.listTypeScroll = new devAfScroller("uh_typeList_panel", {
                refresh: false
            });

            // 初始化教材Scroller
            that.listScroll = new devAfScroller("uh_bookList_panel", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });

            // 初始化Scroller
            that.listVideoScroll = new devAfScroller("uh_videoList_panel", {
                refreshFunc: that.loadVideoList,
                loadMoreFunc: that.loadVideoMore
            });

            $("#uh_first_div").hide();
            $("#uh_second_div").hide();
            $("#uh_bookList").hide();
            $("#uh_videoList").hide();
            //是否可以提交按钮
            that.isCanClick = true;
            CommonClickEvent(".uh_studentlist_click_first", function (isClick, data) {
                if (isClick) {
                    if (data != "") {
                        var strs = new Array();
                        strs = data.split("*");
                        that.chooseType(parseInt(strs[0]), strs[1]);
                    }
                }
            });

          

            // add by lujf 2016-11-23
            var videoInfo = Cache.getCache("UploadHomework_videoInfo");
            if (videoInfo) {
                that.videoInfo = JSON.parse(videoInfo);
                // 清空参数
                Cache.clearCache("UploadHomework_videoInfo");
                // 获取页面数据
                var typeName = "";
                switch (that.videoInfo.BookType + "") {
                    case "101":
                        typeName = "钢琴";
                        break;
                    case "102":
                        typeName = "体育舞蹈";
                        break;
                    case "103":
                        typeName = "架子鼓";
                        break;
                    case "104":
                        typeName = "笛子";
                        break;
                    case "105":
                        typeName = "吉他";
                        break;
                    case "106":
                        typeName = "古筝";
                        break;
                    case "107":
                        typeName = "琵琶";
                        break;
                    case "108":
                        typeName = "小提琴";
                        break;
                    case "109":
                        typeName = "竹笛";
                        break;
                    case "110":
                        typeName = "萨克斯";
                        break;
                    case "111":
                        typeName = "芭蕾";
                        break;
                    case "112":
                        typeName = "中国舞";
                        break;
                    case "113":
                        typeName = "软开度练习";
                        break;
                    case "114":
                        typeName = "国标舞";
                        break;
                    case "115":
                        typeName = "内部教材";
                        break;
                }
                // 选择类型
                that.chooseType(that.videoInfo.BookType, typeName);
                //选择教材
                that.chooseBook(that.videoInfo.BookId, that.videoInfo.BookName);
                //选择曲目
                that.chooseVideo(that.videoInfo.VideoId, that.videoInfo.VideoName);
            }

           
        },

        //选择类型
        chooseType: function (index, typeName) {
            that.learningType = index;
            that.loadList();
            that.typeName = typeName;
            $("#uh_first_div").show();
            $("#uh_bookList").show();
            $("#uh_title").html(that.typeName + (that.bookName == "" ? that.bookName : "-" + that.bookName) + (that.videoName == "" ? that.videoName : "-" + that.videoName));
        },

        //选择教材
        chooseBook: function (index,bookName) {
            that.bookId = index;
            that.loadVideoList();
            that.bookName = bookName;
            $("#uh_second_div").show();
            $("#uh_videoList").show();
            $("#uh_title").html(that.typeName + (that.bookName == "" ? that.bookName : "-" + that.bookName) + (that.videoName == "" ? that.videoName : "-" + that.videoName));
        },

        //选择曲目
        chooseVideo: function (index, videoName) {
            that.videoId = index;
            that.videoName = videoName;
            $("#uh_title").html(that.typeName + (that.bookName == "" ? that.bookName : "-" + that.bookName) + (that.videoName == "" ? that.videoName : "-" + that.videoName));
        },

        // 加载课程列表
        loadList: function () {
            // 判断课本表是否初始化
            var checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_book_" + that.learningType + "'";
            db.fetchAll(checkInitSql, function (ret) {
                var date = {
                    isInit: true,
                    bookType: that.learningType,
                    bookAttribute: 0,
                    orgIdStr: that.orgIdStr,
                    lastUpdateTime: "",
                    userType: 1
                };
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            isInit: true,
                            bookType: that.learningType,
                            bookAttribute: 0,
                            orgIdStr: that.orgIdStr,
                            lastUpdateTime: "",
                            userType: 1
                        },
                        url: Util.getApiUrl("NewBookList")
                    }, function (data) {
                        //  清空列表                       
                        $("#uh_bookList_panel_item").html("");

                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = data.slice(0, 15);
                            that.bookList = dataList;
                            // 显示数据
                            that.showData(dataList);
                            // 设置scroller                            
                            that.listScroll.setMoreRecord(dataList.length == 15 ? true : false);
                            that.listScroll.pullback();

                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                                var it = data[i];
                                var sql2 = "insert into t_book(BookId,BookName,BookType,BookAttribute,BookImgStr,IsVip,FirstShow,CustomType,ClickCount,OrgId,UpdateTime,CreateTime,IsInside)" +
                                " values (" + it.BookId + ",'"
                                + it.BookName + "',"
                                + it.BookType + ","
                                + it.BookAttribute + ",'"
                                + it.BookImgStr + "',"
                                + it.IsVip + ","
                                + it.FirstShow + ","
                                + it.CustomType + ","
                                + it.ClickCount + ","
                                + it.OrgId + ",'"
                                + it.UpdateTimeDateStr + "','"
                                + it.CreateTimeDateStr + "','"
                                   + (it.IsInside ? 1 : 0) + "')";
                                db.query(sql2);


                            }
                            // 保存最后更新时间
                            sql = "insert into t_manage(tbl_nm,last_update_time) values('t_book_" + that.learningType + "','" + data[0].LastUpdateTimeStr + "')";
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.bookList = [];
                        }
                    });
                } else {// 已经初始化 
                    //删除用户因修改机构绑定状态而多余的机构内部教材的数据
                    var orgdelsql = "delete from t_book where IsInside = 1 ";
                    if (that.loginUser.OrganizationList.length > 0) {
                        for (var i = 0; i < that.loginUser.OrganizationList.length; i++) {
                           orgdelsql += " and OrgId !=" + that.loginUser.OrganizationList[i].OrgId;
                        }
                    }
                    db.query(orgdelsql);
                    // 取出本地数据
                    that.getDataList(0, 15, function (dataList) {
                        //  清空列表                        
                        $("#uh_bookList_panel_item").html("");

                        that.bookList = dataList;
                        // 显示数据
                        that.showData(dataList);
                        // 设置scroller                        
                        that.listScroll.setMoreRecord(dataList.length == 15 ? true : false);
                        that.listScroll.pullback();

                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                isInit: false,
                                bookType: that.learningType,
                                bookAttribute: 0,
                                orgIdStr: that.orgIdStr,
                                lastUpdateTime: ret[0].last_update_time,
                                userType: 1
                            },
                            url: Util.getApiUrl("NewBookList")
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            var it;
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    it = data[i];
                                    //验证数据是否已存在

                                    var checkSql = "select count(*) as ct from t_book where BookId = " + it.BookId;
                                    db.fetchAll(checkSql, function (ret) {
                                        if (ret[0].ct > 0 ) {
                                            //  删除
                                            if (it.IsDeleted || it.IsDeletedOrg) {
                                                var delsql = "delete from t_book where BookId=" + it.BookId;
                                                db.query(delsql);
                                            } else {
                                                // 更新
                                                var updatesql = "update t_book set BookName = '" + it.BookName
                                                            + "',BookType = " + it.BookType
                                                            + ",BookAttribute = " + it.BookAttribute
                                                            + ",BookImgStr = '" + it.BookImgStr
                                                            + "',IsVip = " + it.IsVip
                                                            + ",FirstShow = " + it.FirstShow
                                                            + ",CustomType = " + it.CustomType
                                                            + ",ClickCount = " + it.ClickCount
                                                            + ",OrgId = " + it.OrgId
                                                            + ",UpdateTime = '" + it.UpdateTimeDateStr
                                                            + ",IsInside =" + (it.IsInside ? 1 : 0)
                                                            + "' where BookId = " + it.BookId;
                                                db.query(updatesql);
                                            }
                                        } else {
                                            // 新增
                                            if (!it.IsDeleted && !it.IsDeletedOrg) {
                                                var insertsql = "insert into t_book(BookId,BookName,BookType,BookAttribute,BookImgStr,IsVip,FirstShow,CustomType,ClickCount,OrgId,UpdateTime,CreateTime,IsInside)" +
                                                    " values (" + it.BookId + ",'"
                                                    + it.BookName + "',"
                                                    + it.BookType + ","
                                                    + it.BookAttribute + ",'"
                                                    + it.BookImgStr + "',"
                                                    + it.IsVip + ","
                                                    + it.FirstShow + ","
                                                    + it.CustomType + ","
                                                    + it.ClickCount + ","
                                                    + it.OrgId + ",'"
                                                    + it.UpdateTimeDateStr + "','"
                                                    + it.CreateTimeDateStr + "','"
                                                    + (it.IsInside ? 1 : 0) + "')";
                                                db.query(insertsql);
                                            }
                                        }
                                    });


                                }

                                // 保存最后更新时间
                                var sql = "update t_manage set last_update_time = '" + data[0].LastUpdateTimeStr + "' where tbl_nm = 't_book_" + that.learningType + "'";
                                db.query(sql);
                            }
                        });
                    }, function () {
                        that.listScroll.setMoreRecord(true);
                        that.listScroll.pullback();
                    });
                }
            });
        },

        // 加载更多
        loadMore: function () {
            // 取出本地数据
            that.getDataList(that.bookList.length, 15, function (dataList) {
                that.bookList = that.bookList.concat(dataList);
                that.showData(dataList);
                // 设置scroller               
                that.listScroll.setMoreRecord(dataList.length == 15 ? true : false);
                that.listScroll.pullback();

            }, function () {
                // 设置scroller                
                that.listScroll.setMoreRecord(true);
                that.listScroll.pullback();
            });
        },

        // 获取本地数据
        getDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "";
            if (that.learningType == 199) {// 内部教材
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount,IsInside from t_book where OrgId="
                    + 0 + " order by FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;// todo...
            }
            else {// 其他
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount,IsInside from t_book where BookType="
                    + that.learningType + " order by IsInside desc , FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;
            }
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret_1) {
                if (typeof callback == 'function') {
                    callback(ret_1);
                }
            }, function () {
                errCallback();
            });
        },

        // 显示数据
        showData: function (dataList) {
            var showStr = "";
            var imgHeight = window.innerWidth * 0.2 * 0.92;
            var bookImage = new Image();
            var imgBgSize;
            // 体育舞蹈            
            for (var k = 0; k < dataList.length; k++) {
                bookImage.src = dataList[k].BookImgStr;
                if (bookImage.width > bookImage.height) {
                    imgBgSize = "auto 100%";
                }
                else {
                    imgBgSize = "100%";
                }
                showStr += '<div class="uh_studentlist_template uh_studentlist_dance" data="' + dataList[k].BookId + '*' + dataList[k].BookName + '" >'
                        + '<div class="uh_studentlist_left">' + dataList[k].BookName + '</div>'
                        + '<div class="uh_studentlist_right">'
                        + '<img class="uh_goto_img" src="images/learn/goto.png" />'
                        + '</div>'
                        + '</div>';
            }
            $("#uh_bookList_panel_item").append(showStr);
            if (dataList.length > 0) {
                CommonClickEvent(".uh_studentlist_dance", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            var strs = new Array();
                            strs = data.split("*");
                            that.chooseBook(parseInt(strs[0]), strs[1]);
                        }
                    }
                });
            }
        },

        // 曲目刷新List
        loadVideoList: function () {
            // 判断视频表是否初始化
            var checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_video_" + that.bookId + "'";
            db.fetchAll(checkInitSql, function (ret) {
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            isInit: true,
                            bookId: that.bookId,
                            userId: 1,// todo..
                            lastUpdateTime: "",
                            videoType: 0,
                            userType: 1// todo..
                        },
                        url: Util.getApiUrl("VideoList")
                    }, function (data) {
                        //  清空列表
                        $("#uh_videoList_panel_item").html("");
                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = data.slice(0, 15);
                            that.videoList = dataList;
                            // 显示数据
                            that.showVideoData(dataList);
                            // 设置scroller
                            that.listVideoScroll.setMoreRecord(dataList.length == 15 ? true : false);
                            that.listVideoScroll.pullback();

                            // 将数据保存到本地数据库
                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                                var it = data[i];
                                var sql2 = "insert into t_video(VideoId,BookId,VideoName,VideoType,VideoImgStr,Gold,UploadGold,ClickCount,FirstShow,IsCollected,UpdateTime,CreateTime,IsShow)" +
                                   " values (" + it.VideoId + ","
                                   + it.BookId + ",'"
                                   + it.VideoName + "',"
                                   + it.VideoType + ",'"
                                   + it.VideoImgStr + "',"
                                   + it.Gold + ","
                                   + it.UploadGold + ","
                                   + it.ClickCount + ","
                                   + it.FirstShow + ","
                                   + (it.IsCollected ? 1 : 0) + ",'"
                                   + it.UpdateTimeDateStr + "','"
                                   + it.CreateTimeDateStr + "',"
                                   + (it.IsShow ? 1 : 0) + ")";
                                db.query(sql2);
                            }
                            // 保存最后更新时间
                            sql = "insert into t_manage(tbl_nm,last_update_time) values('t_video_" + that.bookId + "','" + data[0].LastUpdateTimeStr + "')";
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.videoList = [];
                        }
                    });
                }
                else {// 已经初始化
                    that.getVideoDataList(0, 15, function (dataList) {
                        //  清空列表
                        $("#uh_videoList_panel_item").html("");
                        that.videoList = dataList;
                        // 显示数据
                        that.showVideoData(dataList);
                        // 设置scroller
                        that.listVideoScroll.setMoreRecord(dataList.length == 15 ? true : false);
                        that.listVideoScroll.pullback();
                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                isInit: false,
                                bookId: that.bookId,
                                userId: 1,// todo..
                                lastUpdateTime: ret[0].last_update_time,
                                videoType: 0,
                                userType: 1// todo..
                            },
                            url: Util.getApiUrl("VideoList")
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            var it;
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    it = data[i];
                                    //验证数据是否已存在

                                    var checkSql = "select count(*) as ct from t_video where VideoId = " + it.VideoId;
                                    db.fetchAll(checkSql, function (ret) {
                                        if (ret[0].ct > 0) {
                                            //  删除
                                            if (it.IsDeleted || it.VideoStatus == enumKey.VideoStatus.OffSale) {
                                                var delsql = "delete from t_video where VideoId=" + it.VideoId;
                                                db.query(delsql);
                                            } else {
                                                // 更新
                                                var updatesql = "update t_video set BookId = " + it.BookId
                                                            + ",VideoName = '" + it.VideoName
                                                            + "',VideoType = " + it.VideoType
                                                            + ",VideoImgStr = '" + it.VideoImgStr
                                                            + "',Gold = " + it.Gold
                                                            + ",UploadGold = " + it.UploadGold
                                                            + ",ClickCount = " + it.ClickCount
                                                            + ",FirstShow = " + it.FirstShow
                                                            + ",IsCollected = " + (it.IsCollected ? 1 : 0)
                                                            + ",UpdateTime = '" + it.UpdateTimeDateStr
                                                            + "',IsShow = " + (it.IsShow ? 1 : 0)
                                                            + " where VideoId = " + it.VideoId;
                                                db.query(updatesql);
                                            }
                                        } else {
                                            // 新增
                                            if (it.IsDeleted == false && it.VideoStatus == enumKey.VideoStatus.OnSale) {
                                                var insertsql = "insert into t_video(VideoId,BookId,VideoName,VideoType,VideoImgStr,Gold,UploadGold,ClickCount,FirstShow,IsCollected,UpdateTime,CreateTime,IsShow)" +
                                                    " values (" + it.VideoId + ","
                                                    + it.BookId + ",'"
                                                    + it.VideoName + "',"
                                                    + it.VideoType + ",'"
                                                    + it.VideoImgStr + "',"
                                                    + it.Gold + ","
                                                    + it.UploadGold + ","
                                                    + it.ClickCount + ","
                                                    + it.FirstShow + ","
                                                    + (it.IsCollected ? 1 : 0) + ",'"
                                                    + it.UpdateTimeDateStr + "','"
                                                    + it.CreateTimeDateStr + + "',"
                                                    + (it.IsShow ? 1 : 0) + ")";
                                                db.query(insertsql);
                                            }
                                        }
                                    });


                                }

                                // 保存最后更新时间
                                var sql = "update t_manage set last_update_time = '" + data[0].LastUpdateTimeStr + "' where tbl_nm = 't_video_" + that.bookId + "'";
                                db.query(sql);
                            }
                        });
                    }, function () {
                        // 设置scroller
                        that.listVideoScroll.setMoreRecord(true);
                        that.listVideoScroll.pullback();
                    });
                }
            });
        },

        // 加载更多
        loadVideoMore: function () {
            // 取出本地数据
            that.getVideoDataList(that.videoList.length, 15, function (dataList) {
                that.videoList = that.videoList.concat(dataList);
                that.showVideoData(dataList);
                // 设置scroller
                that.listVideoScroll.setMoreRecord(dataList.length == 15 ? true : false);
                that.listVideoScroll.pullback();
            }, function () {
                // 设置scroller
                that.listVideoScroll.setMoreRecord(true);
                that.listVideoScroll.pullback();
            });
        },

        // 显示数据
        showVideoData: function (dataList) {
            var showStr = "";
            var item;
            for (var i = 0; i < dataList.length; i++) {
                item = dataList[i];

                showStr += '<div class="uh_studentlist_template uh_studentlist_click_video" data="' + dataList[i].VideoId + '*' + dataList[i].VideoName + '" >'
                         + '<div class="uh_studentlist_left">' + dataList[i].VideoName + '</div>'
                         + '<div class="uh_studentlist_right">'
                         + '<img class="uh_goto_img" src="images/learn/goto.png" />'
                         + '</div>'
                         + '</div>'
            }
            $("#uh_videoList_panel_item").append(showStr);
            if (dataList.length > 0) {
                CommonClickEvent(".uh_studentlist_click_video", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            var strs = new Array();
                            strs = data.split("*");
                            that.chooseVideo(parseInt(strs[0]), strs[1]);
                        }
                    }
                });
            }
        },

        // 获取数据
        getVideoDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "select VideoId,VideoName,IsCollected,VideoType from t_video where BookId=" + that.bookId
                + " order by FirstShow,  UpdateTime desc limit " + pageIndex + "," + pageCount;
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                if (typeof callback == 'function') {
                    callback(ret);
                }
            }, function () {
                errCallback();
            });
        },

        //返回上一级
        hideDiv: function (index) {
            //1表示返回到类别列表，2，表示返回到教材列表
            if (index == 1) {
                $("#uh_first_div").hide();
                $("#uh_second_div").hide();
                $("#uh_bookList").hide();
                $("#uh_videoList").hide();
                that.bookName = "";
                $("#uh_bookList_panel_item").html("");
            }
            if (index == 2) {
                $("#uh_second_div").hide();
                $("#uh_videoList").hide();
                that.videoName = "";
                $("#uh_videoList_panel_item").html("");
            }
            $("#uh_title").html(that.typeName + (that.bookName == "" ? that.bookName : "-" + that.bookName) + (that.videoName == "" ? that.videoName : "-" + that.videoName));
        },

        //上传作业
        uploadVideo: function () {
            if (that.typeName == "") {
                Util.info("请选择要上传视频的类别");
                return;
            }
            if (that.bookName == "") {
                Util.info("请选择要上传视频的教材");
                return;
            }
            if (that.videoName == "") {
                Util.info("请选择要上传视频的曲目");
                return;
            }

            //定义内容           
            if (that.isCanClick) {
                that.isCanClick = false;
                Util.ajaxL({
                    method: "POST",
                    data: {
                        userId: that.loginUser.UserId,
                        type: that.learningType,
                        videoId: that.videoId
                    },
                    url: Util.getApiUrl("GetHomeworkCount")
                }, function (resultData) {
                    if (resultData.TeacherId == 0) {
                        Util.info("您还没有绑定老师，请先绑定老师");
                        return;
                    }
                    else {
                        that.teacherId = resultData.TeacherId;
                        that.homeworkCount = resultData.HomeworkCount;
                        that.homework = {
                            "UserId": that.loginUser.UserId,
                            "BookType": that.learningType,
                            "TeacherId": that.teacherId,
                            "VideoId": that.videoId,
                            "VideoUrl": that.fileName,
                            "HomeworkCount": that.homeworkCount
                        }

                        if (resultData.HomeworkCount > 0) {
                            that.uploadHomeworkClick();
                        }
                        else {
                            Util.popConfirm("提示", "需要花费" + resultData.Gold + "金币上传作业吗？",
                                 function (result) {//确定回调
                                     if (result) {
                                         that.uploadHomeworkClick()
                                     } else {
                                         that.isCanClick = true;
                                     }
                                 }, false);
                        }
                    }
                }, function () {
                    that.isCanClick = true;
                    Util.info("您的网络有问题哦~", false);
                }
                );
            }
        },

        uploadHomeworkClick: function () {
            Util.ajax({
                method: "POST",
                data: {
                    homeworkStr: JSON.stringify(that.homework)
                },
                url: Util.getApiUrl("UploadHomework")
            }, function (data) {
                that.isCanClick = true;
                if (data.ResponseCode == 1) {
                    Util.showAppLoading();
                    //$("#uh_title").html("请选择。。。");//清空上传作业的题目  byzhusj 2016/12/12
                    setTimeout(function () {
                        Util.hideAppLoading();
                        Util.info(data.ResponseMessage, true);
                        $.ui.goBack();
                    }, 3000)                    
                    
                }
                else {
                    Util.info(data.ResponseMessage, false);
                }
            }, function () {
                that.isCanClick = true;
                Util.info("您的网络有问题哦~", false);
            });

        },
    };
    return new obj();
})();