﻿var CorrectMusicCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.playImgSrc = "images/homeworkTe/play.png";
            that.pauseImgSrc = "images/homeworkTe/pause.png";
            that.fullscreenImgSrc = "images/homeworkTe/fullscreen.png";
            that.cancelFullscreenImgSrc = "images/homeworkTe/cancelFullscreen.png";
            that.loginInfo = Cache.getCache("LoginUserInfo");
            that.homeworkId = Cache.getCache("Correct_HomeworkId");
            that.correntList = [];
            that.init();
        },

        //返回
        goBack: function () {
            // add by lujf 2016-12-2 改用自定义的控制条 start
            $("canvas").show();
            $("div[id^='$']").show();
            $("#cm_homework_staff").show();
            // add by lujf 2016-12-2 改用自定义的控制条 end
            if (typeof (that.h) != "undefined") {
                that.h.remove();
                that.h.stopPlay();//fixedby lijq 2016/11/11
            }
            $("#zebra.fm").hide();
            that.saveToLocal();
            // add by lujf 2016-12-2 改用自定义的控制条 start
            // 将video 控制条还原
            that.refreshControls(function () { $.ui.goBack(); });
            // add by lujf 2016-12-2 改用自定义的控制条 end
            //videoPageBack("cm_videoshow");
        },

        //初始化
        init: function () {
            //fixed by lijq 2016/12/14  手动写谱子div 的大小
            $("#cm_homework_staff").height(window.innerHeight * 0.75);
            $("#cm_homework_staff").width(window.innerWidth);

            // add by lujf 2016-12-2 自定义video控制条 start
            that.timeDrag = false;
            that.isFullScreen = false;
            $(".cm_play_btn img").attr("src", that.pauseImgSrc);
            // 初始化video控制条
            that.video = $('#cm_videoshow');
            that.video[0].controls = false;
            //if (Util.getSystemType() != "IOS") {
            //    // 监听video点击事件
            //    that.video.on('click', function () {
            //        if (that.invokeFieldOrMethod(document, 'FullScreen') || that.invokeFieldOrMethod(document, 'IsFullScreen') || document.IsFullScreen) {
            //            that.video[0].controls = true;
            //            $('.cm_play_btn').click();
            //        }
            //    });

            //    // 监听全屏变更事件
            //    document.addEventListener("fullscreenchange", function (e) {
            //        that.hideControl();
            //    });
            //    document.addEventListener("mozfullscreenchange", function (e) {
            //        that.hideControl();
            //    });
            //    document.addEventListener("webkitfullscreenchange", function (e) {
            //        that.hideControl();
            //    });
            //    document.addEventListener("msfullscreenchange", function (e) {
            //        that.hideControl();
            //    });
            //}
            
            // 监听播放/暂停点击事件
            if (!that.checkBindEnvent($('.cm_play_btn'), 'click')) {
                $('.cm_play_btn').on('click', function () {
                    if (that.video[0].paused) {
                        $(".cm_play_btn img").attr("src", that.pauseImgSrc);
                        that.video[0].play();
                    }
                    else {
                        $(".cm_play_btn img").attr("src", that.playImgSrc);
                        that.video[0].pause();
                    }
                });
            }

            //get HTML5 video time duration 获取video的总时间
            if (!that.checkBindEnvent(that.video, 'loadedmetadata')) {
                that.video.on('loadedmetadata', function () {
                    $('.cm_duration').text(Util.formatTimeSpan(that.video[0].duration));
                });
            }

            //update HTML5 video current play time 获取video当前时间
            if (!that.checkBindEnvent(that.video, 'timeupdate')) {
                that.video.on('timeupdate', function () {
                    $('.cm_current').text(Util.formatTimeSpan(that.video[0].currentTime));
                    var currentPos = that.video[0].currentTime; //Get currenttime
                    var maxduration = that.video[0].duration; //Get video duration
                    var percentage = 100 * currentPos / maxduration; //in %
                    $('.cm_timeBar').css('width', percentage + '%');
                });
            }

            // 监听全屏事件
            if (!that.checkBindEnvent($('.cm_fullscreen_btn'), 'click')) {
                $('.cm_fullscreen_btn').on('click', function () {
                    //if (that.video[0].requestFullscreen) {
                    //    that.video[0].requestFullscreen();
                    //} else if (that.video[0].mozRequestFullScreen) {
                    //    that.video[0].mozRequestFullScreen();
                    //} else if (that.video[0].webkitRequestFullscreen) {
                    //    that.video[0].webkitRequestFullscreen();
                    //} else if (that.video[0].msRequestFullscreen) {
                    //    that.video[0].msRequestFullscreen();
                    //}
                    // 如果是全屏的状态
                    if (that.isFullScreen) {
                        $(".cm_fullscreen_btn img").attr("src", that.fullscreenImgSrc);
                        $(".cm_video_div").removeClass("cm_video_div_full");
                        $("#cm_videoshow").removeClass("cm_video_div_video_full");
                        $("canvas").show();
                        $("#cm_homework_staff").show();
                        setTimeout(function () {
                            $("div[id^='$']").show();
                        }, 400);
                        that.isFullScreen = false;
                    } else {// 如果是非全屏状态
                        $(".cm_fullscreen_btn img").attr("src", that.cancelFullscreenImgSrc);
                        $(".cm_video_div").addClass("cm_video_div_full");
                        $("#cm_videoshow").addClass("cm_video_div_video_full");
                        $("canvas").hide();
                        $("#cm_homework_staff").hide();
                        $("div[id^='$']").hide();
                        that.isFullScreen = true;
                    }
                });
            }

            if (!that.checkBindEnvent($('.cm_progressBar'), 'touchstart')) {
                $('.cm_progressBar').on('touchstart', function (e) {
                    that.timeDrag = true;
                    that.updateBar(e.touches[0].pageX);
                });
            }
            if (!that.checkBindEnvent($('.cm_progressBar'), 'touchend')) {
                $('.cm_progressBar').on('touchend', function (e) {
                    if (that.timeDrag) {
                        that.timeDrag = false;
                        //that.updateBar(e.touches[0].pageX);
                    }
                });
            }
            if (!that.checkBindEnvent($('.cm_progressBar'), 'touchmove')) {
                $('.cm_progressBar').on('touchmove', function (e) {
                    if (that.timeDrag) {
                        that.updateBar(e.touches[0].pageX);
                    }
                });
            }
            // add by lujf 2016-12-2 自定义video控制条 end
            Util.ajaxL({
                method: "POST",
                data: {
                    homeworkId: that.homeworkId
                },
                url: Util.getApiUrl("CorrectingHomeworkDetail")
            }, function (resultData) {
                that.maxCount = resultData.HomeStaffList.length;
                that.staffList = resultData.HomeStaffList;
                that.index = 1;
                debugger;
                //加载视频
                $("#cm_videoshow").attr("src", resultData.VideoUrlInfo);

                //若是没有谱子的情况
                if (that.maxCount >= 1) {
                    $("#cm_staff").attr('src', that.staffList[0].StaffImgUrl);
                }
                else {// fixedby lijq 2016/11/11 没有谱子的情况下置为空
                    $("#cm_staff").attr('src', '');
                }

                //批改作业
                zebra.ready(function () {
                    debugger;
                    that.h = new ZebDev.happymusic.homework(false, that.noti);
                    
                    onRecordPop = function () {
                        that.stopVideo();
                    };

                    if (that.maxCount > 1) {
                        //定义下一页按钮
                        //FixedStart liyl 2016/12/28  https的判断
                        var nextImg = "";
                        if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                            nextImg = "https://oivtg60a1.qnssl.com/next.png";
                        } else {
                            nextImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/next.png";
                        }
                        //FixedEnd
                        //定义下一页按钮
                        that.next = new ZebDev.imageButton.imageButton(window.innerWidth - 25, 200, 25, that.nextClick, nextImg).toZebraComp();
                        mainZebDevPanel.add(that.next);
                    }

                    //添加一个div
                    //var insertText = "<div id='zebraFix' class='x-contents-content x-content-on-left'></div>";
                    //$(insertText).appendTo("#__baseID___pages");
                });

                //本地数据库是否已经有相关的批改记录
                var checkInitSql = "select HomeworkId,CorrectContent from t_correct where HomeworkId =" + that.homeworkId;
                db.fetchAll(checkInitSql, function (ret) {
                    //没有数据 初始化数据
                    if (ret.length == 0) {                       
                        //定义数组
                        for (var i = 0; i < that.maxCount; i++) {
                            that.correntList[i] = "";
                        }
                    }
                    else {//已经有数据
                        that.correntList = JSON.parse(ret[0].CorrectContent);
                        if (that.correntList != null) {
                            if (that.h && that.correntList[that.index - 1]) {
                                that.h.reducteCompList(that.correntList[that.index - 1]);
                            }
                        }
                    }
                });                             

            }, function () {

            });

        },

        // 隐藏控制条
        //hideControl:function(){
        //    if (that.invokeFieldOrMethod(document, 'FullScreen') || that.invokeFieldOrMethod(document, 'IsFullScreen') || document.IsFullScreen) {
        //    }
        //    else {
        //        that.video[0].controls = false;
        //    }
        //},

        ////反射調用
        //invokeFieldOrMethod : function(element, method) 
        //{
        //    var usablePrefixMethod;
        //    ["webkit", "moz", "ms", "o", ""].forEach(function(prefix) {
        //        if (usablePrefixMethod) return;
        //        if (prefix === "") {
        //            // 无前缀，方法首字母小写
        //            method = method.slice(0,1).toLowerCase() + method.slice(1); 
        //        }
        //        var typePrefixMethod = typeof element[prefix + method];
        //        if (typePrefixMethod + "" !== "undefined") {
        //            if (typePrefixMethod === "function") {
        //                usablePrefixMethod = element[prefix + method]();
        //            } else {
        //                usablePrefixMethod = element[prefix + method];
        //            }
        //        }
        //    });
        //    return usablePrefixMethod;
        //},

        // check 某个元素是否绑定了某个事件
        checkBindEnvent: function (selector, eventName) {
            //jQuery event封装支持判断元素上是否绑定了事件，此方法只适用于jQuery绑定的事件
            var $events = $._data(selector[0], "events");
            if ($events && $events[eventName]) {
                return true;
            }
            return false;
        },

        //update Progress Bar control 跟新进度条 add by lujf 2016-12-7
        updateBar:function(x) {
            var progress = $('.cm_progressBar');
            var maxduration = that.video[0].duration; //Video duraiton
            var position = x - progress.offset().left; //Click pos
            var percentage = 100 * position / progress.width();
 
            //Check within range
            if(percentage > 100) {
                percentage = 100;
            }
            if(percentage < 0) {
                percentage = 0;
            }
 
            //Update progress bar and video currenttime
            $('.cm_timeBar').css('width', percentage + '%');
            that.video[0].currentTime = maxduration * percentage / 100;
        },

        // 还原初始状态 add by lujf 2016-12-2
        refreshControls: function (callback) {
            // 将video 控制条还原
            that.video[0].pause();
            $(".cm_play_btn img").attr("src", that.playImgSrc);
            $('.cm_timeBar').css('width', '0px');
            $('.cm_duration').text("00:00");
            $('.cm_current').text("00:00");
            $(".cm_fullscreen_btn img").attr("src", that.fullscreenImgSrc);
            $(".cm_video_div").removeClass("cm_video_div_full");
            $("#cm_videoshow").removeClass("cm_video_div_video_full");
            callback();
        },

        //弹出信息
        noti: function (msg) {
            Util.info(msg);
        },

        //清空
        clean: function () {
            if (that.h) {
                that.h.clearCanvas();
            }
        },

        //上一页
        preClick: function () {
            that.correntList[that.index - 1] = that.h.getZebraCompList();

            that.clean();

            if (that.index > 1) {
                that.index -= 1;

                //定义下一页按钮
                //FixedStart liyl 2016/12/28  https的判断
                var nextImg = "";
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    nextImg = "https://oivtg60a1.qnssl.com/next.png";
                } else {
                    nextImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/next.png";
                }
                //FixedEnd
                that.next = new ZebDev.imageButton.imageButton(window.innerWidth - 25, 200, 25, that.nextClick, nextImg).toZebraComp();
                mainZebDevPanel.add(that.next);

                $("#next").css({ "display": "block" });
                $("#cm_staff").attr('src', that.staffList[that.index - 1].StaffImgUrl);
                if (that.index != 1) {
                    //FixedStart liyl 2016/12/28  https的判断
                    var preImg = "";
                    if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                        preImg = "https://oivtg60a1.qnssl.com/pre.png";
                    } else {
                        preImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/pre.png";
                    }
                    //FixedEnd
                    that.pre = new ZebDev.imageButton.imageButton(0, 200, 25, that.preClick, preImg).toZebraComp();
                    mainZebDevPanel.add(that.pre);
                }
            }
            if (that.h && that.correntList[that.index - 1]) {
                that.h.reducteCompList(that.correntList[that.index - 1]);
            }
        },

        //下一页
        nextClick: function () {
            that.correntList[that.index - 1] = that.h.getZebraCompList();
            that.index += 1;

            that.clean();

            //定义上一页按钮和下一页按钮
            //FixedStart liyl 2016/12/28  https的判断
            var preImg = "";
            if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                preImg = "https://oivtg60a1.qnssl.com/pre.png";
            } else {
                preImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/pre.png";
            }
            //FixedEnd
            that.pre = new ZebDev.imageButton.imageButton(0, 200, 25, that.preClick, preImg).toZebraComp();
            mainZebDevPanel.add(that.pre);

            if (that.index < that.maxCount) {
                //定义上一页按钮和下一页按钮	
                //FixedStart liyl 2016/12/28  https的判断
                var nextImg = "";
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    nextImg = "https://oivtg60a1.qnssl.com/next.png";
                } else {
                    nextImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/next.png";
                }
                //FixedEnd
                that.next = new ZebDev.imageButton.imageButton(window.innerWidth - 25, 200, 25, that.nextClick, nextImg).toZebraComp();
                mainZebDevPanel.add(that.next);

                $("#cm_staff").attr('src', that.staffList[that.index - 1].StaffImgUrl);
            } else if (that.index == that.maxCount) {
                $("#cm_staff").attr('src', that.staffList[that.index - 1].StaffImgUrl);
            }

            if (that.h && that.correntList[that.index - 1]) {
                that.h.reducteCompList(that.correntList[that.index - 1]);
            }
        },

        //暂停播放视频
        stopVideo: function () {
            // fixed by lujf 2016-12-2 改用自定义的控制条 start
            //var myVideo = $("#cm_videoshow")[0];
            //myVideo.pause();
            $(".cm_play_btn img").attr("src", that.playImgSrc);
            that.video[0].pause();
            // fixed by lujf 2016-12-2 改用自定义的控制条 end
        },    

        //保存批改作业的内容
        saveBtnClick: function (event) {
            // add by lujf 2016-12-2 改用自定义的控制条 start
            $("canvas").show();
            $("#cm_homework_staff").show();
            $("div[id^='$']").show();
            $(".cm_fullscreen_btn img").attr("src", that.fullscreenImgSrc);
            $(".cm_video_div").removeClass("cm_video_div_full");
            $("#cm_videoshow").removeClass("cm_video_div_video_full");
            // add by lujf 2016-12-2 改用自定义的控制条 end
            that.correntList[that.index - 1] = that.h.getZebraCompList();
            // fixed by lujf 2016-11-25 判断是否批改 start
            var showMsgFlag = true;
            for (var i = 0; i < that.correntList.length; i++) {
                if (that.correntList[i] != "") {
                    showMsgFlag = false;
                }
            }
            if (showMsgFlag)
            {
                Util.info("您还未批改！");
                return;
            }
            // fixed by lujf 2016-11-25 判断是否批改 end
            else{
                that.saveToLocal();
                //暂停播放视频内容
                //$("#cm_videoshow")[0].pause();
                that.refreshControls(function () {
                    //移除canvers
                    if (typeof (that.h) != "undefined") {
                        that.h.remove();
                    }
                    $("#zebra.fm").hide();
                    setTimeout(function () {
                        Cache.setCache("HomeworkComment_type", 1);
                        toPage("pnl_homeworkComment");
                    }, 1000);
                });// 将控制条还原成初始状态 fixed by lujf 2016-12-2 改用自定义控制条    
            }
        },

        //保存数据到本地
        saveToLocal: function () {
            //得到批改作业的数据
            var correctContent = JSON.stringify(that.correntList);

            var checkInitSql = "select HomeworkId,CorrectContent from t_correct where HomeworkId =" + that.homeworkId;
            db.fetchAll(checkInitSql, function (ret) {
                //没有数据
                if (ret.length == 0) {
                    var sql = "insert into t_correct(HomeworkId,CorrectContent)" +
                                   " values (" + that.homeworkId + ",'" + correctContent + "')";
                    db.query(sql);
                }
                else {//已经有数据
                    var sql = "update t_correct set CorrectContent='" + correctContent + "' where HomeworkId=" + that.homeworkId;
                    db.query(sql);
                }
            });
        },
    };
    return new obj();
})();