﻿var HomeworkCommentCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.score = 0;
            that.getScore(that.score);
            that.loginInfo = Cache.getCache("LoginUserInfo");
            that.homeworkId = Cache.getCache("Correct_HomeworkId");
            that.type = Cache.getCache("HomeworkComment_type");
            that.init();
            $("#hcComment").val("");
            //4.0.1 fixedstart by lijq 2016/1/1 按钮控制

            // add by lijq 2016-12-21 屏蔽表情 start
            $("#hcComment").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("hcComment").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#hcComment").val().trim();
                if (Util.isEmojiCharacter(content))
                {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#hcComment").val(content);
                }               
            };
            // add by lujf 2016-12-21 屏蔽表情 end


            that.isClick = true;
        },

        //初始化
        init: function () {
            var checkInitSql = "select HomeworkId,CorrectContent from t_correct where HomeworkId =" + that.homeworkId;
            db.fetchAll(checkInitSql, function (ret) {
                //没有数据
                if (ret.length == 0) {
                    
                }
                else {//已经有数据
                    that.correntList = JSON.parse(ret[0].CorrectContent);
                }
            });
        },

        //得到评分
        getScore:function(score)
        {
            that.score = score;
            for (var i = 1; i < 6; i++)
            {
                $("#hc_img" + i + "").attr('src', 'images/homeworkTe/star_empty.png');
            }
            for (var i = 1; i <= score; i++) {
                $("#hc_img" + i + "").attr('src', 'images/homeworkTe/star.png');
            }
        },

        saveCorrect: function () {
            that.comment = $("#hcComment").val();
            if (that.score == 0)
            {
                Util.info("您还未评等级，请选择等级");
                return;
            }
            if ($.trim(that.comment) == "")
            {
                Util.info("您还未给到总的评价，请输入总的评价");
                return;
            }
            //4.0.1 fixedstart by lijq 2016/11/1 按钮控制
            if (that.isClick)
            {
                Util.showAppLoading();
                that.isClick = false;
                var apiUrl = "";
                //FixedStart liyl 2016/12/28  https的判断
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    apiUrl = Config.HttpsApiRootPath + "user/GetUptokenToVoice";
                } else {
                    apiUrl = Config.ApiRootPath + "user/GetUptokenToVoice";
                }
                //FixedEnd
                if (that.type == 1)//乐器
                {
                    $.ajax({
                        type: 'POST',
                        url: apiUrl,
                        data: {},
                        dataType: "text",
                        timeout: 10000,
                        success: function (data) {
                            //4.0.1 fixedstart by lijq 2016/1/1 添加loading以及按钮控制
                          
                            that.isClick = true;
                            //fixedend
                            if (data) {
                                data = JSON.parse(data);
                            }
                            //每一页的批改痕迹的集合
                            var listArray = that.correntList;
                            //3个参数分别是七牛的token，每一页批改后获取的complist的集合，上传完成的回调方法
                            ZebDev.happymusic.homework.uploadRecord(data.uptoken, listArray,
                                function (newListArray) {
                                    //newListArray回调的这个结果为传入参数listArray的修正，主要变更的内容是语音的路径从本地改为云盘
                                    //将这个newListArray保存到数据库即可
                                    that.correct = {
                                        "HomeworkId": that.homeworkId,
                                        "CorrectContent": JSON.stringify(newListArray),
                                        "CorrectComment": that.comment,
                                        "UserId": that.loginInfo.UserId,
                                        "CorrectScore": that.score
                                    };

                                    Util.ajax({
                                        method: "POST",
                                        data: {
                                            correctStr: JSON.stringify(that.correct)
                                        },
                                        url: Util.getApiUrl("SaveCorrectContent"),
                                        timeout: 10000
                                    }, function (resultData) {
                                        Util.hideAppLoading();
                                        if (resultData.ResponseCode == enumKey.CommonResp.Success) {
                                            //成功保存，则在本地数据库中删除，本地数据库作业状态变更
                                            var sql = "delete from t_correct where HomeworkId =" + that.homeworkId;
                                            db.query(sql);
                                            var sqlHomework = "update t_homework set HomeworkStatus=" + enumKey.HomeworkStatus.Rendering + " where HomeworkId=" + that.homeworkId;
                                            db.query(sqlHomework);
                                            Util.info(resultData.ResponseMessage);

                                            //关闭画面,跳转到作业列表页面
                                            $.ui.history.pop();
                                            $.ui.goBack();
                                        }
                                        else {
                                            Util.info(resultData.ResponseMessage);
                                        }
                                    }, function () {
                                        Util.hideAppLoading();
                                    });

                                }, data.domain);
                        },
                        error: function (e, msg) {
                            //4.0.1 fixedstart by lijq 2016/1/1 添加loading以及按钮控制
                            Util.hideAppLoading();
                            that.isClick = true;
                            //fixedend
                        }
                    });
                }
                else
                {
                    $.ajax({
                        type: 'POST',
                        url: apiUrl,
                        data: {},
                        dataType: "text",
                        timeout: 10000,
                        success: function (data) {
                            if (data) {
                                data = JSON.parse(data);
                            }
                             //4.0.1 fixedstart by lijq 2016/1/1 添加loading以及按钮控制
                            that.isClick = true;
                            //fixedend
                            //每一页的批改痕迹的集合
                            var listArray = that.correntList;
                            //3个参数分别是七牛的token，每一页批改后获取的complist的集合，上传完成的回调方法
                            ZebDance.happymusic.homework.uploadRecord(data.uptoken, listArray,
                                function (newListArray) {
                                    //newListArray回调的这个结果为传入参数listArray的修正，主要变更的内容是语音的路径从本地改为云盘
                                    //将这个newListArray保存到数据库即可
                                    that.correct = {
                                        "HomeworkId": that.homeworkId,
                                        "CorrectContent": JSON.stringify(newListArray),
                                        "CorrectComment": that.comment,
                                        "UserId": that.loginInfo.UserId,
                                        "CorrectScore": that.score
                                    };

                                    Util.ajax({
                                        method: "POST",
                                        data: {
                                            correctStr: JSON.stringify(that.correct)
                                        },
                                        url: Util.getApiUrl("SaveCorrectContent"),
                                        timeout: 10000
                                    }, function (resultData) {
                                        Util.hideAppLoading();
                                        if (resultData.ResponseCode == enumKey.CommonResp.Success) {
                                            //成功保存，则在本地数据库中删除，本地数据库作业状态变更
                                            var sql = "delete from t_correct where HomeworkId =" + that.homeworkId;
                                            db.query(sql);
                                            var sqlHomework = "update t_homework set HomeworkStatus=" + enumKey.HomeworkStatus.Rendering + " where HomeworkId=" + that.homeworkId;
                                            db.query(sqlHomework);
                                            Util.info(resultData.ResponseMessage);

                                            //关闭画面,跳转到作业列表页面
                                            $.ui.history.pop();
                                            $.ui.goBack();
                                            //$.ui.loadContent("#pnl_homeworkList", false, true, "slide");
                                        }
                                        else {
                                            Util.info(resultData.ResponseMessage);
                                        }
                                    }, function () {
                                        Util.hideAppLoading();
                                    });
                                }, data.domain);
                        },
                        error: function (e, msg) {
                            //4.0.1 fixedstart by lijq 2016/1/1 添加loading以及按钮控制
                            Util.hideAppLoading();
                            that.isClick = true;
                            //fixedend
                        }
                    });
                }             
            }
         },
    };
    return new obj();
})();