﻿var HomeworkListCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginUser = Cache.getCache("LoginUserInfo");
            //fixedStart liyl 2017/1/11 拼接机构字符串
            that.orgIdStr = "";
            for (var i = 0; i < that.loginUser.OrganizationList.length; i++) {
                that.orgIdStr += that.loginUser.OrganizationList[i].OrgId + ",";
            }
            if (that.orgIdStr != "") {
                that.orgIdStr = that.orgIdStr.substring(0, (that.orgIdStr.length - 1));
            }
            //fixedEnd
            var tab = Cache.getCache("HomeworkList_tab");
            that.changeTab(tab);
            
            $("#homeworkList_chooseHomework").height(document.getElementById("homeworkList_top_div").offsetHeight
                - document.getElementById("homeworkList_top_btnbar").offsetHeight
                - 42);
            $("#homeworkList_tab_sended").height(document.getElementById("homeworkList_top_div").offsetHeight - document.getElementById("homeworkList_top_btnbar").offsetHeight);
            $("#homeworkList_tab_list").height(document.getElementById("homeworkList_top_div").offsetHeight - document.getElementById("homeworkList_top_btnbar").offsetHeight);
            $("#homeworkList_typeList_panel").height($("#homeworkList_chooseHomework").height() - 40);
            $("#homeworkList_bookList_panel").height($("#homeworkList_typeList_panel").height());
            $("#homeworkList_videoList_panel").height(window.innerHeight - $("#hl_height_div").offset().top - $("#hl_height_div").height()-20);           

            //初始化类别列表
            that.listTypeScroll = new devAfScroller("homeworkList_typeList_panel", { });
            //绑定点击事件
            CommonClickEvent(".homeworkList_studentlist_click_type", function (isClick, data) {
                if (isClick) {
                    if (data != "") {
                        that.chooseType(parseInt(data));
                    }
                }
            });
            //初始化教材列表
            that.listBookScroll = new devAfScroller("homeworkList_bookList_panel", {
                refreshFunc: that.loadBookList,
                loadMoreFunc: that.loadBookMore
            });
            //初始化曲目列表
            that.listVideoScroll = new devAfScroller("homeworkList_videoList_panel", {
                refreshFunc: that.loadVideoList,
                loadMoreFunc: that.loadVideoMore
            });
            //初始化学生列表
            that.listStudentScroll = new devAfScroller("homeworkList_studentList_panel", {
                refreshFunc: that.loadStudentList,
                loadMoreFunc: that.loadStudentMore
            });
            //初始化已发送列表
            that.listTabSendedScroll = new devAfScroller("homeworkList_tab_sended", {
                refreshFunc: that.loadSendHomeworkList,
                loadMoreFunc: that.loadSendHomeworkMore
            });
            //初始化作业列表
            that.listTabListScroll = new devAfScroller("homeworkList_tab_list", {
                refreshFunc: that.loadHomeworkList,
                loadMoreFunc: that.loadHomeworkMore
            });

            that.listBookScroll.scrollTo({ x: 0, y: 0 });
            that.listVideoScroll.scrollTo({ x: 0, y: 0 });
            that.listStudentScroll.scrollTo({ x: 0, y: 0 });
            that.listTabSendedScroll.scrollTo({ x: 0, y: 0 });
            that.listTabListScroll.scrollTo({ x: 0, y: 0 });

            that.sendedHomeworkList = [];
            that.homeworkListDataList = [];
            that.bookList = [];
            that.videoList = [];
            that.studentList = [];
            //确认按钮的点击次数
            that.comfirmCount = 0;
            that.studentId = 0;
            //按钮的开关
            that.kaiguan = 0;
        },

        //选择切换
        changeTab: function (index) {
            $("#homeworkList_send").removeClass("homeworkList_top_btnbar_underLine");
            $("#homeworkList_sended").removeClass("homeworkList_top_btnbar_underLine");
            $("#homeworkList_detail").removeClass("homeworkList_top_btnbar_underLine");
           
            $("#homeworkList_tab_send").hide();
            $("#homeworkList_tab_list").hide();
            $("#homeworkList_tab_sended").hide();

            $("#homeworkList_send_div_back").html("");

            if (index == 1) {
                //切换按钮的横线有
                $("#homeworkList_send").addClass('homeworkList_top_btnbar_underLine');
                $("#homeworkList_tab_send").show();

                $("#homeworkList_student").hide();
                $("#homeworkList_bookList").hide();
                $("#homeworkList_first_div").hide();
                $("#homeworkList_second_div").hide();
                $("#homeworkList_videoList").hide();
                //fixedby lijq 2016/11/2 学生列表的高度导致滚动有问题
                $("#homeworkList_studentList_panel").height(window.innerHeight - $("#hl_height_div").offset().top - $("#hl_height_div").height() - 20);
            }
            else if (index == 2) {
                Cache.clearCache("HomeworkList_studentId");// add by lujf 2016-11-25 清空参数
                //切换按钮的横线有
                $("#homeworkList_sended").addClass('homeworkList_top_btnbar_underLine');
                $("#homeworkList_tab_sended").show();
                that.loadSendHomeworkList();
            }
            else {
                Cache.clearCache("HomeworkList_studentId");// add by lujf 2016-11-25 清空参数
                $("#homeworkList_detail").addClass("homeworkList_top_btnbar_underLine");
                $("#homeworkList_tab_list").show();
                that.loadHomeworkList();
            }
        },

        //选择类别
        chooseType: function (typeId) {
            that.learningType = typeId;
            that.loadBookList();
            $("#homeworkList_first_div").show();
            $("#homeworkList_bookList").show();
        },

        //选择教材
        chooseBook: function (bookId) {
            that.bookId = bookId;
            that.loadVideoList();
            $("#homeworkList_second_div").show();
            $("#homeworkList_videoList").show();
        },

        //选择曲目
        chooseVideo: function (videoId) {
            that.videoId = videoId;
            for (var i = 0; i < that.videoList.length;i++)
            {
                $("#homeworkList_videoId_" + that.videoList[i].VideoId).css("background-color", "#fff");
            }
            $("#homeworkList_videoId_" + that.videoId).css("background-color", "#a1a1a1");
        },

        //选择学生
        chooseStudent: function (studentId) {
            that.studentId = studentId;
            for (var i = 0; i < that.studentList.length; i++) {
                $("#homeworkList_studentId_" + that.studentList[i].UserId).css("background-color", "#fff");
            }
            $("#homeworkList_studentId_" + that.studentId).css("background-color", "#a1a1a1");
        },

        //确认按钮
        comfirmBtn: function () {
            if (that.videoId == null || typeof that.videoId == 'undefined' || that.videoId == "") {
                return;
            }// add by lujf 2016-11-24 有时候没选中video就点了确认
            if (that.comfirmCount == 0) {
                // fixed by lujf 2016-11-25 学生列表进入时带入学生Id start 
                var studentId = Cache.getCache("HomeworkList_studentId");
                if (studentId && studentId!=0) {
                    that.studentId = studentId;
                    that.comfirmCount = 1;
                    that.comfirmBtn();
                }
                else {
                    $("#homeworkList_send_div_back").html("返回");
                    $("#homeworkList_student").show();
                    that.loadStudentList();
                    that.comfirmCount = 1;
                }
                // fixed by lujf 2016-11-25 学生列表进入时带入学生Id end 
            }
            else {
                if (that.studentId == 0)
                {
                    Util.info("请选择要发送作业的学生");
                    return;
                }
                var publishHomework = {
                    "UserId": that.studentId,
                    "TeacherId": that.loginUser.UserId,
                    "VideoId": that.videoId
                };
                //发送作业点击按钮修改2016-12-20        
                if (that.kaiguan == 0) {  
                    that.kaiguan = 1;
                    Util.ajax({
                        method: "POST",
                        data: {
                            publishHomeworkStr: JSON.stringify(publishHomework)
                        },
                        url: Util.getApiUrl("SendHomework")
                    }, function (data) {
                        that.kaiguan = 0;
                        if (data.ResponseCode == 1) {
                            that.studentId = 0;
                            that.changeTab(2);
                        }
                        Util.info(data.ResponseMessage);
                        that.comfirmCount = 0;
                        Cache.clearCache("HomeworkList_studentId");// add by lujf 2016-11-25 清空参数
                    }, function () {
                        that.kaiguan = 0;
                        Util.info(data.ResponseMessage);
                    });                   
                }                             
            }            
        },

        //返回按钮
        backBtn: function () {
            that.comfirmCount = 0;
            $("#homeworkList_student").hide();
            $("#homeworkList_send_div_back").html("");
        },

        //返回上一级
        hideDiv: function (index) {
            //1表示返回到类别列表，2，表示返回到教材列表
            if (index == 1) {
                $("#homeworkList_first_div").hide();
                $("#homeworkList_second_div").hide();
                $("#homeworkList_bookList").hide();
                $("#homeworkList_videoList").hide();
            }
            if (index == 2) {
                $("#homeworkList_second_div").hide();
                $("#homeworkList_videoList").hide();
            }
        },

        //选中某一个作业 
        chooseHomework: function (homeworkId,status,type) {
            if (type == 2) {//舞蹈
                if (status == enumKey.HomeworkStatus.Rendering)//已批改
                {
                    Cache.setCache("HomeworkList_tab", 3);
                    Cache.setCache("HomeworkDetail_HomeworkId", homeworkId);
                    toPage("pnl_homeworkDetailDance");
                }
                else
                {
                    Cache.setCache("HomeworkList_tab", 3);
                    Cache.setCache("Correct_HomeworkId", homeworkId);
                    toPage("pnl_correctDance");
                }
            } else {
                if (status == enumKey.HomeworkStatus.Rendering)//已批改
                {
                    Cache.setCache("HomeworkList_tab", 3);
                    Cache.setCache("HomeworkDetail_HomeworkId", homeworkId);
                    toPage("pnl_homeworkDetail");
                }
                else
                {
                    Cache.setCache("HomeworkList_tab", 3);
                    Cache.setCache("Correct_HomeworkId", homeworkId);
                    toPage("pnl_correctMusic");
                }
            }
        },

        // 加载课程列表
        loadBookList: function () {
            // 判断课本表是否初始化
            var checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_book_" + that.learningType + "'";
            db.fetchAll(checkInitSql, function (ret) {
                var date = {
                    isInit: true,
                    bookType: that.learningType,
                    bookAttribute: 0,
                    orgIdStr: that.orgIdStr,
                    lastUpdateTime: "",
                    userType: 2
                };
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            isInit: true,
                            bookType: that.learningType,
                            bookAttribute: 0,
                            orgIdStr: that.orgIdStr,
                            lastUpdateTime: "",
                            userType: 2
                        },
                        url: Util.getApiUrl("NewBookList")
                    }, function (data) {
                        //  清空列表                       
                        $("#homeworkList_bookList_panel_item").html("");

                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = data.slice(0, 10);
                            that.bookList = dataList;
                            // 显示数据
                            that.showBookData(dataList);
                            // 设置scroller                            
                            that.listBookScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.listBookScroll.pullback();

                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                                var it=  data[i];
                                sql = "insert into t_book(BookId,BookName,BookType,BookAttribute,BookImgStr,IsVip,FirstShow,CustomType,ClickCount,OrgId,UpdateTime,CreateTime,IsInside)" +
                                   " values (" + it.BookId + ",'"
                                   + it.BookName + "',"
                                   + it.BookType + ","
                                   + it.BookAttribute + ",'"
                                   + it.BookImgStr + "',"
                                   + it.IsVip + ","
                                   + it.FirstShow + ","
                                   + it.CustomType + ","
                                   + it.ClickCount + ","
                                   + it.OrgId + ",'"
                                   + it.UpdateTimeDateStr + "','"
                                   + it.CreateTimeDateStr + "','"
                                   + (it.IsInside ? 1 : 0) + "')";
                                    db.query(sql);
                               
                            }
                            // 保存最后更新时间
                            sql = "insert into t_manage(tbl_nm,last_update_time) values('t_book_" + that.learningType + "','" + data[0].LastUpdateTimeStr + "')";
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.bookList = [];
                        }
                    });
                } else {// 已经初始化 
                    //删除用户因修改机构绑定状态而多余的机构内部教材的数据
                    var orgdelsql = "delete from t_book where IsInside = 1 ";
                    if (that.loginUser.OrganizationList.length > 0) {
                        for (var i = 0; i < that.loginUser.OrganizationList.length; i++) {
                                orgdelsql += " and  OrgId !=" + that.loginUser.OrganizationList[i].OrgId;
                        }
                    }
                    db.query(orgdelsql);
                    // 取出本地数据
                    that.getBookDataList(0, 10, function (dataList) {
                        //  清空列表                        
                        $("#homeworkList_bookList_panel_item").html("");

                        that.bookList = dataList;
                        // 显示数据
                        that.showBookData(dataList);
                        // 设置scroller                        
                        that.listBookScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listBookScroll.pullback();

                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                isInit: false,
                                bookType: that.learningType,
                                bookAttribute: 0,
                                orgIdStr: that.orgIdStr,
                                lastUpdateTime: ret[0].last_update_time,
                                userType: 2// todo...
                            },
                            url: Util.getApiUrl("NewBookList")
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            var it;
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    it = data[i];
                                    
                                        //验证数据是否已存在
                                        var checkSql = "select count(*) as ct from t_book where BookId = " + it.BookId;
                                        db.fetchAll(checkSql, function (ret) {
                                            if (ret[0].ct > 0 ) {
                                                //  删除
                                                if (it.IsDeleted || it.IsDeletedOrg) {
                                                    var delsql = "delete from t_book where BookId=" + it.BookId;
                                                    db.query(delsql);
                                                } else {
                                                    // 更新
                                                    var updatesql = "update t_book set BookName = '" + it.BookName
                                                                + "',BookType = " + it.BookType
                                                                + ",BookAttribute = " + it.BookAttribute
                                                                + ",BookImgStr = '" + it.BookImgStr
                                                                + "',IsVip = " + it.IsVip
                                                                + ",FirstShow = " + it.FirstShow
                                                                + ",CustomType = " + it.CustomType
                                                                + ",ClickCount = " + it.ClickCount
                                                                + ",OrgId = " + it.OrgId
                                                                + ",UpdateTime = '" + it.UpdateTimeDateStr
                                                                + ",IsInside =" + (it.IsInside ? 1 : 0)
                                                                + "' where BookId = " + it.BookId;
                                                    db.query(updatesql);
                                                }
                                            } else {
                                                // 新增
                                                if (!it.IsDeleted && !it.IsDeletedOrg) {
                                                    var insertsql = "insert into t_book(BookId,BookName,BookType,BookAttribute,BookImgStr,IsVip,FirstShow,CustomType,ClickCount,OrgId,UpdateTime,CreateTime,IsInside)" +
                                                        " values (" + it.BookId + ",'"
                                                        + it.BookName + "',"
                                                        + it.BookType + ","
                                                        + it.BookAttribute + ",'"
                                                        + it.BookImgStr + "',"
                                                        + it.IsVip + ","
                                                        + it.FirstShow + ","
                                                        + it.CustomType + ","
                                                        + it.ClickCount + ","
                                                        + it.OrgId + ",'"
                                                        + it.UpdateTimeDateStr + "','"
                                                        + it.CreateTimeDateStr + "','"
                                                        + (it.IsInside ? 1 : 0) + "')";
                                                    db.query(insertsql);
                                                }
                                            }
                                        });
                                   
                                   
                                }

                                // 保存最后更新时间
                                var sql = "update t_manage set last_update_time = '" + data[0].LastUpdateTimeStr + "' where tbl_nm = 't_book_" + that.learningType + "'";
                                db.query(sql);
                            }
                        });
                    }, function () {
                        that.listBookScroll.setMoreRecord(true);
                        that.listBookScroll.pullback();
                    });
                }
            });
        },

        // 加载更多
        loadBookMore: function () {
            // 取出本地数据
            that.getBookDataList(that.bookList.length, 10, function (dataList) {
                that.bookList = that.bookList.concat(dataList);
                that.showBookData(dataList);
                // 设置scroller               
                that.listBookScroll.setMoreRecord(dataList.length == 10 ? true : false);
                that.listBookScroll.pullback();

            }, function () {
                // 设置scroller                
                that.listBookScroll.setMoreRecord(true);
                that.listBookScroll.pullback();
            });
        },

        // 获取本地数据
        getBookDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "";
            if (that.learningType == 199) {// 内部教材
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount,IsInside from t_book where OrgId="
                    + 0 + " order by FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;// todo...
            }
            else {// 其他
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount,IsInside from t_book where BookType="
                    + that.learningType + " order by IsInside desc , FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;
            }
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret_1) {
                if (typeof callback == 'function') {
                    callback(ret_1);
                }
            }, function () {
                errCallback();
            });
        },

        // 显示数据
        showBookData: function (dataList) {
            var showStr = "";
            var imgHeight = window.innerWidth * 0.2 * 0.92;
            var bookImage = new Image();
            var imgBgSize;
            // 体育舞蹈            
            for (var k = 0; k < dataList.length; k++) {
                bookImage.src = dataList[k].BookImgStr;
                if (bookImage.width > bookImage.height) {
                    imgBgSize = "auto 100%";
                }
                else {
                    imgBgSize = "100%";
                }
                showStr += '<div class="homeworkList_studentlist_template homeworkList_studentlist_click_book" data="' + dataList[k].BookId + '" >'
                        + '<div class="homeworkList_studentlist_left">' + dataList[k].BookName + '</div>'
                        + '<div class="homeworkList_studentlist_right">'
                        + '<img class="homeworkList_goto_img" src="images/learn/goto.png" />'
                        + '</div>'
                        + '</div>';
            }
            $("#homeworkList_bookList_panel_item").append(showStr);
            if (dataList.length>0) {
                //绑定点击事件
                CommonClickEvent(".homeworkList_studentlist_click_book", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            that.chooseBook(parseInt(data));
                        }
                    }
                });
            }
        },

        // 刷新List
        loadVideoList: function () {
            // 判断视频表是否初始化
            var checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_video_" + that.bookId + "'";
            db.fetchAll(checkInitSql, function (ret) {
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            isInit: true,
                            bookId: that.bookId,
                            userId: 1,// todo..
                            lastUpdateTime: "",
                            videoType: 0,
                            userType: 2// 
                        },
                        url: Util.getApiUrl("VideoList")
                    }, function (data) {
                        //  清空列表
                        $("#homeworkList_videoList_panel_item").html("");
                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = data.slice(0, 10);
                            that.videoList = dataList;
                            // 显示数据
                            that.showVideoData(dataList);
                            // 设置scroller
                            that.listVideoScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.listVideoScroll.pullback();

                            // 将数据保存到本地数据库
                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                                var it= data[i];
                                sql = "insert into t_video(VideoId,BookId,VideoName,VideoType,VideoImgStr,Gold,UploadGold,ClickCount,FirstShow,IsCollected,UpdateTime,CreateTime,IsShow)" +
                                  " values (" + it.VideoId + ","
                                  + it.BookId + ",'"
                                  + it.VideoName + "',"
                                  + it.VideoType + ",'"
                                  + it.VideoImgStr + "',"
                                  + it.Gold + ","
                                  + it.UploadGold + ","
                                  + it.ClickCount + ","
                                  + it.FirstShow + ","
                                  + (it.IsCollected ? 1 : 0) + ",'"
                                  + it.UpdateTimeDateStr + "','"
                                  + it.CreateTimeDateStr + "','"
                                  + (it.IsShow ? 1 : 0) + "')";
                                    db.query(sql);
                               
                              
                            }
                            // 保存最后更新时间
                            sql = "insert into t_manage(tbl_nm,last_update_time) values('t_video_" + that.bookId + "','" + data[0].LastUpdateTimeStr + "')";
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.videoList = [];
                        }
                    });
                }
                else {// 已经初始化
                    that.getVideoDataList(0, 10, function (dataList) {
                        //  清空列表
                        $("#homeworkList_videoList_panel_item").html("");
                        that.videoList = dataList;
                        // 显示数据
                        that.showVideoData(dataList);
                        // 设置scroller
                        that.listVideoScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listVideoScroll.pullback();
                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                isInit: false,
                                bookId: that.bookId,
                                userId: 1,// todo..
                                lastUpdateTime: ret[0].last_update_time,
                                videoType: 0,
                                userType: 2// todo..
                            },
                            url: Util.getApiUrl("VideoList")
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            var it;
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    it = data[i];
                                    //验证数据是否已存在
                                    
                                        var checkSql = "select count(*) as ct from t_video where VideoId = " + it.VideoId;
                                        db.fetchAll(checkSql, function (ret) {
                                            if (ret[0].ct > 0 ) {
                                                //  删除
                                                if (it.IsDeleted || it.VideoStatus == enumKey.VideoStatus.OffSale) {
                                                    var delsql = "delete from t_video where VideoId=" + it.VideoId;
                                                    db.query(delsql);
                                                } else {
                                                    // 更新
                                                    var updatesql = "update t_video set BookId = " + it.BookId
                                                                + ",VideoName = '" + it.VideoName
                                                                + "',VideoType = " + it.VideoType
                                                                + ",VideoImgStr = '" + it.VideoImgStr
                                                                + "',Gold = " + it.Gold
                                                                + ",UploadGold = " + it.UploadGold
                                                                + ",ClickCount = " + it.ClickCount
                                                                + ",FirstShow = " + it.FirstShow
                                                                + ",IsCollected = " + (it.IsCollected ? 1 : 0)
                                                                + ",UpdateTime = '" + it.UpdateTimeDateStr
                                                                + ",IsShow = '" + (it.IsShow ? 1 : 0)
                                                                + "' where VideoId = " + it.VideoId;
                                                    db.query(updatesql);
                                                }
                                            } else {
                                                // 新增
                                                if (it.IsDeleted == false && it.VideoStatus == enumKey.VideoStatus.OnSale) {
                                                    var insertsql = "insert into t_video(VideoId,BookId,VideoName,VideoType,VideoImgStr,Gold,UploadGold,ClickCount,FirstShow,IsCollected,UpdateTime,CreateTime,IsShow)" +
                                                        " values (" + it.VideoId + ","
                                                        + it.BookId + ",'"
                                                        + it.VideoName + "',"
                                                        + it.VideoType + ",'"
                                                        + it.VideoImgStr + "',"
                                                        + it.Gold + ","
                                                        + it.UploadGold + ","
                                                        + it.ClickCount + ","
                                                        + it.FirstShow + ","
                                                        + (it.IsCollected ? 1 : 0) + ",'"
                                                        + it.UpdateTimeDateStr + "','"
                                                        + it.CreateTimeDateStr + "','"
                                                        + (it.IsShow ? 1 : 0) + "')";

                                                    db.query(insertsql);
                                                }
                                            }
                                        });
                                   
                                    
                                }

                                // 保存最后更新时间
                                var sql = "update t_manage set last_update_time = '" + data[0].LastUpdateTimeStr + "' where tbl_nm = 't_video_" + that.bookId + "'";
                                db.query(sql);
                            }
                        });
                    }, function () {
                        // 设置scroller
                        that.listVideoScroll.setMoreRecord(true);
                        that.listVideoScroll.pullback();
                    });
                }
            });
        },

        // 加载更多
        loadVideoMore: function () {
            // 取出本地数据
            that.getVideoDataList(that.videoList.length, 10, function (dataList) {
                that.videoList = that.videoList.concat(dataList);
                that.showVideoData(dataList);
                // 设置scroller
                that.listVideoScroll.setMoreRecord(dataList.length == 10 ? true : false);
                that.listVideoScroll.pullback();
            }, function () {
                // 设置scroller
                that.listVideoScroll.setMoreRecord(true);
                that.listVideoScroll.pullback();
            });
        },

        // 显示数据
        showVideoData: function (dataList) {
            var showStr = "";
            var item;
            for (var i = 0; i < dataList.length; i++) {
                item = dataList[i];

                showStr += '<div class="homeworkList_studentlist_template homeworkList_studentlist_click_video" data="' + dataList[i].VideoId + '"   id="homeworkList_videoId_' + dataList[i].VideoId + '">'
                         + '<div class="homeworkList_studentlist_left">' + dataList[i].VideoName + '</div>'
                         + '<div class="homeworkList_studentlist_right">'
                         + '<div class="homeworkList_studentlist_unselect" style="border:none;"></div>'
                         + '</div>'
                         + '</div>'
            }
            $("#homeworkList_videoList_panel_item").append(showStr);
            if (dataList.length > 0) {
                //绑定点击事件
                CommonClickEvent(".homeworkList_studentlist_click_video", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            that.chooseVideo(parseInt(data));
                        }
                    }
                });
            }

        },

        // 获取数据
        getVideoDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "select VideoId,VideoName,IsCollected,VideoType from t_video where BookId=" + that.bookId
                + " order by FirstShow,  UpdateTime desc limit " + pageIndex + "," + pageCount;
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                if (typeof callback == 'function') {
                    callback(ret);
                }
            }, function () {
                errCallback();
            });
        },

        //加载学生用户信息
        loadStudentList: function () {
            that.getStudentDataList(0);
        },

        //加载更多
        loadStudentMore: function () {
            that.getStudentDataList(that.studentList.length);
        },

        //显示数据
        showStudentData: function (dataList) {
            //alert(2);
            var showStr = "";
            var item;
            for (var i = 0; i < dataList.length; i++) {
                item = dataList[i];

                showStr += '<div class="homeworkList_studentlist_template homeworkList_studentlist_click_student" data="' + item.UserId + '" >'
                         + '<div class="homeworkList_studentlist_left">' + item.RealName + '</div>'
                         + '<div class="homeworkList_studentlist_right">'
                         + '<div class="homeworkList_studentlist_unselect" id="homeworkList_studentId_' + item.UserId + '"></div>'
                         + '</div>'
                         + '</div>'
            }
            $("#homeworkList_studentList_item").append(showStr);
            if (dataList.length > 0) {
                //绑定点击事件
                CommonClickEvent(".homeworkList_studentlist_click_student", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            that.chooseStudent(parseInt(data));
                        }
                    }
                });
            }
        },

        //获取数据
        getStudentDataList: function (pageIndex) {
            Util.ajax({
                method: "POST",
                data: {
                    teacherId: that.loginUser.UserId,
                    realName: "",
                    size: 10,
                    index: pageIndex,
                },
                url: Util.getApiUrl("MyStudents")
            }, function (data) {
                if (data.DataList.length > 0) {
                    if (pageIndex == 0) {
                        that.studentList = [];
                        //  清空列表    
                        $("#homeworkList_studentList_item").html("");
                    }
                    that.studentList = that.studentList.concat(data.DataList);
                    that.showStudentData(data.DataList);                   
                    that.listStudentScroll.setMoreRecord(data.DataList.length >= 10 ? true : false);
                    that.listStudentScroll.pullback();
                }
            },function () {
                that.listStudentScroll.pullback();
            });          
        },

        //已发送的作业列表
        loadSendHomeworkList: function () {
            that.getSendHomeworkDataList(0);
        },

        //加载更多
        loadSendHomeworkMore: function () {
            that.getSendHomeworkDataList(that.sendedHomeworkList.length);
        },

        //显示数据
        showSendHomeworkData: function (dataList) {
            var showStr = "";
            var item;
            for (var i = 0; i < dataList.length; i++) {
                item = dataList[i];

                showStr += '<div class="homeworkList_studentlist_template">'
                         + '<div class="homework_List_headImg"><img src="'+item.HeadImg+'"></div>'
                         + '<div class="homeworkList_sendedList_left" style="width: 72%;">'
                         + '<div>'+item.RealName +'</div>'
                         + '<div><span>作业：</span><span>' + item.VideoName+ '</span></div>'
                         + '<div>' + item.CreateTimeStr + '</div>'
                         + '</div>'
                         + '<div class="homeworkList_List_right"></div>'
                         + '</div>'
            }
            $("#homeworkList_sendedList").append(showStr);
        },

        //获取数据
        getSendHomeworkDataList: function (pageIndex) {
            //debugger;
            Util.ajax({
                method: "POST",
                data: {
                    teacherId: that.loginUser.UserId,
                    size: 10,
                    index: pageIndex,
                },
                url: Util.getApiUrl("SendedHomeworkList")
            }, function (data) {
                if (data.DataList.length > 0) {
                    if (pageIndex == 0) {
                        that.sendedHomeworkList = [];
                        //  清空列表    
                        $("#homeworkList_sendedList").html("");
                    }
                    that.sendedHomeworkList = that.sendedHomeworkList.concat(data.DataList);
                    that.showSendHomeworkData(data.DataList);
                    that.listTabSendedScroll.setMoreRecord(data.DataList.length >= 10 ? true : false);
                    that.listTabSendedScroll.pullback();
                }
            }, function () {
                that.listTabSendedScroll.pullback();
            });
        },

        //老师的作业列表
        loadHomeworkList: function () {
            that.getHomeworkDataList(0);
        },

        //加载更多
        loadHomeworkMore: function () {
            that.getHomeworkDataList(that.homeworkListDataList.length);
        },

        //显示数据
        showHomeworkData: function (dataList) {
            var showStr = "";
            var item;
            for (var i = 0; i < dataList.length; i++) {
                item = dataList[i];

                showStr += '<div class="homeworkList_studentlist_template homeworkList_studentlist_click_homework" data="' + item.HomeworkId + '*' + item.HomeworkStatus + '*' + item.CustomType + '" > '
                showStr += '<div class="homework_List_headImg"><img src="' + item.HeadImg + '"></div>'
                showStr += '<div class="homeworkList_homeworkList_left">'
                showStr += '<div>' + item.RealName + '</div>'
                showStr += '<div><span>作业：</span><span>' + item.VideoName + '</span></div>'
                showStr += '<div>' + item.CreateTimeStr + '</div>'
                showStr += '</div>'
                showStr += '<div class="homeworkList_List_middle">'
                if(item.HomeworkStatus == 2) {
                    showStr += '<div>已批改</div>'
                }
                else {
                    showStr += '<div>未批改</div>'
                }
                showStr += '</div>'
                showStr += '<div class="homeworkList_List_right"><img src="images/learn/goto.png" /></div>'
                showStr += '</div>'
            }
            $("#homeworkList_homeworkList").append(showStr);
            if (dataList.length > 0) {
                //绑定点击事件
                CommonClickEvent(".homeworkList_studentlist_click_homework", function (isClick, data) {
                    if (isClick) {
                        if (data != "") {
                            var strs = new Array();
                            strs = data.split("*");
                            that.chooseHomework(parseInt(strs[0]),parseInt(strs[1]),parseInt(strs[2]));
                        }
                    }
                });
            }
        },

        //获取数据
        getHomeworkDataList: function (pageIndex) {
            Util.ajax({
                method: "POST",
                data: {
                    teacherId: that.loginUser.UserId,
                    searchStr:"",
                    size: 10,
                    index: pageIndex,
                },
                url: Util.getApiUrl("CorrectingHomeworkList")
            }, function (data) {
                if (data.DataList.length > 0) {
                    if (pageIndex == 0) {
                        that.homeworkListDataList = [];
                        //  清空列表    
                        $("#homeworkList_homeworkList").html("");
                    }
                    that.homeworkListDataList = that.homeworkListDataList.concat(data.DataList);
                    that.showHomeworkData(data.DataList);
                    that.listTabListScroll.setMoreRecord(data.DataList.length >= 10 ? true : false);
                    that.listTabListScroll.pullback();
                }
            }, function () {
                that.listTabListScroll.pullback();
            });
        },
    };
    return new obj();
})();