﻿var BookListCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
           
            // 初始化数据
            that.typeList = [];
            that.bookList = [];

            $("#bookList_guobiao_template").html("");// add by lujf 2017-1-18
            $("#bookList_sportsDance_template").html("");
            $("#bookList_list_template").html("");

            // 获取登录信息
            that.loginInfo = Cache.getCache("LoginUserInfo");
            that.orgIdStr = "";
            for (var i = 0; i < that.loginInfo.OrganizationList.length; i++) {
                that.orgIdStr += that.loginInfo.OrganizationList[i].OrgId + ",";
            }
            if (that.orgIdStr != "") {
                that.orgIdStr = that.orgIdStr.substring(0 , (that.orgIdStr.length - 1));
            }
            // 学习类型
            that.learningType = 0;
            that.sportsDanceType = 0;
            that.guobiaoType = 0;// add by lujf 2017-1-18 增加国标舞
            that.pageType = Cache.getCache("BookList_PageType");
            if (that.pageType == "Music" || that.pageType == "Staff") {// 如果是乐器示范或曲谱搜索
                Cache.getDbCache("MusicLearningType", that.initPageType);
            } else if (that.pageType == "Dance") {// 如果是舞蹈示范
                Cache.getDbCache("DanceLearningType", that.initPageType);
            } else {// 默认乐器
                that.pageType = "Music"
                Cache.getDbCache("MusicLearningType", that.initPageType);
            }

            // 初始化Scroller
            that.listScroll = new devAfScroller("bookList_bookList_panel", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });
            
            // 初始化体育舞蹈Scroller
            that.sportsListScroll = new devAfScroller("bookList_sportsDance_bookList", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });

            // 初始化国标舞蹈Scroller add  by lujf 2017-1-18 
            that.guobiaoListScroll = new devAfScroller("bookList_guobiao_bookList", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });

            // 定义窗口大小变更事件
            //$(window).resize(function () {
            //    //$(".bookList_item_left img").height(window.innerWidth * 0.2 * 0.92);
            //    if (that.learningType == 102) {
            //        $("#bookList_sportsDance_bookList").height(window.innerHeight - $(".bookList_sportsDanceType_div").offset().top - $(".bookList_sportsDanceType_div").height() - 10);
            //    } else {
            //        $("#bookList_bookList_panel").height(window.innerHeight - $("#bookList_bookList_panel").offset().top);
            //    }
            //});

            // 获取类别
            that.getType();

            that.listScroll.scrollTo({ x: 0, y: 0 });
            that.sportsListScroll.scrollTo({ x: 0, y: 0 });
            that.guobiaoListScroll.scrollTo({ x: 0, y: 0 });// add by lujf 2017-1-18 增加国标舞
            
        },

        // 初始化页面类型
        initPageType:function(result){
            if (result) {
                var data = JSON.parse(result);
                that.learningType = data.id;
                $("#bookList_title").html(data.name);
                $(".bookList_title_type_img").show();
                $(".bookList_bookType_div").hide();
                // 体育舞蹈
                if (that.learningType == 102) {
                    that.sportsDanceType = 1021;
                    $("#bookList_header_right").hide();
                    $("#bookList_bookList_panel").hide();
                    $("#bookList_guobiao_panel").hide();// add by lujf 2017-1-18
                    $("#bookList_sportsDance_panel").show();
                    $("#bookList_sportsDance_bookList").height(window.innerHeight - $(".bookList_sportsDanceType_div").offset().top - $(".bookList_sportsDanceType_div").height() - 10);
                    $(".bookList_sportsDanceType_div div").removeClass("bookList_sportsDanceType_border");
                    $("#bookList_sportsDanceType_" + that.sportsDanceType).addClass("bookList_sportsDanceType_border");
                }
                // 国标舞 add by lujf 2017-1-18 增加国标舞
                else if (that.learningType == 114) {
                    that.guobiaoType = 1141;
                    $("#bookList_header_right").hide();
                    $("#bookList_bookList_panel").hide();
                    $("#bookList_sportsDance_panel").hide();
                    $("#bookList_guobiao_panel").show();
                    $("#bookList_guobiao_bookList").height(window.innerHeight - $(".bookList_guobiaoType_div").offset().top - $(".bookList_guobiaoType_div").height() - 10);
                    $(".bookList_guobiaoType_div div").removeClass("bookList_guobiaoType_border");
                    $("#bookList_guobiaoType_" + that.guobiaoType).addClass("bookList_guobiaoType_border");
                }
                else {
                    if (that.learningType == 115) {
                        $("#bookList_header_right").hide();
                    }
                    else {
                        $("#bookList_header_right").show();
                    }
                    $("#bookList_bookList_panel").show();
                    $("#bookList_guobiao_panel").hide();// add by lujf 2017-1-18
                    $("#bookList_sportsDance_panel").hide();
                    $("#bookList_bookList_panel").height(window.innerHeight - $("#bookList_bookList_panel").offset().top);
                }
                // 执行搜索列表
                that.loadList();
            }
            else {
                $("#bookList_title").html("选择种类");
                $(".bookList_bookType_div").show();
                $("#bookList_bookList_panel").hide();
                $("#bookList_guobiao_panel").hide();// add by lujf 2017-1-18
                $("#bookList_sportsDance_panel").hide();
                $("#bookList_header_right").hide();
            }
        },

        // 获取类别列表
        getType: function () {
            var data = [];
            if (that.pageType == "Music" || that.pageType == "Staff") {
                data = [{ DecodeId: 101, DecodeName: "钢琴" },
                { DecodeId: 103, DecodeName: "架子鼓" },
                { DecodeId: 104, DecodeName: "笛子" },
                { DecodeId: 105, DecodeName: "吉他" },
                { DecodeId: 106, DecodeName: "古筝" },
                { DecodeId: 107, DecodeName: "琵琶" },
                { DecodeId: 108, DecodeName: "小提琴" },
                { DecodeId: 109, DecodeName: "竹笛" },
                { DecodeId: 110, DecodeName: "萨克斯" }];
                //{ DecodeId: 199, DecodeName: "内部教材" }];//Fixed by liyl 2017/1/9 去掉内部教材
            } else {
                data = [{ DecodeId: 102, DecodeName: "体育舞蹈" },
                { DecodeId: 112, DecodeName: "中国舞" },
                { DecodeId: 111, DecodeName: "芭蕾舞" },
                { DecodeId: 113, DecodeName: "软开度练习" },
                { DecodeId: 114, DecodeName: "国标舞" },// fixed by lujf 2017-1-18 增加国标舞
                { DecodeId: 115, DecodeName: "内部教材" }];// fixed by lujf 2017-1-18 增加内部教材
            }
                that.typeList = data;
                // 设置页面数据
                var showStr = "";
                for (var i = 0; i < data.length; i++) {
                    showStr = showStr + "<div class='bookList_bookType_item' onclick='BookListCtrl.chooseType(" + data[i].DecodeId + ",\"" + data[i].DecodeName + "\")'>" + data[i].DecodeName + "</div>";
                }

                $(".bookList_bookType_div").html(showStr);
        },

        // 加载课程列表
        loadList: function () {
            if (that.learningType == 199)
            {
                $("#bookList_list_template").html("");
                return;
            }
            // 判断课本表是否初始化
            // fixed by lujf 2017-1-18 增加国标舞 start
            var saveType;
            if (that.learningType == 102) {
                saveType = that.sportsDanceType;
            }
            else if (that.learningType == 114) {
                saveType = that.guobiaoType;
            }
            else {
                saveType = that.learningType;
            }
            var checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_book_" + saveType + "'";
            // fixed by lujf 2017-1-18 增加国标舞 end
            db.fetchAll(checkInitSql, function (ret) {
                debugger;
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            isInit: true,
                            bookType: that.learningType,
                            bookAttribute: (that.learningType == 102 ? that.sportsDanceType : that.guobiaoType),// fixed by lujf 2017-1-18
                            orgIdStr: that.orgIdStr,
                            lastUpdateTime: "",
                            userType: that.loginInfo.UserType
                        },
                        url: Util.getApiUrl("NewBookList412")
                    }, function (data) {
                        //  清空列表
                        if (that.learningType == 102) {
                            $("#bookList_sportsDance_template").html("");
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 start
                        else if (that.learningType == 114) {
                            $("#bookList_guobiao_template").html("");
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 end
                        else {
                            $("#bookList_list_template").html("");
                        }
                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = data.slice(0, 10);
                            that.bookList = dataList;
                            // 显示数据
                            that.showData(dataList);
                            // 设置scroller
                            if (that.learningType == 102) {
                                that.sportsListScroll.setMoreRecord(dataList.length == 10 ? true : false);
                                that.sportsListScroll.pullback();
                            }
                            // fixed by lujf  2017-1-18 增加国标舞 start
                            else if (that.learningType == 114) {
                                that.guobiaoListScroll.setMoreRecord(dataList.length == 10 ? true : false);
                                that.guobiaoListScroll.pullback();
                            }
                            // fixed by lujf  2017-1-18 增加国标舞 end
                            else {
                                that.listScroll.setMoreRecord(dataList.length == 10 ? true : false);
                                that.listScroll.pullback();
                            }
                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                                var it = data[i];
                                var sql2 = "insert into t_book(BookId,BookName,BookType,BookAttribute,BookImgStr,IsVip,FirstShow,CustomType,ClickCount,OrgId,UpdateTime,CreateTime,IsInside)" +
                                  " values (" + it.BookId + ",'"
                                  + it.BookName + "',"
                                  + it.BookType + ","
                                  + it.BookAttribute + ",'"
                                  + it.BookImgStr + "',"
                                  + it.IsVip + ","
                                  + it.FirstShow + ","
                                  + it.CustomType + ","
                                  + it.ClickCount + ","
                                  + it.OrgId + ",'"
                                  + it.UpdateTimeDateStr + "','"
                                  + it.CreateTimeDateStr + "','"
                                  + (it.IsInside ? 1 : 0) + "')";
                                  db.query(sql2);
                              
                            }
                            // 保存最后更新时间
                            sql = "insert into t_manage(tbl_nm,last_update_time) values('t_book_" + saveType + "','" + data[0].LastUpdateTimeStr + "')";// fixed by lujf 2017-1-18 
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.bookList = [];
                        }

                    });
                } else {// 已经初始化 
                    //删除用户因修改机构绑定状态而多余的机构内部教材的数据
                    var orgdelsql = "delete from t_book where IsInside = 1 ";
                    if (that.loginInfo.OrganizationList.length>0) {
                        for (var i = 0; i < that.loginInfo.OrganizationList.length; i++) {
                           orgdelsql += " and OrgId !=" + that.loginInfo.OrganizationList[i].OrgId;

                        }
                    }
                    db.query(orgdelsql);

                    // 取出本地数据
                    that.getDataList(0, 10, function (dataList) {
                        //  清空列表
                        if (that.learningType == 102) {
                            $("#bookList_sportsDance_template").html("");
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 start
                        else if (that.learningType == 114) {
                            $("#bookList_guobiao_template").html("");
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 end
                        else {
                            $("#bookList_list_template").html("");
                        }
                        that.bookList = dataList;
                        // 显示数据
                        that.showData(dataList);
                        // 设置scroller
                        if (that.learningType == 102) {
                            that.sportsListScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.sportsListScroll.pullback();
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 start
                        else if (that.learningType == 114) {
                            that.guobiaoListScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.guobiaoListScroll.pullback();
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 end
                        else {
                            that.listScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.listScroll.pullback();
                        }

                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                isInit: false,
                                bookType: that.learningType,
                                bookAttribute: (that.learningType == 102 ? that.sportsDanceType : that.guobiaoType),// fixed by lujf 2017-1-18,
                                orgIdStr: that.orgIdStr,
                                lastUpdateTime: ret[0].last_update_time,
                                userType: that.loginInfo.UserType
                            },
                            url: Util.getApiUrl("NewBookList412")
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            var it;
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    it = data[i];
                                    //验证数据是否已存在
                                    
                                        var checkSql = "select count(*) as ct from t_book where BookId = " + it.BookId;
                                        db.fetchAll(checkSql, function (ret) {
                                            if (ret[0].ct > 0 ) {
                                                //  删除
                                                if (it.IsDeleted || it.IsDeletedOrg) {
                                                    var delsql = "delete from t_book where BookId=" + it.BookId ;
                                                    db.query(delsql);
                                                } else {
                                                    // 更新
                                                    var updatesql = "update t_book set BookName = '" + it.BookName
                                                                + "',BookType = " + it.BookType
                                                                + ",BookAttribute = " + it.BookAttribute
                                                                + ",BookImgStr = '" + it.BookImgStr
                                                                + "',IsVip = " + it.IsVip
                                                                + ",FirstShow = " + it.FirstShow
                                                                + ",CustomType = " + it.CustomType
                                                                + ",ClickCount = " + it.ClickCount
                                                                + ",OrgId = " + it.OrgId
                                                                + ",UpdateTime = '" + it.UpdateTimeDateStr
                                                                + ",IsInside ="+(it.IsInside ? 1 : 0)
                                                                + "' where BookId = " + it.BookId;
                                                    db.query(updatesql);
                                                }
                                            } else {
                                                // 新增
                                                if (!it.IsDeleted && !it.IsDeletedOrg) {
                                                    var insertsql = "insert into t_book(BookId,BookName,BookType,BookAttribute,BookImgStr,IsVip,FirstShow,CustomType,ClickCount,OrgId,UpdateTime,CreateTime,IsInside)" +
                                                        " values (" + it.BookId + ",'"
                                                        + it.BookName + "',"
                                                        + it.BookType + ","
                                                        + it.BookAttribute + ",'"
                                                        + it.BookImgStr + "',"
                                                        + it.IsVip + ","
                                                        + it.FirstShow + ","
                                                        + it.CustomType + ","
                                                        + it.ClickCount + ","
                                                        + it.OrgId + ",'"
                                                        + it.UpdateTimeDateStr + "','"
                                                        + it.CreateTimeDateStr + "','"
                                                        + (it.IsInside ? 1 : 0)+"')";
                                                    db.query(insertsql);
                                                }
                                            }
                                        });
                                   
                                }
                                // fixed by lujf 2017-1-18 增加国标舞 start
                                var saveType;
                                if (that.learningType == 102) {
                                    saveType = that.sportsDanceType;
                                }
                                else if (that.learningType == 114) {
                                    saveType = that.guobiaoType;
                                }
                                else {
                                    saveType = that.learningType;
                                }
                                // 保存最后更新时间
                                var sql = "update t_manage set last_update_time = '" + data[0].LastUpdateTimeStr + "' where tbl_nm = 't_book_" + saveType + "'";
                                // fixed by lujf 2017-1-18 增加国标舞 end
                                db.query(sql);
                            }
                        });
                    }, function () {
                        // 设置scroller
                        if (that.learningType == 102) {
                            that.sportsListScroll.setMoreRecord(true);
                            that.sportsListScroll.pullback();
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 start
                        else if (that.learningType == 114) {
                            that.guobiaoListScroll.setMoreRecord(true);
                            that.guobiaoListScroll.pullback();
                        }
                        // fixed by lujf  2017-1-18 增加国标舞 end
                        else {
                            that.listScroll.setMoreRecord(true);
                            that.listScroll.pullback();
                        }
                        
                    });
                }
            });
        },

        // 加载更多
        loadMore: function () {
            // 取出本地数据
            that.getDataList(that.bookList.length, 10, function (dataList) {
                that.bookList = that.bookList.concat(dataList);
                that.showData(dataList);
                // 设置scroller
                if (that.learningType == 102) {
                    that.sportsListScroll.setMoreRecord(dataList.length == 10 ? true : false);
                    that.sportsListScroll.pullback();
                }
                // fixed by lujf  2017-1-18 增加国标舞 start
                else if (that.learningType == 114) {
                    that.guobiaoListScroll.setMoreRecord(dataList.length == 10 ? true : false);
                    that.guobiaoListScroll.pullback();
                }
                // fixed by lujf  2017-1-18 增加国标舞 end
                else {
                    that.listScroll.setMoreRecord(dataList.length == 10 ? true : false);
                    that.listScroll.pullback();
                }
            }, function () {
                // 设置scroller
                if (that.learningType == 102) {
                    that.sportsListScroll.setMoreRecord(true);
                    that.sportsListScroll.pullback();
                }
                // fixed by lujf  2017-1-18 增加国标舞 start
                else if (that.learningType == 114) {
                    that.guobiaoListScroll.setMoreRecord(true);
                    that.guobiaoListScroll.pullback();
                }
                // fixed by lujf  2017-1-18 增加国标舞 end
                else {
                    that.listScroll.setMoreRecord(true);
                    that.listScroll.pullback();
                }
            });
        },

        // 获取本地数据
        getDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "";
            //if (that.learningType == 199) {// 内部教材
            //    getDataSql = "select BookId,BookName,BookImgStr,ClickCount from t_book where OrgId in("
            //        + that.orgIdStr + ") order by FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;
            //} else
            if (that.learningType == 102) {// 体育舞蹈
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount from t_book where BookType="
                    + that.learningType + " and BookAttribute>=" + that.sportsDanceType * 10 + " and BookAttribute<" + (that.sportsDanceType + 1) * 10 + " order by  FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;
            }
            // add by lujf 2017-1-18 增加国标舞 start
            else if(that.learningType ==114){// 国标舞
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount from t_book where BookType="
                    + that.learningType + " and BookAttribute>=" + that.guobiaoType * 10 + " and BookAttribute<" + (that.guobiaoType + 1) * 10 + " order by  FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;
            }
            // add by lujf 2017-1-18 增加国标舞 end
            else {// 其他
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount,IsInside from t_book where BookType="
                    + that.learningType + " order by IsInside desc ,FirstShow, UpdateTime desc limit " + pageIndex + "," + pageCount;
            }
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret_1) {
                if (typeof callback == 'function') {
                    callback(ret_1);
                }
            }, function () {
                errCallback();
            });
        },

        // 显示数据
        showData: function (dataList) {
            var showStr = "";
            var imgHeight = window.innerWidth * 0.2 * 0.92;
            //var bookImage = new Image();
            //var imgBgSize;
            // 体育舞蹈
            if (that.learningType == 102) {
                for (var i = 0; i < dataList.length; i++) {
                    //bookImage.src = dataList[i].BookImgStr;
                    //if (bookImage.width > bookImage.height) {
                    //    imgBgSize = "auto 100%";
                    //}
                    //else {
                    //    imgBgSize = "100%";
                    //}
                    showStr += '<div class="bookList_list_template bookList_list_click_dance" data="' + dataList[i].BookId + '" >'
                              + '      <div style="height:' + imgHeight + 'px;" class="bookList_item_left">'
                              + '           <img src="' + dataList[i].BookImgStr + '" onload="BookListCtrl.fixImageSize(this)"/>'
                              + '      </div>'
                              + '      <div class="bookList_item_content">'
                              + '          <div class="bookList_item_content_name">' + dataList[i].BookName + '</div>'
                              + '          <div class="bookList_item_content_playcount">'
                              + '              <img src="images/learn/play_count.png" />'
                              + '              <span>' + dataList[i].ClickCount + '</span>'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_item_right"  id="bookList_item_right_' + dataList[i].BookId + '">'
                              + '          <img src="images/learn/goto.png" />'
                              + '      </div>'
                              + '  </div>'
                              + '  <div class="bookList_item_type_div" style="display:none;" id="bookList_item_type_div_' + dataList[i].BookId + '">'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*7*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">一级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*8*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">二级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*9*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">三级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*10*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">四级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*11*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">五级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*12*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">六级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*13*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">七级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*14*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">八级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*3*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">铜牌</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*2*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">银牌</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*1*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">金牌</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*4*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">金星一</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*5*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">金星二</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_sportsDance" data="' + dataList[i].BookId + '*6*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">金星三</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '  </div>';
                }
                $("#bookList_sportsDance_template").append(showStr);
                if (dataList.length > 0) {
                    //绑定点击事件
                    CommonClickEvent(".bookList_list_click_dance", function (isClick, data) {
                        if (isClick) {
                            if (data != "") {
                                that.clickSportsDanceList(parseInt(data));
                            }
                        }
                    });
                    //绑定点击事件
                    CommonClickEvent(".bookList_list_clcik_type_sportsDance", function (isClick, data) {
                        if (isClick) {
                            if (data != "") {
                                var strs = new Array();
                                strs = data.split("*");
                                that.gotoSportsDanceDetail(parseInt(strs[0]), parseInt(strs[1]), strs[2], strs[3]);
                            }
                        }
                    });
                }

            }
            // 国标舞
            else if (that.learningType == 114) {
                for (var i = 0; i < dataList.length; i++) {
                    showStr += '<div class="bookList_list_template bookList_list_click_guobiao" data="' + dataList[i].BookId + '" >'
                              + '      <div style="height:' + imgHeight + 'px;" class="bookList_item_left">'
                              + '           <img src="' + dataList[i].BookImgStr + '" onload="BookListCtrl.fixImageSize(this)"/>'
                              + '      </div>'
                              + '      <div class="bookList_item_content">'
                              + '          <div class="bookList_item_content_name">' + dataList[i].BookName + '</div>'
                              + '          <div class="bookList_item_content_playcount">'
                              + '              <img src="images/learn/play_count.png" />'
                              + '              <span>' + dataList[i].ClickCount + '</span>'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_item_right"  id="bookList_item_right_' + dataList[i].BookId + '">'
                              + '          <img src="images/learn/goto.png" />'
                              + '      </div>'
                              + '  </div>'
                              + '  <div class="bookList_item_type_div" style="display:none;" id="bookList_item_type_div_' + dataList[i].BookId + '">'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*301*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">一级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*302*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">二级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*303*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">三级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*304*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">四级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*305*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">五级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*306*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">六级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*307*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">七级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*308*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">八级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*309*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '">'
                              + '          <div class="bookList_item_type_left">九级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*310*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">十级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*311*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">十一级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '      <div class="bookList_list_template bookList_list_clcik_type_guobiao" data="' + dataList[i].BookId + '*312*' + dataList[i].BookName + '*' + dataList[i].BookImgStr + '" >'
                              + '          <div class="bookList_item_type_left">十二级</div>'
                              + '          <div class="bookList_item_right">'
                              + '              <img src="images/learn/goto.png" />'
                              + '          </div>'
                              + '      </div>'
                              + '  </div>';
                }
                $("#bookList_guobiao_template").append(showStr);
                if (dataList.length > 0) {
                    //绑定点击事件
                    CommonClickEvent(".bookList_list_click_guobiao", function (isClick, data) {
                        if (isClick) {
                            if (data != "") {
                                that.clickSportsDanceList(parseInt(data));
                            }
                        }
                    });
                    //绑定点击事件
                    CommonClickEvent(".bookList_list_clcik_type_guobiao", function (isClick, data) {
                        if (isClick) {
                            if (data != "") {
                                var strs = new Array();
                                strs = data.split("*");
                                that.gotoSportsDanceDetail(parseInt(strs[0]), parseInt(strs[1]), strs[2], strs[3]);
                            }
                        }
                    });
                }
            }
            else {
                for (var k = 0; k < dataList.length; k++) {
                    //bookImage.src = dataList[k].BookImgStr;
                    //if (bookImage.width > bookImage.height) {
                    //    imgBgSize = "auto 100%";
                    //}
                    //else {
                    //    imgBgSize = "100%";
                    //}
                    showStr += '<div class="bookList_list_template bookList_list_clcik_musicList" data="' + dataList[k].BookId + '*' + dataList[k].BookName + '*' + dataList[k].BookImgStr + '" >'
                               + '    <div style="height:' + imgHeight + 'px;"  class="bookList_item_left">'
                               + '           <img src="' + dataList[k].BookImgStr + '" onload="BookListCtrl.fixImageSize(this)"/>'
                               + '      </div>'
                               + '     <div class="bookList_item_content">'
                               + '         <div class="bookList_item_content_name">' + dataList[k].BookName + '</div>'
                               + '         <div class="bookList_item_content_playcount">'
                               + '             <img src="images/learn/play_count.png"/>'
                               + '             <span>' + dataList[k].ClickCount + '</span>'
                               + '              <div  class="bookList_item_content_insidespan" style="display:' + (dataList[k].IsInside == 1 ? "inline-block" : "none") + '" >内部教材</div>'
                               + '         </div>'
                               + '     </div>'
                               + '     <div class="bookList_item_right">'
                               + '         <img src="images/learn/goto.png"/>'
                               + '     </div>'
                               + ' </div>';
                }
                $("#bookList_list_template").append(showStr);
                if (dataList.length > 0) {
                    //绑定点击事件
                    CommonClickEvent(".bookList_list_clcik_musicList", function (isClick, data) {
                        if (isClick) {
                            if (data != "") {
                                var strs = new Array();
                                strs = data.split("*");
                                that.gotoMusicList(parseInt(strs[0]), strs[1], strs[2]);
                            }
                        }
                    });
                }
            }
        },

        // 改变图片大小
        fixImageSize: function (img) {
            //$('.bookList_item_left').height($('.bookList_item_left').width());
            var imgWidth = $(img).width();
            var imgHeight = $(img).height();
            var containerWidth = $('.bookList_item_left').height();
            var containerHeight = $('.bookList_item_left').height();
            //false：图片宽高比小于容器宽高比，true：图片宽高比大于容器宽高比
            var flag = imgWidth * containerHeight > containerWidth * imgHeight ? true : false;
            if (flag == true) {
                $(img).css("height", "100%");
                //图片左右居中
                $(img).css("margin-left", "-" + (imgWidth * containerHeight / imgHeight - containerWidth) / 2 + "px");
            }
            else {
                $(img).css("width", "100%");
                //图片上下居中
                $(img).css("margin-top", "-" + (imgHeight * containerWidth / imgWidth - containerHeight) / 2 + "px");
            }
        },

        // 点击体育舞蹈列表
        clickSportsDanceList:function(bookId){
            if ($("#bookList_item_type_div_" + bookId).css("display") == "none") {
                $("#bookList_item_right_" + bookId ).html('<img src="images/learn/goto_2.png"/>');
                $("#bookList_item_type_div_" + bookId).show();
            }
            else {
                $("#bookList_item_right_" + bookId).html('<img src="images/learn/goto.png"/>');
                $("#bookList_item_type_div_" + bookId).hide();
            }
        },

        // 进入体育舞蹈视频列表
        gotoSportsDanceDetail:function(bookId,videoType,bookNm,bookImg){
            // 传递参数
            var bookInfo = JSON.stringify({ BookId: bookId, BookName: bookNm, BookType: that.learningType, BookImg: bookImg, VideoType: videoType });
            Cache.setCache("MusicList_bookInfo", bookInfo);
            toPage('pnl_musicList');
        },

        // 选择体育舞蹈类别
        chooseSportsDanceType: function (sportsDanceType) {
            if (that.sportsDanceType == sportsDanceType) {
                return;
            }
            that.sportsDanceType = sportsDanceType;
            $(".bookList_sportsDanceType_div div").removeClass("bookList_sportsDanceType_border");
            $("#bookList_sportsDanceType_" + sportsDanceType).addClass("bookList_sportsDanceType_border");
            that.loadList();
        },

        // 选择国标舞蹈类别 add by lujf 2017-1-18
        chooseGuobiaoType:function (guobiaoType){
            if (that.guobiaoType == guobiaoType) {
                return;
            }
            that.guobiaoType = guobiaoType;
            $(".bookList_guobiaoType_div div").removeClass("bookList_guobiaoType_border");
            $("#bookList_guobiaoType_" + guobiaoType).addClass("bookList_guobiaoType_border");
            that.loadList();
        },

        // 点击类别
        clickType: function () {
            $(".bookList_bookType_div").toggle();
            // 体育舞蹈
            if (that.learningType == 102) {
                $("#bookList_sportsDance_bookList").height(window.innerHeight - $(".bookList_sportsDanceType_div").offset().top - $(".bookList_sportsDanceType_div").height() - 10);
            }
            // 国标舞 add by lujf 2017-1-18
            else if (that.learningType == 114) {
                $("#bookList_guobiao_bookList").height(window.innerHeight - $(".bookList_guobiaoType_div").offset().top - $(".bookList_guobiaoType_div").height() - 10);
            }
            else {
                $("#bookList_bookList_panel").height(window.innerHeight - $("#bookList_bookList_panel").offset().top);
            }
        },

        // 选择类别
        chooseType: function (bookType,bookName) {
            if (that.pageType == "Music" || that.pageType == "Staff") {// 如果是乐器示范或曲谱搜索
                Cache.setDbCache("MusicLearningType", JSON.stringify({ id: bookType, name: bookName }));
            } else {// 如果是舞蹈示范
                Cache.setDbCache("DanceLearningType", JSON.stringify({ id: bookType, name: bookName }));
            }

            that.learningType = bookType;
            $("#bookList_title").html(bookName);
            $(".bookList_title_type_img").show();
            $(".bookList_bookType_div").toggle();
            // 体育舞蹈
            if (bookType == 102) {
                that.sportsDanceType = 1021;
                $("#bookList_header_right").hide();
                $("#bookList_bookList_panel").hide();
                $("#bookList_guobiao_panel").hide();// add by lujf 2017-1-18
                $(".bookList_sportsDanceType_div div").removeClass("bookList_sportsDanceType_border");
                $("#bookList_sportsDanceType_" + that.sportsDanceType).addClass("bookList_sportsDanceType_border");
                $("#bookList_sportsDance_panel").show();
                $("#bookList_sportsDance_bookList").height(window.innerHeight - $(".bookList_sportsDanceType_div").offset().top - $(".bookList_sportsDanceType_div").height() - 10);
            }
            // 国标舞 add by lujf 2017-1-18
            else if (bookType == 114) {
                that.guobiaoType = 1141;
                $("#bookList_header_right").hide();
                $("#bookList_bookList_panel").hide();
                $("#bookList_sportsDance_panel").hide();
                $(".bookList_guobiaoType_div div").removeClass("bookList_guobiaoType_border");
                $("#bookList_guobiaoType_" + that.guobiaoType).addClass("bookList_guobiaoType_border");
                $("#bookList_guobiao_panel").show();
                $("#bookList_guobiao_bookList").height(window.innerHeight - $(".bookList_guobiaoType_div").offset().top - $(".bookList_guobiaoType_div").height() - 10);
            }
            else {
                if (that.learningType == 115) {
                    $("#bookList_header_right").hide();
                }
                else {
                    $("#bookList_header_right").show();
                }
                $("#bookList_bookList_panel").show();
                $("#bookList_sportsDance_panel").hide();
                $("#bookList_guobiao_panel").hide();// add by lujf 2017-1-18
                $("#bookList_bookList_panel").height(window.innerHeight - $("#bookList_bookList_panel").offset().top);
            }
           
            // 执行搜索列表
            that.loadList();
        },

        // 跳转到搜索页面
        gotoSearch: function () {
            Cache.setCache("BookSearch_learningType", that.learningType);
            toPage('pnl_bookSearch');
        },

        // 跳转到明细页面
        gotoMusicList: function (bookId, bookNm, bookImg) {
            // 传递参数
            var bookInfo = JSON.stringify({ BookId: bookId, BookName: bookNm, BookType: that.learningType, BookImg: bookImg, VideoType: 0 });
            Cache.setCache("MusicList_bookInfo", bookInfo);
            toPage('pnl_musicList');
        },

        // 点击返回
        goBack: function () {
            // 初始化页面
            $(".bookList_title_type_img").hide();
            $(".bookList_bookType_div").hide();
            $.ui.goBack();
        }
    };
    return new obj();
})();