﻿var BookSearchCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.searchInfo = "";
            that.bookList = [];

            $("#bookSearch_searchStr").val("");
            $("#bookSearch_content_template").html("");
            $("#bookSearch_content_panel").css("opacity", "0");

            // 初始化scroller
            $("#bookSearch_content_div").height(window.innerHeight - $("#bookSearch_content_div").offset().top-12);
            that.listScroll = new devAfScroller("bookSearch_content_div", { refresh: false });

            // 获取学习类别
            that.learningType = Cache.getCache("BookSearch_learningType");

            // 定义窗口大小变更事件
            $(window).resize(function () {
                $(".bookSearch_content_bookImg img").height(window.innerWidth * 0.28 * 0.95);
                $("#bookSearch_content_div").height(window.innerHeight - $("#bookSearch_content_div").offset().top - 10);
            });
            that.listScroll.scrollTo({ x: 0, y: 0 });
        },


        // 点击搜索
        doSearch: function () {
            that.listScroll.scrollTo({ x: 0, y: 0 });
            that.searchInfo = $("#bookSearch_searchStr").val();
            // 搜索内容为空时
            if (that.searchInfo == "") {
                $("#bookSearch_content_panel").css("opacity","10");
                $("#bookSearch_content_template").html("");
                that.bookList = [];
                return;
            }
            //根据关键字搜索数据
            var getDataSql = "";
            if (that.learningType == 199) {// 内部教材
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount from t_book where BookName like '%" + that.searchInfo + "%' and OrgId="
                    + 0 + " order by FirstShow, UpdateTime desc ";
            }
            else {// 其他
                getDataSql = "select BookId,BookName,BookImgStr,ClickCount,IsInside from t_book where BookName like '%" + that.searchInfo + "%' and BookType="
                    + that.learningType + " order by IsInside desc , FirstShow, UpdateTime desc";
            }
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                $("#bookSearch_content_panel").css("opacity", "10");
                $("#bookSearch_content_template").html("");
                that.bookList = ret;
                that.showData();
            }, function () {
            });
        },

        // 显示数据
        showData:function(){
            var showStr = "";
            var imgHeight=window.innerWidth * 0.28 * 0.95;
            var item;
            var imgBgSize;
            
            for (var i = 0; i < that.bookList.length; i++) {
                item = that.bookList[i];
                debugger;
                //showStr += '<div class="bookSearch_content_template " onclick="BookSearchCtrl.gotoMusicList(' + item.BookId + ',\'' + item.BookName + '\',\'' + item.BookImgStr + '\')">'
                //FixedStart byzhusj 2016/11/4
                showStr += '<div class="bookSearch_content_template bookSearch_click_class" data="' + item.BookId + '*' + item.BookName + '*' + item.BookImgStr + '">'
                //FixedEnd
                            + '      <div class="bookSearch_content_bookImg"  style="height:' + imgHeight + 'px;">'
                            + '           <img src="' + item.BookImgStr + '" onload="BookSearchCtrl.fixImageSize(this)"/>'
                            + '      </div>'
                            + '      <div class="bookSearch_content_bookNm">' + item.BookName + '</div>'
                            + '  </div>';
                
              
            }
            $("#bookSearch_content_template").html(showStr);
           
            //FixedStart byzhusj 2016/11/4
            CommonClickEvent(".bookSearch_click_class", function (isClick, value) {
                if (isClick) {
                    var index1 =value.split("*")[0];
                    var index2 =value.split("*")[1];
                    var index3 =value.split("*")[2];
                    that.gotoMusicList(index1,index2,index3);
                }
            });
            //FixedEnd
        },

        // 进入视频列表页面
        gotoMusicList: function (bookId, bookNm, bookImg) {
            // 传递参数
            var bookInfo = JSON.stringify({ BookId: bookId, BookName: bookNm, BookType: that.learningType, BookImg: bookImg, VideoType: 0 });
            Cache.setCache("MusicList_bookInfo", bookInfo);
            toPage('pnl_musicList');
        },

        // 点击返回按钮
        goBack: function () {
            inputPageBack();
        },
        // 改变图片大小
        fixImageSize: function (img) {
            //$('.bookList_item_left').height($('.bookList_item_left').width());
            var imgWidth = $(img).width();
            var imgHeight = $(img).height();
            var containerWidth = $('.bookSearch_content_bookImg').width();
            var containerHeight = $('.bookSearch_content_bookImg').height();
            //false：图片宽高比小于容器宽高比，true：图片宽高比大于容器宽高比
            var flag = imgWidth * containerHeight > containerWidth * imgHeight ? true : false;
            if (flag == true) {
                $(img).css("height", "100%");
                //图片左右居中
                $(img).css("margin-left", "-" + (imgWidth * containerHeight / imgHeight - containerWidth) / 2 + "px");
            }
            else {
                $(img).css("width", "100%");
                //图片上下居中
                $(img).css("margin-top", "-" + (imgHeight * containerWidth / imgWidth - containerHeight) / 2 + "px");
            }
        },
    };
    return new obj();
})();