﻿var MusicListCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            $("#musicList_videoList_template").html("");
            $(".musicList_bookImg").css('background-image', 'none');
            $("#musicList_title").html("");

            // 设置图片高度
            $(".musicList_bookImg").height(window.innerWidth / 5 * 3);
            // 设置isroll高度
            $("#musicList_videoList_panel").height(window.innerHeight - $("#musicList_videoList_panel").offset().top);

            // 获取登录信息
             that.loginInfo = Cache.getCache("LoginUserInfo");

            // 获取参数
            that.bookInfo = [];
            var bookInfo = Cache.getCache("MusicList_bookInfo");
            if (bookInfo) {
                that.bookInfo = JSON.parse(bookInfo);
                //FixedStart byzhusj 2016/10/27
                // 显示数据               
                $("#musicList_title").html(that.bookInfo.BookName.split("", 12));
                //FixedEnd
                // 判断图片大小
                var bookImage = new Image();
                bookImage.src = that.bookInfo.BookImg;
                if (bookImage.width * 3 > bookImage.height * 5) {
                    $(".musicList_bookImg").css('background-size', 'auto 100%');
                } else {
                    $(".musicList_bookImg").css('background-size', '100%');
                }
                $(".musicList_bookImg").css('background-image', 'url('+that.bookInfo.BookImg+')');
            }

            // 初始化Scroller
            that.listScroll = new devAfScroller("musicList_videoList_panel", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });

            // 定义窗口大小变更事件
            //$(window).resize(function () {
            //    $(".musicList_bookImg").height(window.innerWidth / 5 * 3);
            //    $("#musicList_videoList_panel").height(window.innerHeight - $("#musicList_videoList_panel").offset().top);
            //});

            that.videoList = [];

            that.listScroll.scrollTo({ x: 0, y: 0 });
            that.loadList();
        },

        // 刷新List
        loadList: function () {
            // 判断视频表是否初始化
            var checkInitSql;
            // 体育舞蹈
            if (that.bookInfo.BookType == 102 || that.bookInfo.BookType == 114) {
                checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_video_" + that.bookInfo.BookId + "_" + that.bookInfo.VideoType + "'";
            }
            else {
                checkInitSql = "select last_update_time from t_manage where tbl_nm ='t_video_" + that.bookInfo.BookId + "'";
            }
            
            db.fetchAll(checkInitSql, function (ret) {
                if (ret.length == 0) {// 没有初始化
                    Util.ajax({
                        method: "POST",
                        data: {
                            isInit: true,
                            bookId: that.bookInfo.BookId,
                            userId: that.loginInfo.UserId,
                            lastUpdateTime: "",
                            videoType: that.bookInfo.VideoType,
                            userType: that.loginInfo.UserType
                        },
                        url: Util.getApiUrl("VideoList")
                    }, function (data) {
                        //  清空列表
                        $("#musicList_videoList_template").html("");
                        // 将取到的数据放到本地数据库
                        if (data.length > 0) {
                            var dataList = []; 
                            var pageType = Cache.getCache("BookList_PageType");
                            if (pageType == "Music") {
                                for (var i = 0; i < data.length; i++) {
                                    if (data[i].IsShow) {
                                        dataList.push(data[i]);
                                        if (dataList.length>=10) {
                                            break;
                                        }
                                    }
                                }
                            } else {
                                dataList = data.slice(0, 10);
                            }

                            that.videoList = dataList;
                            // 显示数据
                            that.showData(dataList);
                            // 设置scroller
                            that.listScroll.setMoreRecord(dataList.length == 10 ? true : false);
                            that.listScroll.pullback();

                            // 将数据保存到本地数据库
                            var sql = "";
                            for (var i = 0; i < data.length; i++) {
                                sql = "insert into t_video(VideoId,BookId,VideoName,VideoType,VideoImgStr,Gold,UploadGold,ClickCount,FirstShow,IsCollected,UpdateTime,CreateTime,IsShow)" +
                                   " values (" + data[i].VideoId + ","
                                   + data[i].BookId + ",'"
                                   + data[i].VideoName + "',"
                                   + data[i].VideoType + ",'"
                                   + data[i].VideoImgStr + "',"
                                   + data[i].Gold + ","
                                   + data[i].UploadGold + ","
                                   + data[i].ClickCount + ","
                                   + data[i].FirstShow + ","
                                   + (data[i].IsCollected ? 1 : 0) + ",'"
                                   + data[i].UpdateTimeDateStr + "','"
                                   + data[i].CreateTimeDateStr + "',"
                                   + (data[i].IsShow ? 1 : 0) + ")";//Fixed By liyl 2016/11/3 添加是否显示
                                   db.query(sql);
                            }
                            // 保存最后更新时间
                            if (that.bookInfo.BookType == 102 || that.bookInfo.BookType == 114) {
                                sql = "insert into t_manage(tbl_nm,last_update_time) values('t_video_" + that.bookInfo.BookId + "_" + that.bookInfo.VideoType + "','" + data[0].LastUpdateTimeStr + "')";
                            }
                            else {
                                sql = "insert into t_manage(tbl_nm,last_update_time) values('t_video_" + that.bookInfo.BookId + "','" + data[0].LastUpdateTimeStr + "')";
                            }
                            
                            db.query(sql);
                        } else {
                            // 清空数据
                            that.videoList = [];
                        }
                    });
                }
                else {// 已经初始化
                    that.getDataList(0, 10, function (dataList) {
                        //  清空列表
                        $("#musicList_videoList_template").html("");
                        that.videoList = dataList;
                        // 显示数据
                        that.showData(dataList);
                        // 设置scroller
                        that.listScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listScroll.pullback();
                        // 进行数据同步
                        Util.ajax({
                            method: "POST",
                            data: {
                                isInit: false,
                                bookId: that.bookInfo.BookId,
                                userId: that.loginInfo.UserId,
                                lastUpdateTime: ret[0].last_update_time,
                                videoType: that.bookInfo.VideoType,
                                userType: that.loginInfo.UserType
                            },
                            url: Util.getApiUrl("VideoList")
                        }, function (data) {
                            // 将取到的数据同步本地数据库
                            var it;
                            if (data.length > 0) {
                                for (var i = 0; i < data.length; i++) {
                                    it = data[i];
                                    //验证数据是否已存在

                                        var checkSql = "select count(*) as ct from t_video where VideoId = " + it.VideoId;
                                        db.fetchAll(checkSql, function (ret) {
                                            if (ret[0].ct > 0) {
                                                //  删除
                                                if (it.IsDeleted || it.VideoStatus == enumKey.VideoStatus.OffSale) {
                                                    var delsql = "delete from t_video where VideoId=" + it.VideoId;
                                                    db.query(delsql);
                                                } else {
                                                    // 更新
                                                    var updatesql = "update t_video set BookId = " + it.BookId
                                                                + ",VideoName = '" + it.VideoName
                                                                + "',VideoType = " + it.VideoType
                                                                + ",VideoImgStr = '" + it.VideoImgStr
                                                                + "',Gold = " + it.Gold
                                                                + ",UploadGold = " + it.UploadGold
                                                                + ",ClickCount = " + it.ClickCount
                                                                + ",FirstShow = " + it.FirstShow
                                                                + ",IsCollected = " + (it.IsCollected ? 1 : 0)
                                                                + ",UpdateTime = '" + it.UpdateTimeDateStr
                                                                + "',IsShow = " + (it.IsShow ? 1 : 0)
                                                                + " where VideoId = " + it.VideoId;
                                                    db.query(updatesql);
                                                }
                                            } else {
                                                // 新增
                                                if (it.IsDeleted == false && it.VideoStatus == enumKey.VideoStatus.OnSale) {
                                                    var insertsql = "insert into t_video(VideoId,BookId,VideoName,VideoType,VideoImgStr,Gold,UploadGold,ClickCount,FirstShow,IsCollected,UpdateTime,CreateTime,IsShow)" +
                                                        " values (" + it.VideoId + ","
                                                        + it.BookId + ",'"
                                                        + it.VideoName + "',"
                                                        + it.VideoType + ",'"
                                                        + it.VideoImgStr + "',"
                                                        + it.Gold + ","
                                                        + it.UploadGold + ","
                                                        + it.ClickCount + ","
                                                        + it.FirstShow + ","
                                                        + (it.IsCollected ? 1 : 0) + ",'"
                                                        + it.UpdateTimeDateStr + "','"
                                                        + it.CreateTimeDateStr + "',"
                                                        + (it.IsShow ? 1 : 0) + ")";
                                                    db.query(insertsql);
                                                }
                                            }
                                        });
                                    
                                }
                                var sql = "";
                                // 保存最后更新时间
                                if (that.bookInfo.BookType == 102 || that.bookInfo.BookType == 114) {
                                    //fixedby lijq 2016/12/8
                                    //sql = "insert into t_manage(tbl_nm,last_update_time) values('t_video_" + that.bookInfo.BookId + "_" + that.bookInfo.VideoType + "','" + data[0].LastUpdateTimeStr + "')";
                                    sql = "update t_manage set last_update_time='" + data[0].LastUpdateTimeStr + "' where tbl_nm='t_video_" + that.bookInfo.BookId + "_" + that.bookInfo.VideoType + "'";
                                }
                                else {
                                    //sql = "insert into t_manage(tbl_nm,last_update_time) values('t_video_" + that.bookInfo.BookId + "','" + data[0].LastUpdateTimeStr + "')";
                                    sql = "update t_manage set last_update_time='" + data[0].LastUpdateTimeStr + "' where tbl_nm='t_video_" + that.bookInfo.BookId + "'";
                                }
                                db.query(sql);
                            }
                        });
                    }, function () {
                        // 设置scroller
                        that.listScroll.setMoreRecord(true);
                        that.listScroll.pullback();
                    });
                }
            });

        },

        // 加载更多
        loadMore:function(){
            // 取出本地数据
            that.getDataList(that.videoList.length, 10, function (dataList) {
                that.videoList = that.videoList.concat(dataList);
                that.showData(dataList);
                // 设置scroller
                that.listScroll.setMoreRecord(dataList.length == 10 ? true : false);
                that.listScroll.pullback();
            }, function () {
                // 设置scroller
                that.listScroll.setMoreRecord(true);
                that.listScroll.pullback();
            });
        },

        // 显示数据
        showData: function (dataList) {
            var showStr = "";
            var item;
            for (var i = 0; i < dataList.length; i++) {
                item = dataList[i];
                showStr += '<div class="musicList_videoList_template">'
                           + '<div class="musicList_videoList_videoNm">' + item.VideoName + '</div>';
                if (that.loginInfo.UserType == enumKey.UserType.Student) {
                    //FixedStart by lijq 2016/11/4 修改点击事件
                    showStr += '<div class="musicList_homework_btn" id="musicList_homework_btn_' + item.VideoId + '" data="' + item.VideoId + '*' + item.VideoName + '">'
                          + '<img src="images/learn/upload_grey.png" />'
                          + '</div>';
                }
                showStr += '<div class="musicList_videoList_btn" id="musicList_videoList_btn_' + item.VideoId + '" data="' + item.VideoId + '">'
                          + (item.IsCollected ? '<img src="images/learn/collect.png" />' : '<img src="images/learn/uncollect.png" />')
                          + '</div>'
                          + '<div class="musicList_look_btn" id="musicList_look_btn_' + item.VideoId + '" data="' + item.VideoId + '*' + item.VideoName + '">'
                          + '<img src="images/learn/view_grey.png" />'
                          + '</div>'
                          + '</div>';
              
            }
            $("#musicList_videoList_template").append(showStr);
            //FixedStart by lijq 2016/11/4  添加交作业点击事件 
            CommonClickEvent(".musicList_homework_btn", function (isClick, value) {
                if (isClick) {
                    var index = value.split("*");
                    that.uploadHomework(index[0], index[1]);
                }
            });
            //添加收藏点击击事件 
            CommonClickEvent(".musicList_videoList_btn" , function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.collectVideo(index);
                }
            });
            //添加查看明细点击事件 
            CommonClickEvent(".musicList_look_btn" , function (isClick, value) {
                if (isClick) {
                    var index=value.split("*");
                    that.goToDetail(index[0], index[1]);
                }
            });
            //FixedEnd
        },

        // 获取数据
        getDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "";
            //FixedStart By liyl 2016/11/3 乐器示范判断是否显示
            var pageType = Cache.getCache("BookList_PageType");
            if (pageType == "Music") {
                getDataSql = "select VideoId,VideoName,IsCollected,VideoType from t_video where IsShow = 1 and BookId=" + that.bookInfo.BookId
               + (that.bookInfo.VideoType == 0 ? "" : " and VideoType=" + that.bookInfo.VideoType)
               + " order by FirstShow,  UpdateTime desc limit " + pageIndex + "," + pageCount;
            } else {
                getDataSql = "select VideoId,VideoName,IsCollected,VideoType from t_video where BookId=" + that.bookInfo.BookId
               + (that.bookInfo.VideoType == 0 ? "" : " and VideoType=" + that.bookInfo.VideoType)
               + " order by FirstShow,  UpdateTime desc limit " + pageIndex + "," + pageCount;
            }
            //FixedEnd By liyl 2016/11/3 乐器示范判断是否显示
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                if (typeof callback == 'function') {
                    callback(ret);
                }
            }, function () {
                errCallback();
            });
        },

        // 上传作业
        uploadHomework: function (videoId,videoName) {
            var videoInfo = {
                BookId: that.bookInfo.BookId,
                BookName: that.bookInfo.BookName,
                BookType: that.bookInfo.BookType,
                VideoId: videoId,
                VideoName: videoName
            };
            // fixed by lujf 2016-11-23 区分上传的是舞蹈作业还是乐器作业
            var pageType = Cache.getCache("BookList_PageType");
            if (pageType == "Music") {
                showHomeworkPop(videoInfo, function () { });// fixed by lujf 2016-12-1 添加回调函数参数
            } else {
                toUploadVideo(videoInfo, function () { });// fixed by lujf 2016-12-1 添加回调函数参数

            }
        },

        // 收藏视频
        collectVideo: function (videoId) {
            // 判断是否收藏
            var checkSql = "select IsCollected from t_video where VideoId=" + videoId;
            db.fetchAll(checkSql, function (ret) {
                if (ret.length > 0) {
                    if (ret[0].IsCollected) {
                        Util.info("视频已收藏", false);
                        return;
                    }
                }
                // 去后台更新数据
                Util.ajax({
                    method: "POST",
                    data: {
                        userId: that.loginInfo.UserId,
                        videoId: videoId,
                        userType: that.loginInfo.UserType
                    },
                    url: Util.getApiUrl("CollectVideo")
                }, function (data) {
                    if (data.ResponseCode == enumKey.RespCode.Success) {
                        Util.info(data.ResponseMessage, true);
                        // 页面显示变更
                        $("#musicList_videoList_btn_" + videoId).html('<img src="images/learn/collect.png" />');
                        // 更新本地数据库
                        var updateSql = "update t_video set IsCollected = 1 where VideoId =" + videoId;
                        db.query(updateSql);
                    }
                    else {
                        Util.info(data.ResponseMessage, false);
                    }
                });
            });
        },

        // 进入明细页面
        goToDetail: function (videoId,videoName) {
            var videoInfo = JSON.stringify({
                BookId: that.bookInfo.BookId,
                BookName: that.bookInfo.BookName,
                BookType: that.bookInfo.BookType,
                VideoId: videoId,
                VideoName: videoName
            });// fixed by lujf 2016-11-23 增加参数
            if (that.bookInfo.BookType == 102 || that.bookInfo.BookType == 111 || that.bookInfo.BookType == 112 || that.bookInfo.BookType == 113 || that.bookInfo.BookType == 114)
            {
                lookVideo(videoId, function (result) {
                    if (result) {
                        Cache.setCache("DanceVideoDetail_videoInfo", videoInfo);
                        toPage('pnl_danceVideoDetail');
                    }
                });
            }
            else {
                var pageType = Cache.getCache("BookList_PageType");
                if (pageType == "Staff") {
                    Cache.setCache("StaffDetail_videoInfo", videoInfo);
                    toPage('pnl_staffDetail');
                } else {
                    lookVideo(videoId, function (result) {
                        if (result) {
                            Cache.setCache("MusicVideoDetail_videoInfo", videoInfo);
                            toPage('pnl_musicVideoDetail');
                        }
                    });
                }
            }
        },

        // 点击返回
        goBack: function () {
           
            $.ui.goBack();
        }

    };
    return new obj();
})();