﻿var ForgotpasswordCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            $("#password_tel_input").val("");
            $("#register_authcode_input").val("");
            that.IsStartTiming = false;
            document.getElementById('password_authcode_button').innerHTML = "获取验证码";
            document.getElementById('password_authcode_button').style.background = "#FF4D4D";
            // add by lijq 2016-12-21 屏蔽表情 start
            $("#password_tel_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("password_tel_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#password_tel_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#password_tel_input").val(content);
                }
            };
            $("#password_authcode_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("password_authcode_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#password_authcode_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#password_authcode_input").val(content);
                }
            };
            // add by lijq 2016-12-21 屏蔽表情 end

        },

        //发送短信验证码
        SendAuthcode: function () {

            if (!that.IsStartTiming) {
                var Phone = $("#password_tel_input").val().trim();
                if (!Phone) {
                    Util.info("请输入手机号", false);
                    return;
                }
                if (!Util.isMobile(Phone)) {
                    Util.info("请输入有效的手机号", false);
                    return;
                }
                Util.ajax({
                    method: "POST",
                    data: {
                        phone: Phone,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("SendAuthcode")
                }, function (data) {
                    if (data == "SUCCESS") {
                        Util.info("发送验证码成功", true);
                        that.currPhone = Phone;
                        that.showTime();
                    }
                });
            }

        },
        //显示倒计时
        showTime: function () {
            that.IsStartTiming = true;
            //计时器
            that.leftSeconds = 60;
            that.cdtime = setInterval(function () {
                that.leftSeconds--;
                document.getElementById('password_authcode_button').innerHTML = that.leftSeconds + "s后重新获取";
                document.getElementById('password_authcode_button').style.background = "#A2A2A2";
                if (that.leftSeconds <= 0) {
                    that.IsStartTiming = false;
                    clearInterval(that.cdtime);
                    document.getElementById('password_authcode_button').innerHTML = "获取验证码";
                    document.getElementById('password_authcode_button').style.background = "#FF4D4D";
                }
            }, 1000);
        },
        NextPassword: function () {

            if (!that.currPhone) {
                Util.info("请获取验证码", false);
                return;
            }
            var Authcode = $("#password_authcode_input").val().trim();
            if (!Authcode) {
                Util.info("请输入您收到的5位验证码", false);
                return;
            }
            Util.ajax({
                method: "POST",
                data: {
                    phone: that.currPhone,
                    authcode: Authcode,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("CheckAuthcode")
            }, function (data) {

                if (data == enumKey.CheckAuthcodeEnum.Success) {
                    Cache.setCache("PasswordPhone", that.currPhone);
                    toPage('pnl_modifypassword');
                } else if (data == enumKey.CheckAuthcodeEnum.Wrong) {
                    Util.info("您输入的验证码错误，请重新输入", false);
                    $("#register_authcode_input").val("");
                } else if (data == enumKey.CheckAuthcodeEnum.TimeOut) {
                    Util.info("您输入的验证码已过期，请重新输入", false);
                    $("#register_authcode_input").val("");
                }
            });
        },
        passworkBack: function () {
            if (that.IsStartTiming) {
                clearInterval(that.cdtime);
            }
            $.ui.goBack();
        }
    };
    return new obj();
})();