﻿var LoginCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
             $("#login_user_input").val("");
             $("#login_password_input").val("");
             $("#login_bottom_box").show();
             that.init();
        },
        init : function(){
            var loginCount = 0;
            //QQ登录判别是否安装app
            //显示按钮
            function successCallback() {
                $("#qq_button").show();
            }
            //未安装需隐藏按钮
            function errorCallback() {
                //loginCount = loginCount+1;
                //$("#qq_button").hide();
            }
            if (typeof (YCQQ) != "undefined") {
                YCQQ.checkClientInstalled(successCallback, errorCallback);
            } else {
                //oginCount = loginCount + 1;
                //$("#qq_button").hide();
            }

            //wechat登录判别是否安装app
            //显示按钮
            function onSuccess(result) {
                if (result) {
                    $("#wechat_button").show();
                } else {
                    //loginCount = loginCount + 1;
                    $("#wechat_button").hide();
                }
            }

            function onError() {

            }
            if (typeof (Wechat) != "undefined") {
               Wechat.isInstalled(onSuccess, onError);
            } else {
                //loginCount = loginCount + 1;
                $("#wechat_button").hide();
            }
            ////如果两个按钮都隐藏
            //if (loginCount >= 2) {
            //    $("#login_bottom_box").hide();
            //}
        },


        doLogin: function () {
            var tel = $("#login_user_input").val().trim();
            var pwd = $("#login_password_input").val().trim();
            if (!tel) {
                Util.info("请输入您的账号",false);
                return;
            }
            if (!pwd) {
                Util.info("请输入您的密码",false);
                return;
            }
            Util.ajaxL({
                method: "POST",
                data: {
                    userTel: tel,
                    password: pwd,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("Login"),
                timeout: 12000
            }, function (data) {
                document.activeElement.blur();//软键盘隐藏 byzhusj 2016/12/13
                //登录成功
                if (data.ResponseCode == 0) {
                    //获取token
                    if (typeof navigator.xg != "undefined") {
                        navigator.xg.getToken(function (token) {
                            if (data.LoginUser.DeviceToken != token) {
                                Util.ajax({
                                    method: "POST",
                                    data: {
                                        token: token,
                                        userId: data.LoginUser.UserId,
                                        userType: enumKey.HappyMusic.CurrUserVersion
                                    },
                                    url: Util.getApiUrl("SetDeviceToken")
                                }, function () {
                                });

                            }
                        }, function () { });
                    }

                    Cache.setCache("LoginUserInfo", data.LoginUser);
                    Cache.setDbCache("LoginUserInfo", data.LoginUser);
                    //if (enumKey.HappyMusic.CurrUserVersion == enumKey.UserType.Student) {
                    //    if (data.LoginUser.UserType != enumKey.HappyMusic.CurrUserVersion) {
                    //        Util.info("此账号注册的是老师端，请在老师端登录使用", false);
                    //        toPage("pnl_login");
                    //    } else {
                    //        toPage("pnl_main");
                    //    }
                    //}
                    //else if (enumKey.HappyMusic.CurrUserVersion == enumKey.UserType.Teacher) {
                    //    if (data.LoginUser.UserType != enumKey.HappyMusic.CurrUserVersion) {
                    //        Util.info("此账号注册的是学生端，请在学生端登录使用", false);
                    //        toPage("pnl_login");
                    //    } else {
                    //        toPage("pnl_mainTe");
                    //    }
                    //}
                    if (data.LoginUser.UserType == enumKey.UserType.Student) {
                        $("#stu_foot_help_div").attr("src", "images/main/st_help_unselect.png");
                        $("#stu_foot_help_div_lable").css('color', '#707070');
                        $("#stu_foot_main_div").attr("src", "images/main/st_main_select.png");
                        $("#stu_foot_main_div_lable").css('color', '#FF4D4D');
                        toPage("pnl_main");
                    } else if (data.LoginUser.UserType == enumKey.UserType.Teacher) {
                        $("#tec_foot_work_div").attr("src", "images/main/tec_work_unselect.png");
                        $("#tec_foot_me_div").attr("src", "images/main/tec_me_unselect.png");
                        $("#tec_foot_work_div_lable").css('color', '#707070');
                        $("#tec_foot_me_div_lable").css('color', '#707070');
                        $("#stu_foot_main_div").attr("src", "images/main/st_main_select.png");
                        $("#stu_foot_main_div_lable").css('color', '#FF4D4D');
                        toPage("pnl_mainTe");
                    }
                    //初始化边页
                    sidePage = new SidePage("#sidePageId", "tpl/person/MyCenter.html", {
                        width: "70%",
                        height: "100%",
                        onload: MyCenterCtrl_load,
                        onShow: MyCenterCtrl_load
                    });

                } else {
                    Util.info(data.ResponseMessage,false);
                }
            });
        },
        //第三方登录
        thirdLogin : function(third_type){
	     //that.QuickLogin("FCDC4CEE0C52972F90823C3C81885418",1);
	    //qq登录
        if(third_type==1){
            if (!YCQQ) {
                Util.info("您还没有登录QQ",false);
                return;
            }	 
            var checkClientIsInstalled = 1;//default is 0,only for iOS
            YCQQ.ssoLogin(function(args){
                that.QuickLogin(args.userid,1);
            },function(failReason){
                //Util.info("登录失败，请重试"+failReason,false);
            },checkClientIsInstalled);
			
        }else if (third_type==2){ //微信登录
            if (!Wechat) {
                Util.info("您还没有登录微信",false);
                return;
            }
            Wechat.isInstalled(function () { }, function () {
                Util.info("您没有安装微信", false);
                return;
            });
            Wechat.auth(function (res) {
                Wechat.getWxInfoByAuth(res,function(result){
                    that.QuickLogin(result.openid,2);
                },function(err){
                    //Util.info("登录失败，请重试",false);
                });
            }, function (error) {
                //Util.info("登录失败，请重试"+error,false);
            });
        }
		 
    },
	
    //快捷登录
    QuickLogin : function(userOrOpenId,loginType){

        Util.ajaxL({
            method: "POST",
            data: {
                UserOrOpenId: userOrOpenId,
                LoginType: loginType,
                userType: enumKey.HappyMusic.CurrUserVersion
            },
            url: Util.getApiUrl("QQorWXRegist_Login"),
            timeout: 12000
        }, function (data) {
            //登录成功
            if (data.ResponseCode == 0) {
                Cache.setCache("LoginUserInfo", data.LoginUser);
                Cache.setDbCache("LoginUserInfo", data.LoginUser);
                //if (enumKey.HappyMusic.CurrUserVersion == enumKey.UserType.Student) {
                //    if (data.LoginUser.UserType != enumKey.HappyMusic.CurrUserVersion) {
                //        Util.info("此账号注册的是老师端，请在老师端登录使用", false);
                //        toPage("pnl_login");
                //    } else {
                //        toPage("pnl_main");
                //    }
                //}
                //else if (enumKey.HappyMusic.CurrUserVersion == enumKey.UserType.Teacher) {
                //    if (data.LoginUser.UserType != enumKey.HappyMusic.CurrUserVersion) {
                //        Util.info("此账号注册的是学生端，请在学生端登录使用", false);
                //        toPage("pnl_login");
                //    } else {
                //        toPage("pnl_mainTe");
                //    }
                //}
                if (data.LoginUser.UserType == enumKey.UserType.Student) {
                    $("#stu_foot_help_div").attr("src", "images/main/st_help_unselect.png");
                    $("#stu_foot_help_div_lable").css('color', '#707070');
                    $("#stu_foot_main_div").attr("src", "images/main/st_main_select.png");
                    $("#stu_foot_main_div_lable").css('color', '#FF4D4D');
                    toPage("pnl_main");
                } else if (data.LoginUser.UserType == enumKey.UserType.Teacher) {
                    $("#tec_foot_work_div").attr("src", "images/main/tec_work_unselect.png");
                    $("#tec_foot_me_div").attr("src", "images/main/tec_me_unselect.png");
                    $("#tec_foot_work_div_lable").css('color', '#707070');
                    $("#tec_foot_me_div_lable").css('color', '#707070');
                    $("#stu_foot_main_div").attr("src", "images/main/st_main_select.png");
                    $("#stu_foot_main_div_lable").css('color', '#FF4D4D');
                    toPage("pnl_mainTe");
                }
                //初始化边页
                sidePage = new SidePage("#sidePageId", "tpl/person/MyCenter.html", {
                    width: "70%",
                    height: "100%",
                    onload: MyCenterCtrl_load,
                    onShow: MyCenterCtrl_load
                });
                //获取token
                if (typeof navigator.xg != "undefined") {
                    navigator.xg.getToken(function (token) {
                        if (data.LoginUser.DeviceToken != token) {
                            Util.ajax({
                                method: "POST",
                                data: {
                                    token: token,
                                    userId: data.LoginUser.UserId,
                                    userType: enumKey.HappyMusic.CurrUserVersion
                                },
                                url: Util.getApiUrl("SetDeviceToken")
                            }, function () {
                            });

                        }
                    }, function () { });
                }
            } else if (data.ResponseCode == 5) {//第一次登陆，直接跳转到
                Cache.getCache("RegisterUserOrOpenId", userOrOpenId);
                Cache.getCache("RegisterloginType", loginType);
                toPage('pnl_register');
            } else {
                Util.info(data.ResponseMessage, false);
            }
        });
    },
	
    };
    return new obj();
})();