﻿var PerfectinfoCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.CurrUserType = Cache.getCache("RegisterUserType");
            debugger;
            if (that.CurrUserType == 1) {
                that.teacherId = 1;//默认官方教师
                $("#perfectinfo_teacher_input").val("");
                document.getElementById("perfectinfo_binding_teacher").style.display = "block";
            } else {
                that.teacherId = -1;
                document.getElementById("perfectinfo_binding_teacher").style.display = "none";
            }
            $("#perfectinfo_realname_input").val("");
            $("#perfectinfo_nickname_input").val("");
            $("#perfectinfo_invitecode_input").val("");
            that.phone= Cache.getCache("RegisterPhone");
            that.password = Cache.getCache("RegisterPassword");
            that.userOrOpenId = Cache.getCache("RegisterUserOrOpenId");
            that.loginType = Cache.getCache("RegisterloginType");
            that.headerImg = "images/background_img.jpg";
            that.IsSaveUserInfo = false;
            // add by lijq 2016-12-16 屏蔽表情 start
            $("#perfectinfo_realname_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("perfectinfo_realname_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#perfectinfo_realname_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#perfectinfo_realname_input").val(content);
                }
            };
            $("#perfectinfo_nickname_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("perfectinfo_nickname_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#perfectinfo_nickname_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#perfectinfo_nickname_input").val(content);
                }
            };
            $("#perfectinfo_invitecode_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("perfectinfo_invitecode_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#perfectinfo_invitecode_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#perfectinfo_invitecode_input").val(content);
                }
            };
            // add by lujf 2016-5-11 屏蔽表情 end
        },


        //搜索绑定老师
        TeacherInformation: function () {
            var searchStr = $("#perfectinfo_teacher_input").val().trim();
            if (!searchStr) {
                Util.info("填写教师手机号或邀请码", false);
                return;
            }
            Util.ajax({
                method: "POST",
                data: {
                    searchStr: searchStr,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("TeacherInformation")
            }, function (data) {
                if (data.ResponseCode == 1) {
                    $("#perfectinfo_teacher_input").val("");
                    var teacherInfo = data.TeacherInfo;
                    var content = '<div class="perfectinfo_teacher_headerimg_div"><div class="perfectinfo_teacher_headerimg"><img src="' + teacherInfo.HeadImg + '" /></div></div>'
                     + '<div class="perfectinfo_teacher_content">'
                     + '<div>姓名：' + teacherInfo.RealName + '</div>'
                     + '<div>手机号码：' + teacherInfo.Phone + '</div>'
                     + '<div>邀请码：' + teacherInfo.InviteCode + '</div>'
                     + '</div> ';
                    Util.customConfirm(content, function (result) {
                        if (result) {
                            that.teacherId = teacherInfo.UserId;
                            $("#perfectinfo_cell_box").html("<div>已绑定教师<span>" + teacherInfo.RealName + "</span>，如果需要更改请重新查找</div>");
                        }
                    }, false);
                } else if (data.ResponseCode == 2) {
                    $("#perfectinfo_teacher_input").val("");
                    var content="<div>未查询到您搜索的老师</div><div>是否绑定官方教师</div>"; 
                    Util.popConfirm("提示", content, function (result) {
                        if (result) {

                            that.teacherId = 1 ;
                            $("#perfectinfo_cell_box").html("<div>已绑定教师<span>官方教师</span>，如果需要更改请重新查找</div>");
                        }
                    }, false);
                } else {
                    Util.info(data.ResponseMessage, false);
                }
            });
        },
        //保存信息
        saveUserInfo: function () {
            if (that.IsSaveUserInfo) {
                return;
            }
            var realname = $("#perfectinfo_realname_input").val().trim();
            var nickname = $("#perfectinfo_nickname_input").val().trim();
            var invitecode = $("#perfectinfo_invitecode_input").val().trim();
            
            if (!realname) {
                Util.info("请填写真实姓名", false);
                return;
            }
            that.IsSaveUserInfo == true;
            Util.ajax({
                method: "POST",
                data: {
                    userType: that.CurrUserType,
                    userTel: that.phone,
                    password:that.password,
                    inviteCode:invitecode,
                    teacherId:that.teacherId,
                    realName :realname,
                    nickname: nickname,
                    headerImg:that.headerImg,
                    userOrOpenId: that.userOrOpenId,
                    loginType:that.loginType
                },
                url: Util.getApiUrl("Regist")
            }, function (data) {
                if (data.ResponseCode == enumKey.RegistRespEnum.Success) {
                    //清空缓存
                    Cache.clearCache("RegisterPhone");
                    Cache.clearCache("RegisterPassword");
                    Cache.clearCache("RegisterUserOrOpenId");
                    Cache.clearCache("RegisterloginType");
                    Cache.clearCache("RegisterUserType");
                    //保存
                    Cache.setCache("LoginUserInfo", data.LoginUser);
                    Cache.setDbCache("LoginUserInfo", data.LoginUser);

                    if (data.LoginUser.UserType == enumKey.UserType.Student) {
                        $("#stu_foot_help_div").attr("src", "images/main/st_help_unselect.png");
                        $("#stu_foot_help_div_lable").css('color', '#707070');
                        $("#stu_foot_main_div").attr("src", "images/main/st_main_select.png");
                        $("#stu_foot_main_div_lable").css('color', '#FF4D4D');
                        toPage("pnl_main");
                    } else if (data.LoginUser.UserType == enumKey.UserType.Teacher) {
                        $("#tec_foot_work_div").attr("src", "images/main/tec_work_unselect.png");
                        $("#tec_foot_me_div").attr("src", "images/main/tec_me_unselect.png");
                        $("#tec_foot_work_div_lable").css('color', '#707070');
                        $("#tec_foot_me_div_lable").css('color', '#707070');
                        $("#stu_foot_main_div").attr("src", "images/main/st_main_select.png");
                        $("#stu_foot_main_div_lable").css('color', '#FF4D4D');
                        toPage("pnl_mainTe");
                    }

                    //初始化边页
                    sidePage = new SidePage("#sidePageId", "tpl/person/MyCenter.html", {
                        width: "70%",
                        height: "100%",
                        onload: MyCenterCtrl_load,
                        onShow: MyCenterCtrl_load
                    });

                    //获取token
                    if (typeof navigator.xg != "undefined") {
                        navigator.xg.getToken(function (token) {
                            if (data.LoginUser.DeviceToken != token) {
                                Util.ajax({
                                    method: "POST",
                                    data: {
                                        token: token,
                                        userId: data.LoginUser.UserId,
                                        userType: enumKey.HappyMusic.CurrUserVersion
                                    },
                                    url: Util.getApiUrl("SetDeviceToken")
                                }, function () {
                                });

                            }
                        }, function () { });
                    }
                } else {
                    //if (data.ResponseCode == enumKey.RegistRespEnum.Exists) {
                    //    if (data.currUserType != enumKey.HappyMusic.CurrUserVersion) {
                    //        if (data.currUserType == enumKey.UserType.Teacher && enumKey.HappyMusic.CurrUserVersion == enumKey.UserType.Student) {
                    //            Util.info("此用户已在老师端注册", false);
                    //        } else if (data.currUserType == enumKey.UserType.Student && enumKey.HappyMusic.CurrUserVersion == enumKey.UserType.Teacher) {
                    //            Util.info("此用户已在学生端注册", false);
                    //        }else{
                    //          Util.info(data.ResponseMessage, false);
                    //        }
                    //    }else{
                    //        Util.info(data.ResponseMessage, false);
                    //    }
                    //} else {
                    //    Util.info(data.ResponseMessage, false);
                    //}
                    Util.info(data.ResponseMessage, false);
                   
                }
            });
        },
        toUploadheadImg: function () {
            navigator.camera.getPicture(onSuccess, onFail, {
                quality: 75, // 图片质量
                destinationType: Camera.DestinationType.FILE_URI, // DATA_URL返回Base64编码字符串的图像数据，FILE_URI返回图像文件的URI
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY, // CAMERA表示拍照，PHOTOLIBRARY表示相册选择
                allowEdit: true, // 在选择图片进行操作之前允许对其进行简单编辑
                encodingType: Camera.EncodingType.JPEG, // 返回JPEG格式图片
                targetWidth: 640, // 以像素为单位的图像缩放宽度
                targetHeight: 450 // 以像素为单位的图像缩放高度
            });
            // 获取图片成功
            function onSuccess(imageURI) {
                Util.showAppLoading();
                if (Util.getSystemType() == "Android") {
                    imageURI += ".jpg";
                }

                // 上传设置
                var options = new FileUploadOptions();
                options.fileKey = "file";
                options.fileName = Number(new Date()) + ".jpg";
                options.mimeType = "image/jpeg";
                // 服务器路径
                var uri = encodeURI(Util.getApiUrl("ImageUpload"));
                var ft = new FileTransfer();
                ft.onprogress = function (progressEvent) {
                    console.log("progressEvent.loaded --> " + progressEvent.loaded);
                    console.log("progressEvent.total --> " + progressEvent.total);
                };

                // 上传图片成功
                function uploadSuccess(res) {
                    Util.hideAppLoading();
                    that.headerImg = JSON.parse(res.response).imgUrl;
                    $("#perfectinfo_headimg").attr("src", that.headerImg);
                };

                // 上传图片失败
                function uploadFail(error) {
                    Util.hideAppLoading();
                    switch (error.code) {
                        case FileTransferError.FILE_NOT_FOUND_ERR:
                            //Util.info("错误：文件未找到", false);
                            break;
                        case FileTransferError.INVALID_URL_ERR:
                            //Util.info("错误：无效的URL", false);
                            break;
                        case FileTransferError.CONNECTION_ERR:
                            //Util.info("错误：服务器链接失败", false);
                            break;
                    }
                };

                // 执行上传
                ft.upload(imageURI, uri, uploadSuccess, uploadFail, options);
            };
            // 获取图片失败
            function onFail(message) {
                //Util.info("失败：" + message, false);
            }
        },
    };
    return new obj();
})();