﻿var ModifyNickNameCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            document.getElementById("mnn_text_div_input").value = that.LoginUser.Nickname;
            // add by lijq 2016-12-16 屏蔽表情 start
            $("#mnn_text_div_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("mnn_text_div_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#mnn_text_div_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#mnn_text_div_input").val(content);
                }
            };
            // add by lujf 2016-5-11 屏蔽表情 end
        },

        doReset: function (){
            document.getElementById("mnn_text_div_input").value = "";
        },

        doSave: function () {
            var Name = $("#mnn_text_div_input").val().trim();
            if (!Name) {
                Util.info("昵称不能为空",false);
                return;
            }
            Util.ajax({
                method: "POST",
                data: {
                    name: Name,
                    userId: that.LoginUser.UserId,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("ModifyNickname")
            }, function (data) {
                //登录成功
                if (data.ResponseCode == 1) {
                    that.LoginUser.Nickname = Name;
                    Cache.setCache("LoginUserInfo", that.LoginUser);
                    Util.info(data.ResponseMessage,true);
                    //toPage("pnl_personalData");
                    $.ui.goBack();//Fixed byzhusj 2016/12/13
                } else {
                    Util.info(data.ResponseMessage,false);
                }
            });
        }      
    };
    return new obj();
})();