﻿var MyPurseStCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {         
            //默认显示包月套餐页面           
            that.loginUser = Cache.getCache("LoginUserInfo");
            if (that.loginUser == undefined) {
                Cache.getDbCache("LoginUserInfo", function (result) {
                    if (result) {
                        that.loginUser = result;
                        that.MyPurseStInfo();
                        that.myPurseStTabBtn(1);
                    } else {
                        toPage("pnl_login");
                    }
                });
            } else {
                that.MyPurseStInfo();
                that.myPurseStTabBtn(1);
            }
        },
        //页面信息赋值
        MyPurseStInfo: function () {
            IndexRefreshGoldInfo(function (result) {
                if (result) {
                    //页面初始化
                    if (that.loginUser.UserType == 1) {
                        $("#myPurseSt_info_homeworkcount_box").show();
                        document.getElementById("myPurseSt_tab_detail_buyList").style.height = document.getElementById("mypurseSt_body_box").offsetHeight - 270 + "px";
                        document.getElementById("myPurseSt_tab_detail_allList").style.height = document.getElementById("mypurseSt_body_box").offsetHeight - 270 + "px";
                    } else {
                        $("#recharge_info_homeworkcount_box").hide();
                        document.getElementById("myPurseSt_tab_detail_buyList").style.height = document.getElementById("mypurseSt_body_box").offsetHeight - 245 + "px";
                        document.getElementById("myPurseSt_tab_detail_allList").style.height = document.getElementById("mypurseSt_body_box").offsetHeight - 245 + "px";
                    }

                    $("#myPurseSt_info_flower").html(result.Flower);
                    $("#myPurseSt_info_integral").html(result.Integral);
                    $("#myPurseSt_info_gold").html(result.Gold);
                    $("#myPurseSt_info_homeworkcount").html(result.HomeworkCount);
                    $("#myPurseSt_info_monthlyLastTime").html(result.MonthlyLastTimeStr);
                    $("#myPurseSt_info_danceLastTime").html(result.DanceLastTimeStr);

                    that.buyPurselist = [];

                    that.buyPurseScroller = new devAfScroller("myPurseSt_tab_detail_buyList", {
                        refreshFunc: that.loadBuyPurseList,
                        loadMoreFunc: that.loadBuyPurseMore
                    });
                    that.buyPurseScroller.scrollTo({ x: 0, y: 0 });

                    that.allPurseList = [];

                    that.allPurseScroller = new devAfScroller("myPurseSt_tab_detail_allList", {
                        refreshFunc: that.loadAllPurseList,
                        loadMoreFunc: that.loadAllPurseMore
                    });
                    that.allPurseScroller.scrollTo({ x: 0, y: 0 });
                }
            });
          
        },
        myPurseStTabBtn: function(index){
            $(".myPurseSt_tb").removeClass("myPurseSt_tab_underLine");
            if (index == 1) {
                $("#myPurseSt_tab_buyList").addClass("myPurseSt_tab_underLine");
                $("#myPurseSt_tab_detail_buyList").show();
                $("#myPurseSt_tab_detail_allList").hide();
                that.loadBuyPurseList();
            } else if (index == 2) {

                $("#myPurseSt_tab_allList").addClass("myPurseSt_tab_underLine");
                $("#myPurseSt_tab_detail_allList").show();
                $("#myPurseSt_tab_detail_buyList").hide();
                that.loadAllPurseList();
            }
        },
        buyFlowerClick: function () {
            //购买献花
            BuyFlowers(that.loginUser.UserId, -1, that.loginUser.Integral, false, function (result) {
                if (result != null) {
                    //更新页面及缓存数据
                    $("#myPurseSt_info_flower").html(result.Flower);
                    $("#myPurseSt_info_integral").html(result.Integral);
                    that.loginUser.Flower = result.Flower;
                    that.loginUser.Integral = result.Integral;
                    Cache.setCache("LoginUserInfo", that.loginUser);
                    Cache.setDbCache("LoginUserInfo", that.loginUser);
                }
            });
        },
        //获取已购清单
        getBuyPurseList: function (pageIndex) {
            Util.ajax({
                method: "POST",
                data: {
                    userId: that.loginUser.UserId,
                    productName: "",
                    size: 10,
                    index: pageIndex,
                    userType: enumKey.HappyMusic.CurrUserVersion,
                },
                url: Util.getApiUrl("ProductListByUserId")
            }, function (data) {
                if (data.DataList.length > 0) {
                    if (pageIndex == 0) {
                        that.buyPurselist = [];
                        document.getElementById("myPurseSt_detail_buyList_template").innerHTML = "";
                    }
                    that.buyPurselist = that.buyPurselist.concat(data.DataList);
                    that.loadBuyPurse(data.DataList);
                    that.buyPurseScroller.setMoreRecord(data.DataList.length >= 10 ? true : false);
                    that.buyPurseScroller.pullback();
                }
            }, function () {
                that.buyPurseScroller.pullback();
            });
        },

        loadBuyPurseList: function () {
            that.getBuyPurseList(0);
        },

        loadBuyPurseMore: function () {
            that.getBuyPurseList(that.buyPurselist.length);
        },

        loadBuyPurse: function (obj) {
            var buyPurseList = obj;
            for (var i = 0; i < buyPurseList.length; i++) {
                var item = document.createElement("div");
                item.className = "myPurseSt_tab_detail_line";
                var str = '<div class="myPurseSt_tab_detail_left">'
                        + '<div>' + buyPurseList[i].ProductName + '</div>'
                        + '</div>'
                        + '<div class="myPurseSt_tab_detail_right">'
                        + '<div class="myPurseSt_tab_detail_date">' + buyPurseList[i].CreateTimeStr + '</div>'
                        + '</div>'
                        + '</div>'

                item.innerHTML = str;
                document.getElementById("myPurseSt_detail_buyList_template").appendChild(item);
            }
        },
        //账单列表
        getAllPurseList: function (pageIndex) {
            Util.ajax({
                method: "POST",
                data: {
                    userId: that.loginUser.UserId, 
                    size: 10,
                    index: pageIndex,
                    userType: enumKey.HappyMusic.CurrUserVersion,
                },
                url: Util.getApiUrl("OrderList")
            }, function (data) {
                if (data.DataList.length > 0) {
                    if (pageIndex == 0) {
                        that.allPurseList = [];
                        document.getElementById("myPurseSt_detail_allList_template").innerHTML = "";
                    }
                    that.allPurseList = that.allPurseList.concat(data.DataList);
                    that.loadAllPurse(data.DataList);
                    that.allPurseScroller.setMoreRecord(data.DataList.length >= 10 ? true : false);
                    that.allPurseScroller.pullback();
                }
            }, function () {
                that.allPurseScroller.pullback();
            });
        },

        loadAllPurseList: function () {
            that.getAllPurseList(0);
        },

        loadAllPurseMore: function () {
            that.getAllPurseList(that.allPurseList.length);
        },

        loadAllPurse: function (obj) {
            var allPurseList = obj;
            for (var i = 0; i < allPurseList.length; i++) {
                var item = document.createElement("div");
                item.className = "myPurseSt_tab_detail_line";
                var str = '<div class="myPurseSt_tab_detail_left">'
                        + '<div>' + allPurseList[i].DisplayContent + '</div>'
                        + '</div>'
                        + '<div class="myPurseSt_tab_detail_right">'
                        + '<div class="myPurseSt_tab_detail_points_green" style="color:'
                        +( (allPurseList[i].ShowType == enumKey.GoldLogShowType.Increase 
                        || allPurseList[i].Type == enumKey.GoldChange.Recharge 
                        || allPurseList[i].Type == enumKey.GoldChange.Task
                        || allPurseList[i].Type == enumKey.GoldChange.CorrectHomework
                        || allPurseList[i].Type == enumKey.GoldChange.FirstTimeRecharge
                        || allPurseList[i].Type == enumKey.GoldChange.Artifical
                        || allPurseList[i].Type == enumKey.GoldChange.CDKExcharge
                        || allPurseList[i].Type == enumKey.GoldChange.Game_20
                        || allPurseList[i].Type == enumKey.GoldChange.Invite
                        || allPurseList[i].Type == enumKey.GoldChange.PlatRecharge) ? "#FE5555" : "#5AD577") + '">'
                        + allPurseList[i].GoldStr
                        + '</div>'
                        + '<div class="myPurseSt_tab_detail_date">' + allPurseList[i].CreateTimeStr + '</div>'
                        + '</div>'
                        + '</div>'

                item.innerHTML = str;
                document.getElementById("myPurseSt_detail_allList_template").appendChild(item);
            }
        },

    };
    return new obj();
})();