﻿var NotificationCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            document.getElementById("notification_list_content").style.height = document.getElementById("content").offsetHeight - $("#notification_top_div").height() + "px";
            //初始化作业通知列表
            that.listReceivedScroll = new devAfScroller("notification_list_content", {
                refreshFunc: that.loadReceived,
                loadMoreFunc: that.loadReceivedMore
            });
            that.listReceivedScroll.scrollTo({ x: 0, y: 0 });
            that.receivedDataList = [];
            that.loadReceived();
        },

        //加载作业通知
        loadReceived: function () {         
            // 取出本地数据
            that.getDataList(0, 10, function (dataList) {
                //  清空列表                       
                $("#notification_list_item").html("");
                that.receivedDataList = dataList;
                // 显示数据
                that.showReceivedList(dataList);
                // 设置scroller
                that.listReceivedScroll.setMoreRecord(dataList.length == 10 ? true : false);
                that.listReceivedScroll.pullback();
            });
        }, function () {
            // 设置scroller
            that.listReceivedScroll.setMoreRecord(dataList.length == 10 ? true : false);              
        },

        // 加载更多
        loadReceivedMore: function () {
            if (that.receivedDataList.length < 10) { return; }
            that.getDataList(that.receivedDataList.length, 10, function (receivedDataList) {
                that.receivedDataList = that.receivedDataList.concat(receivedDataList);
                that.showReceivedList(receivedDataList);
                that.listReceivedScroll.setMoreRecord(receivedDataList.length == 10 ? true : false);
                that.listReceivedScroll.pullback();
            }, function () {
                that.listReceivedScroll.setMoreRecord(true);
                that.listReceivedScroll.pullback();
            });
        },


        showReceivedList: function (dataList) {
            debugger;
            for (var i = 0; i < dataList.length; i++) {
                var html = "<div class='notification_list_item'>";
                html += "<div class='notification_new_message' id='notification_" + dataList[i].PublishId + "'>";         
                if (dataList[i].Status == 0) {
                    html += "<div class='notification_new_message_div'>";
                    html += "<img src='images/homework/homework_new.png'/>";
                    html += "</div>";
                }        
                html += "</div>";
                html += "<div class='notification_content'>";
                html += "<div class='notification_lable'>你收到一条新作业啦！</div>";
                html += "<div class='notification_video_name'>作业：" + dataList[i].VideoName + "</div>";
                html += "<div class='notification_time_div'>";
                html += "<div class='notification_time'>" + dataList[i].CreateTimeStr + "</div>";
                html += "</div>";
                html += "</div>";
                html += "<div class='notification_button_div'>";
                html += "<div class='notification_button' data='" + dataList[i].PublishId + "*" + dataList[i].VideoId + "*" + dataList[i].CustomType + "*" + dataList[i].VideoName + "'>观看视频</div>";
                html += "<div class='notification_button show' style='margin-top:10px;' data='" + dataList[i].PublishId + "'>上传作业</div>";
                html += "</div>";
                html += "</div>";
                $("#notification_list_item").append(html);
            }
            //FixedStart by lijq 2016/11/4  
            CommonClickEvent(".notification_button", function (isClick, value) {
                if (isClick) {
                    var index = value.split("*");
                    that.toPageVideo(index[0], index[1], index[2],index[3]);
                }
            });
            CommonClickEvent(".show", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.showPop(index);
                }
            });
            //FixedEnd
        },


        //获取数据一览
        getDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "select PublishId,VideoId,VideoName,RealName,CreateTimeStr,Status,CustomType from t_publish order by CreateTimeStr desc,PublishId desc limit " + pageIndex + "," + pageCount;
           
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret_1) {
                if (typeof callback == 'function') {
                    callback(ret_1);
                }
            }, function () {
                errCallback();
            });
        },
        
        //跳转到播放视频画面
        toPageVideo: function (publishId, videoId, type, videoName) {
            //更新已读状态
            that.changeReadStatus(publishId);

            //var videoInfo = JSON.stringify({ BookId: 0, BookType: 0, VideoId: videoId, VideoName: videoName });
            //lookVideo(videoId, function (res) {
            //    if (!res) { return; }
            //    //乐器类
            //    if (type == 1) {
            //        lookVideo(videoId, function (result) {
            //            if (result) {
            //                Cache.setCache("MusicVideoDetail_videoInfo", videoInfo);
            //                toPage("pnl_musicVideoDetail");
            //            }
            //        });
            //    }
            //    //舞蹈类
            //    if (type == 2) {
            //        lookVideo(videoId, function (result) {
            //            if (result) {
            //                Cache.setCache("DanceVideoDetail_videoInfo", videoInfo);
            //                toPage("pnl_danceVideoDetail");
            //            }
            //        });
            //    }
            //});

            // fixed by lyl 2016-12-22 记录作业路径 start
            var getDataSql = "select VideoId,VideoName,BookId,BookName,BookType from t_publish where PublishId =" + publishId;
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                var videoInfo = JSON.stringify({
                    BookId: ret[0].BookId,
                    BookName: ret[0].BookName,
                    BookType: ret[0].BookType,
                    VideoId: videoId,
                    VideoName: videoName
                });
                lookVideo(videoId, function (res) {
                    if (!res) { return; }
                    //乐器类
                    if (type == 1) {
                        lookVideo(videoId, function (result) {
                            if (result) {
                                debugger;
                                Cache.setCache("MusicVideoDetail_videoInfo", videoInfo);
                                toPage("pnl_musicVideoDetail");
                            }
                        });
                    }
                    //舞蹈类
                    if (type == 2) {
                        lookVideo(videoId, function (result) {
                            if (result) {
                                Cache.setCache("DanceVideoDetail_videoInfo", videoInfo);
                                toPage("pnl_danceVideoDetail");
                            }
                        });
                    }
                });
            }, function () {
            });
            // fixed by lyl 2016-12-22 记录作业路径 end
        },

        //弹出选择框
        showPop: function (publishId) {
            that.changeReadStatus(publishId);
            // fixed by lujf 2016-11-24 记录上传作业路径 start
            var getDataSql = "select VideoId,VideoName,BookId,BookName,BookType from t_publish where PublishId =" + publishId;
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                var videoInfo = {
                    BookId: ret[0].BookId,
                    BookName: ret[0].BookName,
                    BookType: ret[0].BookType,
                    VideoId: ret[0].VideoId,
                    VideoName: ret[0].VideoName
                };
                showHomeworkPop(videoInfo, function () { });
            }, function () {
            });
            // fixed by lujf 2016-11-24 记录上传作业路径 end
        },

        changeReadStatus: function (publishId) {
            $("#notification_" + publishId).hide();
            //更新已读状态
            var updateSql = "update t_publish set status=1 where PublishId = " + publishId;
            db.query(updateSql);
        },
    };
    return new obj();
})();