﻿var PersonalDataCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginUser = Cache.getCache("LoginUserInfo");
            //头像
            document.getElementById("data_image").src = that.loginUser.HeadImg;
            document.getElementById("data_nickname").innerHTML = that.loginUser.Nickname;
            document.getElementById("data_realname").innerHTML = that.loginUser.RealName;
            document.getElementById("data_phone").innerHTML = that.loginUser.Phone;
            document.getElementById("data_area").innerHTML = that.loginUser.AreaInfo;

            //// 图片绑定上传事件
            //$("#data_image").unbind().bind('click', that.toUploadImg);
        },

        goBack: function () {
            if (that.loginUser.UserType==1)
            {
                toPage("pnl_main");
                //修改返回时底部图标还原2016-12-19
                $("#stu_foot_help_div").attr("src", "images/main/st_help_unselect.png");
                $("#stu_foot_help_div_lable").css('color', '#707070');
                $("#stu_foot_main_div").attr("src", "images/main/st_main_select.png");
                $("#stu_foot_main_div_lable").css('color', '#FF4D4D');
            }
            else{
                $.ui.goBack();
            }           
        },
        //上传图片
        toUploadImg: function () {
            navigator.camera.getPicture(onSuccess, onFail, {
                quality: 75, // 图片质量
                destinationType: Camera.DestinationType.FILE_URI, // DATA_URL返回Base64编码字符串的图像数据，FILE_URI返回图像文件的URI
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY, // CAMERA表示拍照，PHOTOLIBRARY表示相册选择
                allowEdit: true, // 在选择图片进行操作之前允许对其进行简单编辑
                encodingType: Camera.EncodingType.JPEG, // 返回JPEG格式图片
                targetWidth: 640, // 以像素为单位的图像缩放宽度
                targetHeight: 450 // 以像素为单位的图像缩放高度
            });
            // 获取图片成功
            function onSuccess(imageURI) {
                if (Util.getSystemType() == "Android") {
                    imageURI += ".jpg";
                }
                Util.showAppLoading();
                // 上传设置
                var options = new FileUploadOptions();
                options.fileKey = "file";
                options.fileName = Number(new Date()) + ".jpg";
                options.mimeType = "image/jpeg";
                // 服务器路径
                var uri = encodeURI(Util.getApiUrl("ImageUpload"));
                var ft = new FileTransfer();
                ft.onprogress = function (progressEvent) {
                    console.log("progressEvent.loaded --> " + progressEvent.loaded);
                    console.log("progressEvent.total --> " + progressEvent.total);
                };

                // 上传图片成功
                function uploadSuccess(res) {
                    
                    that.headImg = JSON.parse(res.response).imgUrl;
                    $("#data_image").attr("src", that.headImg);

                    //修改图片
                    Util.ajax({
                        method: "POST",
                        data: {
                            userId: that.loginUser.UserId, //that.loginUser.UserId,
                            headImg: that.headImg,
                            userType: enumKey.HappyMusic.CurrUserVersion
                        },
                        url: Util.getApiUrl("ModifyHeadImg")
                    }, function (data) {
                        if (data.ResponseCode == 1) {
                            Util.hideAppLoading();
                            that.loginUser.HeadImg = that.headImg;
                            Cache.setCache("LoginUserInfo", that.loginUser);
                            Cache.setDbCache("LoginUserInfo", that.loginUser);

                        } else {
                            Util.hideAppLoading();
                            Util.info("系统正在努力加载，请稍后重试!", false);
                            return;
                        }
                    }, function () {
                        Util.hideAppLoading();
                    });

                };

                // 上传图片失败
                function uploadFail(error) {

                    switch (error.code) {
                        case FileTransferError.FILE_NOT_FOUND_ERR:
                            //Util.info("错误：文件未找到", false);
                            break;
                        case FileTransferError.INVALID_URL_ERR:
                            //Util.info("错误：无效的URL", false);
                            break;
                        case FileTransferError.CONNECTION_ERR:
                            //Util.info("错误：服务器链接失败", false);
                            break;
                    }
                };

                // 执行上传
                ft.upload(imageURI, uri, uploadSuccess, uploadFail, options);
            };
            // 获取图片失败
            function onFail(message) {
                //Util.info("失败：" + message, false);
            }
        }
    };
    return new obj();
})();
