﻿var SearchTeacherCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginInfo = Cache.getCache("LoginUserInfo");
            that.decodeId = Cache.getCache("BindTeacherList_type");
            
            //清空页面
            that.showBlock(0);
            $("#st_search").val("");
        },

        //查找老师
        searchTeacher: function () {
            var searchStr = $("#st_search").val().trim();
            if (searchStr == "官方教师") {
                that.showBlock(2);
                that.teacherId = 1;
                return;
            }
            else {
                Util.ajax({
                    method: "POST",
                    data: {
                        searchStr: searchStr
                    },
                    url: Util.getApiUrl("TeacherInformation")
                }, function (data) {
                    if (data.ResponseCode == enumKey.RespCode.Success) {
                        that.showBlock(1);
                        that.teacherId = data.TeacherInfo.UserId;
                        $("#st_teacher_realname").html(data.TeacherInfo.RealName);
                        $("#st_teacher_nickname").html(data.TeacherInfo.Nickname);
                        $("#st_teacher_phone").html(data.TeacherInfo.Phone);
                        $("#st_teacher_invite").html(data.TeacherInfo.InviteCode);
                    }
                    else {
                        that.showBlock(3);
                    }
                }, function () {

                });
            }
        },

        //显示内容
        showBlock: function (index) {
            $("#st_teacher").css('display', 'none');
            $("#st_office").css('display', 'none');
            $("#st_unfind").css('display', 'none');
            if (index == 1)
            {
                $("#st_teacher").css('display', 'block');
            }
            else if (index == 2)
            {
                $("#st_office").css('display', 'block');
            }
            else if(index==3)
            {
                $("#st_unfind").css('display', 'block');
            }
        },

        //绑定教师
        bindTeacher: function () {
            Util.ajax({
                method: "POST",
                data: {
                    codeNum: that.decodeId,
                    userId: that.loginInfo.UserId,
                    teacherId: that.teacherId
                },
                url: Util.getApiUrl("ModifyTeacherInfo")
            }, function (data) {              
                if (data.ResponseCode == enumKey.RespCode.Success)
                {
                    Util.info(data.ResponseMessage, true);
                    $.ui.goBack()
                }
                else
                {
                    Util.info(data.ResponseMessage);
                }
            }, function () {

            });
        },

        //弹出分享框
        showPop: function () {
            showSharePop();
        },
    };
    return new obj();
})();