﻿var SystemNewsCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {           
            that.LoginUser = Cache.getCache("LoginUserInfo");
            document.getElementById("sn_list_content").style.height = document.getElementById("content").offsetHeight - $("#sn_top_div").height() + "px";
            //初始化系统消息列表
            that.listMessageScroll = new devAfScroller("sn_list_content", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });
            that.listMessageScroll.scrollTo({ x: 0, y: 0 });
            that.messageDataList = [];
            that.loadList();
        },

        //加载系统消息列表
        loadList: function () {                   
                    // 取出本地数据
                    that.getDataList(0, 10, function (dataList) {
                        //  清空列表
                        $("#sn_list_item").html("");
                        that.messageDataList = dataList;
                        // 显示数据
                        that.showMessageData(dataList);
                        // 设置scroller
                        that.listMessageScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        that.listMessageScroll.pullback();                      
                    });                        
                  }, function () {
                        that.listMessageScroll.setMoreRecord(dataList.length == 10 ? true : false);
                        //that.listMessageScroll.pullback();
        },

        // 加载更多
        loadMore: function () {
            if (that.messageDataList.length < 10) { return; }
            // 取出本地数据
            that.getDataList(that.messageDataList.length, 10, function (messageDataList) {
                that.messageDataList = that.messageDataList.concat(messageDataList);
                that.showMessageData(messageDataList);
                // 设置scroller
                that.listMessageScroll.setMoreRecord(messageDataList.length == 10 ? true : false);
                that.listMessageScroll.pullback();

            }, function () {
                // 设置scroller
                that.listMessageScroll.setMoreRecord(true);
                that.listMessageScroll.pullback();

            });
        },
      
        //显示数据
        showMessageData: function (dataList) {
            var item;
            var showStr = "";
            for (var i = 0; i < dataList.length; i++) {
                item = dataList[i];
                showStr += '<div class="sn_list_item" data="' + item.MessageId + '*' + item.MessageTitle + '">'
                       + ' <div class="sn_new_news">';
                    if (item.Status == 0||!item.Status) {
                        showStr += ' <div class="sn_new_news_div">'
                                + ' <img src="images/person/person_news.png" />'
                                + ' </div>';
                    } else if (item.Status == 1 && item.Status) {
                        showStr += ' <div class="sn_new_news_div">'                    
                            + ' </div>';
                    }                      
                showStr +=' </div>'
                       + ' <div class="sn_content">'
                       + ' <div class="sn_news_title">' + item.MessageTitle + ' </div>'
                       + ' <div class="sn_news_time">' + item.CreateTime + '</div></div>' 
                       + ' <div class="sn_goto" >'
                       + ' 查看详情<img src="images/person/data_goto.png" /></div></div>';               
            }         
            $("#sn_list_item").append(showStr);
            //FixedStart by lijq 2016/11/4  
            CommonClickEvent(".sn_list_item", function (isClick, value) {
                if (isClick) {
                    var index = value.split("*");
                    that.gotoDetail(index[0], index[1]);
                }
            });
            //FixedEnd
        },

        // 获取本地数据
        getDataList: function (pageIndex, pageCount, callback, errCallback) {
            var getDataSql = "select MessageId,MessageTitle,IsDeleted,CreateTime,Status from t_message order by CreateTime desc limit " + pageIndex + "," + pageCount;
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret_1) {
                if (typeof callback == 'function') {
                    callback(ret_1);
                }
            }, function () {
                errCallback();
            });
        },
        gotoDetail: function (messageId,messageTitle) {
            var newsInfo = JSON.stringify({ MessageId: messageId, MessageTitle: messageTitle, })
            Cache.setCache("NewsContent_newsInfo",newsInfo);
            toPage("pnl_newsContent");                             
        }
    };
    return new obj();
})();