﻿var MyWorkListCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginUser = Cache.getCache("LoginUserInfo");
            if (that.loginUser == undefined) {
                Cache.getDbCache("LoginUserInfo", function (result) {
                    if (result) {
                        that.loginUser = result;
                    } else {
                        toPage("pnl_login");
                    }
                });
            }
            that.CurrWorkPerson = Cache.getCache("CurrWorkPersonInfo");
            debugger;
            $("#myWorkList_title_header_title").html(that.CurrWorkPerson.Nickname);// fixed by lujf 2016-11-28
            if (that.CurrWorkPerson.HeadImg != null && that.CurrWorkPerson.HeadImg != "") {
                $(".myWorkList_top_div").css({ "background-image": "url(" + that.CurrWorkPerson.HeadImg + ")" });
            }
            $("#myWorkList_attention_span").html(that.CurrWorkPerson.isAttention ? "取消关注" : "+关注");
            $("#myWorkList_top_attention_count").html(that.CurrWorkPerson.AttentionCount);
            $("#myWorkList_top_fans_count").html(that.CurrWorkPerson.FensCount);
            that.type = 1;
            that.datalist = [];
            //document.getElementById("workList_listContent").style.height = document.getElementById("content").offsetHeight - 60 + "px";
            that.workScroller = new devAfScroller("myWorkList_main_box", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });
            that.workScroller.scrollTo({ x: 0, y: 0 });
            that.loadList();

        },

        //获取作品列表
        getworkList: function (pageIndex) {
            Util.ajax({
                method: "POST",
                data: {
                    searchValue: "",
                    userId: that.CurrWorkPerson.UserId, //that.loginUser.UserId,
                    size: 5,
                    index: pageIndex,
                    userType: enumKey.HappyMusic.CurrUserVersion,
                    classificationId: 0,
                    type: that.type
                },
                url: Util.getApiUrl("ListWork")
            }, function (data) {
                if (data.DataList.length > 0) {
                    if (pageIndex == 0) {
                        that.datalist = [];
                        document.getElementById("myWorkList_content_box").innerHTML = "";
                    }
                    that.datalist = that.datalist.concat(data.DataList);
                    that.loadWork(data.DataList);
                    that.workScroller.setMoreRecord(data.DataList.length >= 5 ? true : false);
                    that.workScroller.pullback();
                }
            }, function () {
                that.workScroller.pullback();
            });
        },

        loadList: function () {
            that.getworkList(0);
        },

        loadMore: function () {
            that.getworkList(that.datalist.length);
        },

        loadWork: function (obj) {
            var commentList = obj;
            for (var i = 0; i < commentList.length; i++) {
                var str = '<div  class="workList_cell_box" data="' + commentList[i].WorkId + '">'
                        + '<div class="workList_cell_top_box">'
                        + '<div class="workList_headerimg_div">'
                        + '<img src="' + ((commentList[i].HeadImg == null || commentList[i].HeadImg == "") ? "images/background_img.jpg" : commentList[i].HeadImg) + '" />'
                        + '</div>'
                        + '<div class="workList_name_div">'
                        + '<div class="workList_name" >' + (commentList[i].Nickname == null ? " " : commentList[i].Nickname) + '</div>'
                        + '<div class="workList_time">' + commentList[i].CreateTimeYearStr + '</div>'
                        + '</div>'
                        + '</div>'
                        + '<div class="workList_cell_title">'
                        + '' + (commentList[i].WorkName == null ? "" : commentList[i].WorkName) + ''
                        + '</div>'
                        + '<div class="workList_cell_content_img">'
                        + '<img src="' + commentList[i].WorkImg + '" /> '
                        + '</div>'
                        + '<div class="workList_cell_bottom_div">'
                        + '<img src="images/work/comment.png"  /><span>' + commentList[i].CommentCount + '</span>'
                        + '<img src="images/work/flower.png" /><span>' + commentList[i].Flower + '</span>'
                        + '</div>'
                        + '</div>';
                $("#myWorkList_content_box").append(str);
                //item.innerHTML = str;
                //(function (el, vl) {
                //    el.addEventListener("click", function () { that.goWorkDetail(vl); });
                //})(item, commentList[i].WorkId);
                //document.getElementById("myWorkList_content_box").appendChild(item);
            }
            //FixedStart by lijq 2016/11/4  
            CommonClickEvent(".workList_cell_box", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.goWorkDetail(index);
                }
            });
            //FixedEnd
        },
        goWorkDetail: function (workId) {
            Cache.setCache("CurrWorkId", workId);
            Cache.setCache("isShowMyWorkList", false);
            toPage("pnl_workDetail");
        },
        attentionBtn: function () {
            if (that.CurrWorkPerson.isAttention) {
                //已关注--取消关注
                Util.ajax({
                    method: "POST",
                    data: {
                        userId: that.loginUser.UserId, //that.loginUser.UserId,
                        attentionUserId: that.CurrWorkPerson.UserId,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("CancelAttention")
                }, function (data) {
                    if (data.ResponseCode == 1) {
                        $("#myWorkList_attention_span").html("+关注");
                        $("#myWorkList_top_fans_count").html(that.CurrWorkPerson.FensCount - 1);
                        that.CurrWorkPerson.FensCount = that.CurrWorkPerson.FensCount - 1;
                        that.CurrWorkPerson.isAttention = false;
                    } else {
                        Util.info("系统正在努力加载，请稍后重试!", false);
                        return;
                    }
                }, function () {

                });

            } else {
                //未关注--关注
                Util.ajax({
                    method: "POST",
                    data: {
                        userId: that.loginUser.UserId, //that.loginUser.UserId,
                        attentionUserId: that.CurrWorkPerson.UserId,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("AddAttentionWork")
                }, function (data) {
                    if (data.ResponseCode == 1) {
                        $("#myWorkList_attention_span").html("取消关注");
                        $("#myWorkList_top_fans_count").html(that.CurrWorkPerson.FensCount + 1);
                        that.CurrWorkPerson.FensCount = that.CurrWorkPerson.FensCount + 1;
                        that.CurrWorkPerson.isAttention = true;
                    } else {
                        Util.info("系统正在努力加载，请稍后重试!", false);
                        return;
                    }
                }, function () {

                });
            }
        },
    };
    return new obj();
})();