﻿var UploadWorkCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginUser = Cache.getCache("LoginUserInfo");
            if (that.loginUser == undefined) {
                Cache.getDbCache("LoginUserInfo", function (result) {
                    if (result) {
                        that.loginUser = result;
                    } else {
                        toPage("pnl_login");
                    }
                });
            }
            that.homeKey = Cache.getCache("UploadWork_key");
            if (that.homeKey != undefined) {
                var homeKeyUrl = "";
                //FixedStart liyl 2016/12/28  https的判断
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    homeKeyUrl = "https://oivtotkhy.qnssl.com/";
                } else {
                    homeKeyUrl = "http://7xkpic.com1.z0.glb.clouddn.com/";
                }
                //FixedEnd
                $("#uploadWork_content_video").attr("src", homeKeyUrl + that.homeKey);
            }
            that.isConfirmWork = false;
            that.chooseCategory(0, 101);
            $("#uploadWork_content_title_input").val("");
            $("#uploadWork_content_desc_textarea").val("");
            //滑动
            that.workDetailScroller = new devAfScroller("uploadWork_body_box", { refresh: false });
            that.workDetailScroller.scrollToTop();
            //FixedStart byzhusj 2016/11/4
            CommonClickEvent(".uploadWork_content_category_btn", function (isClick, value) {
                if (isClick) {
                    var index1 = parseInt(value.split("*")[0]);
                    var index2 = parseInt(value.split("*")[1]);
                    that.chooseCategory(index1,index2);
                }
            });
            //FixedEnd
            // add by lijq 2016-12-16 屏蔽表情 start
            $("#uploadWork_content_title_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("uploadWork_content_title_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#uploadWork_content_title_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#uploadWork_content_title_input").val(content);
                }
            };
            $("#uploadWork_content_desc_textarea").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("uploadWork_content_desc_textarea").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#uploadWork_content_desc_textarea").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#uploadWork_content_desc_textarea").val(content);
                }
            };
            // add by lujf 2016-5-11 屏蔽表情 end
        },

      
        chooseCategory: function (index,type) {
            $(".uploadWork_content_category_btn").removeClass("uploadWork_content_category_active");
            $("#uploadWork_content_category_btn" + index).addClass("uploadWork_content_category_active");
            that.Category = type;
        },
        saveUploadWorkClick: function () {
            var WorkName = $("#uploadWork_content_title_input").val().trim();
            var WorkDescription = $("#uploadWork_content_desc_textarea").val().trim();
            var WorkVideo = that.homeKey;
            //var WorkImg = "http://7xkpic.com2.z0.glb.qiniucdn.com/"+that.homeKey+"?vframe/png/offset/1/w/480/h/320/rotate/auto";
            if (!WorkName) {
                Util.info("请输入作品名称", false);
                return;
            }
           
            var work = { UserId: that.loginUser.UserId, WorkType: that.Category, WorkName: WorkName, WorkDescription: WorkDescription, WorkVideo: WorkVideo };
            var content = '<div style=" text-align: center;padding: 8px 0px;">是否确认上传作品</div>';
            Util.popConfirm("提示", content, function (result) {
                if (result) {
                    if (that.isConfirmWork) {
                        return;
                    }
                   
                    that.isConfirmWork = true;
                    
                    Util.showAppLoading();
                    Util.ajax({
                        method: "POST",
                        data: {
                            workStr:JSON.stringify(work),
                            userType: enumKey.HappyMusic.CurrUserVersion
                        },
                        url: Util.getApiUrl("UploadWork")
                    }, function (data) {
                        //上传成功
                        if (data.ResponseCode == 1) {
                            Util.hideAppLoading();
                            Util.info(data.ResponseMessage, true);
                            that.isConfirmWork = false;
                            Cache.clearCache("UploadWork_key");
                            Cache.getCache("CurrWorkListType", 1);
                            videoPageBack('uploadWork_content_video');
                           
                        } else {
                            Util.hideAppLoading();
                            Util.info(data.ResponseMessage, false);
                        }
                    });
                }
            }, false);
        },
        
    };
    return new obj();
})();