﻿//*******作者 zhoucx 2016-06-23 v1.0.0********//
var SidePage = function (targetId, src, options) {
    var that = this;
    $(targetId).attr("class", "side_page");
    //创建阴影
    var shadow = document.createElement("div");
    shadow.className = "side_page_shadow";
    $(targetId)[0].parentElement.appendChild(shadow);
    //加载完成后回调事件
    var sidePageLoad = function () { };
    var sidePageShow = function () { };
    if (options) {
        var width = options.width ? options.width : "";
        var height = options.height ? options.height : "";
        if (options.onload) {
            sidePageLoad = options.onload;
        }
        if (options.onShow) {
            sidePageShow = options.onShow;
        }
        //尺寸设定
        $(targetId).css("width", width);
        $(targetId).css("height", height);
    }
    //加载SidePage内容
    $(targetId).load(src, null, sidePageLoad);

    that.show = function () {
        $(targetId).css("transition-duration", "400ms");
        $(shadow).css("transition-duration", "400ms");
        $(targetId).css("-webkit-transform", "initial");
        $(shadow).css("-webkit-transform", "initial");
        $(shadow).css("opacity", "0.3");
        sidePageShow();
    };
    that.hide = function () {
        $(targetId).css("-webkit-transform", "");
        $(shadow).css("-webkit-transform", "");
        $(shadow).css("opacity", "0");
    };
    //点击阴影隐藏
    shadow.addEventListener("click", that.hide);

    return that;
}