﻿//*******作者 zhoucx 2016-07-20 v1.0.0********//
var devAfScrollerArray = [];
var devAfScroller = function (targetId, options) {
    var oldObject;
    for (var i = 0; i < devAfScrollerArray.length; i++) {
        if (devAfScrollerArray[i].targetId == targetId) {
            oldObject = devAfScrollerArray[i];
            break;
        }
    }
    var that = oldObject ? oldObject : this;
    that.targetId = targetId;
    that.refreshFunc = options.refreshFunc;
    that.loadMoreFunc = options.loadMoreFunc;
    that.needRefresh = options.refresh == false ? options.refresh : true;
    that.keepPosition = options.keepPosition == true ? true : false;
    that.hasMore = true;
    if (oldObject) {
        return that;
    }
    //布局修正
    if ($("#" + targetId).css("position") != "absolute" && $("#" + targetId).css("position") != "fixed") {
        $("#" + targetId).css("position", "relative");
    }
    //模具下的子元素，视为真正存放数据的div
    that.dataTemp = document.getElementById(targetId).children[0];
    that.dataTemp.classList.add("scroller_content");
    that.dataTemp.style.minHeight = "101%";
    //内容变更时刷新iscroll
    $(that.dataTemp).resize(function (e) {
        if (that.dataTemp.offsetHeight == 0 && that.needRefresh == true) {
            refreshDiv.style.display = "none";
            loadDiv.style.display = "none";
        }
        else if (that.needRefresh == true) {
            refreshDiv.style.display = "";
            loadDiv.style.display = "";
        }
        that.scroller.refresh();
        that.pullUpRange = -(that.dataTemp.offsetHeight - document.getElementById(targetId).offsetHeight + 30);
        if (document.getElementById(targetId).offsetHeight == 0) {
            that.scroller.scrollTo(0, that.currentY);
        }
    });
    //创建scroller对象
    that.scroller = new IScroll("#" + targetId, { probeType: 3, mouseWheel: true });
    //下拉刷新元素div
    var refreshDiv = document.createElement("div");
    //点击加载元素div
    var loadDiv = document.createElement("div");
    if (that.needRefresh == true) {
        refreshDiv.classList.add("scroller_das");
        refreshDiv.style.top = "0";
        refreshDiv.innerHTML = "下拉刷新";
        refreshDiv.id = targetId + "_das_refresh";
        loadDiv.classList.add("scroller_das");
        loadDiv.style.bottom = "0";
        loadDiv.innerHTML = "上拉加载";
        loadDiv.id = targetId + "_das_loadMore";
        if (!document.getElementById(loadDiv.id) && typeof that.loadMoreFunc == 'function') {
            //添加加载条
            document.getElementById(targetId).appendChild(loadDiv);
        }
        if (!document.getElementById(refreshDiv.id) && typeof that.refreshFunc == 'function') {
            //添加刷新条
            document.getElementById(targetId).insertBefore(refreshDiv, that.dataTemp);
        }
    }

    //********注册事件************
    that.pullDownRange = 45;
    that.pullUpRange = -(that.dataTemp.offsetHeight - document.getElementById(targetId).offsetHeight + 30);
    //滚动位置记忆
    that.currentY = 0;
    var scrolling = function () {
        that.currentY = that.scroller.y;
        if (that.pullFlag != 0) {
            return;
        }
        if (that.scroller.y > that.pullDownRange) {
            refreshDiv.innerHTML = "释放刷新";
        }
        else{
            refreshDiv.innerHTML = "下拉刷新";
        }
        if (that.scroller.y < that.pullUpRange) {
            loadDiv.innerHTML = that.hasMore == true ? "释放加载" : "已加载全部";
        }
        else {
            loadDiv.innerHTML = that.hasMore == true ? "上拉加载" : "已加载全部";
        }
    };
    //1为下拉刷新中；2为上拉加载中
    that.pullFlag = 0;
    var touchEnd = function () {
        if (that.scroller.y > that.pullDownRange && typeof that.refreshFunc == 'function') {
            that.pullFlag = 1;
            document.getElementById(targetId).style.paddingTop = "40px";
            refreshDiv.innerHTML = "刷新中";
            that.refreshFunc();
        }
        else if (that.scroller.y < that.pullUpRange && that.hasMore == true && typeof that.loadMoreFunc == 'function') {
            that.pullFlag = 2;
            loadDiv.innerHTML = "加载中";
            that.loadMoreFunc();
        }
    };
    if (that.needRefresh == true) {
        that.scroller.on("scroll", scrolling);
        document.getElementById(targetId).addEventListener("touchend", touchEnd);
    }

    //********以下为方法**********
    that.pullback = function () {
        if (that.pullFlag == 1) {
            document.getElementById(targetId).style.paddingTop = "0";
        }
        else if (that.pullFlag == 2) {
            //that.scroller.maxScrollY = -document.getElementById(targetId).offsetHeight;
        }
        that.pullFlag = 0;
    };
    that.setMoreRecord = function (hasMore) {
        that.hasMore = hasMore;
        refreshDiv.innerHTML = "下拉刷新";
        loadDiv.innerHTML = that.hasMore == true ? "上拉加载" : "已加载全部";
    };
    that.scrollTo = function (point) {
        that.scroller.scrollTo(point.x, point.y);
    };

    that.getTarget = function () {
        return that.scroller;
    };

    that.scrollToTop = function () {
        that.scroller.scrollTo(0, 0);
    };

    devAfScrollerArray.push(that);
    return that;
};