﻿var SongMusicCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            var item = {};
            var myAnswer;
            var IsorNouseGold;
            that.showQuestion();           
        },

        //显示题目
        showQuestion: function () {
            document.getElementById("select_A").src = "images/examination/exam_no.png";
            document.getElementById("select_B").src = "images/examination/exam_no.png";
            document.getElementById("select_C").src = "images/examination/exam_no.png";
            document.getElementById("select_D").src = "images/examination/exam_no.png";

            that.songMusic = {};
            var SongMusic = Cache.getCache("SongMusicInfo");
            that.songMusic = JSON.parse(SongMusic);

            Util.ajax({
                method: "POST",
                data: {
                    gameType: that.songMusic.GameType,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("GetQuestion")
            }, function (data) {
                item = data;
                if (data.GameType == 1) {
                    document.getElementById("title").innerHTML = "听歌识曲";
                    document.getElementById("question_log").src = "images/examination/exam_broadcast.png";
                    document.getElementById("gameaudio").src = data.GameSound;
                }
                else {
                    document.getElementById("title").innerHTML = "看谱辨音";
                    var VersionGameImg = "";
                    if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                        VersionGameImg = "https://oivtccbzb.qnssl.com/";
                    } else {
                        VersionGameImg = "http://7xnbmd.com2.z0.glb.qiniucdn.com/";
                    }
                    if (data.GameImg == VersionGameImg) {
                        document.getElementById("question_log").src = "images/examination/exam_broadcast.png";     
                    }
                    else {
                        document.getElementById("question_log").src = data.GameImg;
                    }
                }

                document.getElementById("game_question").innerHTML = "题目：" + data.GameQuestion;
                document.getElementById("answer_A").innerHTML = data.GameAnswerA;
                document.getElementById("answer_B").innerHTML = data.GameAnswerB;
                document.getElementById("answer_C").innerHTML = data.GameAnswerC;
                document.getElementById("answer_D").innerHTML = data.GameAnswerD;                
            });

        },

        //答题后写入答题信息
        answerInformation:function(){      
            Util.ajax({
                method: "POST",
                data: {
                    gameId: item.GameId,
                    userId: that.LoginUser.UserId,
                    answer: myAnswer,
                    trueAnswer: item.TrueAnswer,
                    gameType: item.GameType,
                    useGold: IsorNouseGold,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("InsertAnswerInfo")
            }, function (data) {
                if(data.ResponseCode == 1){

                }
                else{
                    Util.info(data.ResponseMessage, false);
                    that.showQuestion();
                }
            });
        },

        //播放或暂停音乐
        doPlay: function () {
            if (that.songMusic.GameType == 1)
            {
                var img = document.getElementById("question_log");
                if (img.getAttribute("src", 2) == "images/examination/exam_broadcast.png") {
                    img.src = "images/examination/exam_stop.png";
                    document.getElementById("gameaudio").play();
                }
                else {
                    img.src = "images/examination/exam_broadcast.png";
                    document.getElementById("gameaudio").pause();
                }
            }
        },

      //选择A
        doSelectA:function(){           
            var img = document.getElementById("select_A")
                if (img.getAttribute("src", 2) == "images/examination/exam_no.png") {
                    img.src = "images/examination/exam_select.png";
                }
                else {
                    img.src = "images/examination/exam_no.png";
                }
                that.domyAnswer("A");
        },

        //选择B
        doSelectB:function(){
           var img = document.getElementById("select_B")

                if (img.getAttribute("src", 2) == "images/examination/exam_no.png") {
                    img.src = "images/examination/exam_select.png";
                }
                else {
                    img.src = "images/examination/exam_no.png";
                }
                that.domyAnswer("B");
        },

        //选择C
        doSelectC:function(){
            var img = document.getElementById("select_C")
                if (img.getAttribute("src", 2) == "images/examination/exam_no.png") {
                    img.src = "images/examination/exam_select.png"; 
                }
                else {
                    img.src = "images/examination/exam_no.png";
                }
                that.domyAnswer("C");
        },

        //选择D
        doSelectD:function(){
           var img = document.getElementById("select_D")
                if (img.getAttribute("src", 2) == "images/examination/exam_no.png") {
                    img.src = "images/examination/exam_select.png";    
                }
                else {
                    img.src = "images/examination/exam_no.png";
                }
                that.domyAnswer("D");
        },


        //回答是否正确
        domyAnswer: function (index) {
            if (item.GameType == 1) {
                document.getElementById("question_log").src = "images/examination/exam_broadcast.png";
                document.getElementById("gameaudio").pause();
            }
            else {
                null;
            }
            myAnswer = index;
            //if (document.getElementById("select_A").src == "images/examination/exam_select.png") {
            //    myAnswer = "A";  
            //} else if (document.getElementById("select_B").src == "images/examination/exam_select.png") {
            //    myAnswer = "B";
            //} else if (document.getElementById("select_C").src == "images/examination/exam_select.png") {
            //    myAnswer = "C";
            //} else if (document.getElementById("select_D").src == "images/examination/exam_select.png") {
            //    myAnswer = "D";
            //}

            if (myAnswer == item.TrueAnswer) {
                IsorNouseGold = "false";
                that.answerInformation();
                Util.info("回答正确", true)             
                setTimeout(function () {
                    that.showQuestion();
                }, 1500);
                
            }
            else {
                Util.popConfirm("回答错误", "是否花费1金币观看正确答案", function (result) {                   
                    if (result) {
                        IsorNouseGold = "true";
                        that.answerInformation();
                        //var Gold = 10;
                        if (that.LoginUser.Gold > 0) { 
                            that.LoginUser.Gold--;
                            Cache.setCache("LoginUserInfo",that.LoginUser);
                            var myAnswer;
                            if (item.TrueAnswer == "A") {
                                myAnswer = item.GameAnswerA;
                            }
                            else if (item.TrueAnswer == "B") {
                                myAnswer = item.GameAnswerB;
                            }
                            else if (item.TrueAnswer == "C") {
                                myAnswer = item.GameAnswerC
                            }
                            else if (item.TrueAnswer == "D") {
                                myAnswer = item.GameAnswerD;
                            }
                            Util.popConfirm("正确答案", myAnswer, function (result) {
                                if (result) {
                                    that.showQuestion();
                                }
                            }, true);                                              
                        }               
                    }
                    else {   
                        IsorNouseGold = "false";
                        that.answerInformation();
                        that.showQuestion();
                    }
                    
                }, false)

            }
        },

        //规则说明
        doRegular: function () {
            Util.popConfirm("规则说明", "连续10题全部答对可获得20积分，答错可花费1金币查看答案，并继续做答。", function (result) { },true);
        },

        myBack: function () {
            videoPageBack("gameaudio");
        }
    };
    return new obj();
})();