﻿var HomeworkDetailCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            // add by lujf 2016-12-8 自定义video标签 start
            that.playImgSrc = "images/homeworkTe/play.png";
            that.pauseImgSrc = "images/homeworkTe/pause.png";
            that.fullscreenImgSrc = "images/homeworkTe/fullscreen.png";
            that.cancelFullscreenImgSrc = "images/homeworkTe/cancelFullscreen.png";
            // add by lujf 2016-12-8 自定义video标签 end
            that.loginInfo = Cache.getCache("LoginUserInfo");
            that.homeworkId = Cache.getCache("HomeworkDetail_HomeworkId");
            that.init();
        },

        goBack: function () {
            // add by lujf 2016-12-2 改用自定义的控制条 start
            $("canvas").show();
            $("div[id^='$']").show();
            $("#hd_homework_staff").show();
            // add by lujf 2016-12-2 改用自定义的控制条 end
            if (typeof (that.h) != "undefined")
            {
                that.h.remove();
                that.h.stopPlay();//fixedby lijq 2016/11/11
            }
            var my = document.getElementById("zebraFix");
            document.getElementById("zebra.fm").style.display = "none";
            if (my != null)
                my.parentNode.removeChild(my);
            // add by lujf 2016-12-2 改用自定义的控制条 start
            // 将video 控制条还原
            that.refreshControls();
            // add by lujf 2016-12-2 改用自定义的控制条 end
            //videoPageBack("hd_videoshow");
            $.ui.goBack();
        },

        init: function () {
            //fixed by lijq 2016/12/14  手动写谱子div 的大小
            $("#hd_homework_staff").height(window.innerHeight * 0.75);
            $("#hd_homework_staff").width(window.innerWidth);

            // add by lujf 2016-12-2 自定义video控制条 start
            that.timeDrag = false;
            that.isFullScreen = false;
            $(".hd_play_btn img").attr("src", that.pauseImgSrc);
            // 初始化video控制条
            that.video = $('#hd_videoshow');
            that.video[0].controls = false;

            // 监听播放/暂停点击事件
            if (!that.checkBindEnvent($('.hd_play_btn'), 'click')) {
                $('.hd_play_btn').on('click', function () {
                    if (that.video[0].paused) {
                        $(".hd_play_btn img").attr("src", that.pauseImgSrc);
                        that.video[0].play();
                    }
                    else {
                        $(".hd_play_btn img").attr("src", that.playImgSrc);
                        that.video[0].pause();
                    }
                });
            }
            
            //get HTML5 video time duration 获取video的总时间
            if (!that.checkBindEnvent(that.video, 'loadedmetadata')) {
                that.video.on('loadedmetadata', function () {
                    $('.hd_duration').text(Util.formatTimeSpan(that.video[0].duration));
                });
            }

            //update HTML5 video current play time 获取video当前时间
            if (!that.checkBindEnvent(that.video, 'timeupdate')) {
                that.video.on('timeupdate', function () {
                    $('.hd_current').text(Util.formatTimeSpan(that.video[0].currentTime));
                    var currentPos = that.video[0].currentTime; //Get currenttime
                    var maxduration = that.video[0].duration; //Get video duration
                    var percentage = 100 * currentPos / maxduration; //in %
                    $('.hd_timeBar').css('width', percentage + '%');
                });
            }

            // 监听全屏事件
            if (!that.checkBindEnvent($('.hd_fullscreen_btn'), 'click')) {
                $('.hd_fullscreen_btn').on('click', function () {
                    // 如果是全屏的状态
                    if (that.isFullScreen) {
                        $(".hd_fullscreen_btn img").attr("src", that.fullscreenImgSrc);
                        $(".hd_video_div").removeClass("hd_video_div_full");
                        $("#hd_videoshow").removeClass("hd_video_div_video_full");
                        $("canvas").show();
                        $("#hd_homework_staff").show();
                        setTimeout(function () {
                            $("div[id^='$']").show();
                        }, 400);
                        that.isFullScreen = false;
                    } else {// 如果是非全屏状态
                        $(".hd_fullscreen_btn img").attr("src", that.cancelFullscreenImgSrc);
                        $(".hd_video_div").addClass("hd_video_div_full");
                        $("#hd_videoshow").addClass("hd_video_div_video_full");
                        $("canvas").hide();
                        $("#hd_homework_staff").hide();
                        $("div[id^='$']").hide();
                        that.isFullScreen = true;
                    }
                });
            }

            if (!that.checkBindEnvent($('.hd_progressBar'), 'touchstart')) {
                $('.hd_progressBar').on('touchstart', function (e) {
                    that.timeDrag = true;
                    that.updateBar(e.touches[0].pageX);
                });
            }
            if (!that.checkBindEnvent($('.hd_progressBar'), 'touchend')) {
                $('.hd_progressBar').on('touchend', function (e) {
                    if (that.timeDrag) {
                        that.timeDrag = false;
                    }
                });
            }
            if (!that.checkBindEnvent($('.hd_progressBar'), 'touchmove')) {
                $('.hd_progressBar').on('touchmove', function (e) {
                    if (that.timeDrag) {
                        that.updateBar(e.touches[0].pageX);
                    }
                });
            }
            // add by lujf 2016-12-2 自定义video控制条 end
            Util.ajaxL({
                method: "POST",
                data: {
                    homeworkId: that.homeworkId
                },
                url: Util.getApiUrl("CorrectingHomeworkDetail")
            }, function (resultData) {
                that.maxCount = resultData.HomeStaffList.length;
                that.staffList = resultData.HomeStaffList;
                that.index = 1;
                //加载视频
                $("#hd_videoshow").attr("src", resultData.VideoUrlInfo);

                //若是没有谱子的情况
                if (that.maxCount >= 1) {
                    $("#hd_staff")[0].src = that.staffList[0].StaffImgUrl;
                    //console.log(JSON.parse(resultData.Correct.CorrectContent));
                    var correctContent=JSON.parse(resultData.Correct.CorrectContent);
                    //for (var i = 0; i < correctContent.length; i++)
                    //{
                    //    if (correctContent[i] != "")
                    //    {
                    //        if (typeof (JSON.parse(resultData.Correct.CorrectContent)[i][0].Position) != "undefined") {
                    //            var positionHeight = JSON.parse(resultData.Correct.CorrectContent)[0][0].Position.h;
                    //            var positionWidth = JSON.parse(resultData.Correct.CorrectContent)[0][0].Position.w;
                    //            var width = document.getElementById("content").offsetWidth;
                    //            var height = document.getElementById("hd_homework_staff").offsetHeight;

                    //            if ((positionWidth / positionHeight) > (width / height)) {
                    //                var trueHeight = positionHeight * width / positionWidth;
                    //                $("#hd_staff").css("height", trueHeight + "px");
                    //            }
                    //            else {
                    //                var trueWidth = positionWidth * height / positionHeight;
                    //                $("#hd_staff").css("width", trueWidth + "px");
                    //            }
                    //            break;
                    //        }
                    //    }
                    //}
                    //console.log(document.getElementById("hd_homework_staff").offsetHeight);
                }
                else {// fixedby lijq 2016/11/11 没有谱子的情况下置为空
                    $("#hd_staff").attr('src', '');
                }
                //已批改作业
                zebra.ready(function () {
                    that.h = new ZebDev.happymusic.homework(true, that.noti);//不可编辑画布

                    onRecordPop = function () {
                        that.stopVideo();
                    };

                    if (that.maxCount > 1) {
                        //FixedStart liyl 2016/12/28  https的判断
                        var nextImg = "";
                        if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                            nextImg = "https://oivtg60a1.qnssl.com/next.png";
                        } else {
                            nextImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/next.png";
                        }
                        //定义下一页按钮
                        that.next = new ZebDev.imageButton.imageButton(window.innerWidth - 25, 200, 25, that.nextClick, nextImg).toZebraComp();
                        //FixedEnd
                        mainZebDevPanel.add(that.next);
                    }
                    //添加一个div
                    //var insertText = "<div id='zebraFix' class='x-contents-content x-content-on-left'></div>";
                    //$(insertText).appendTo("#__baseID___pages");

                    //加载批改好的作业
                    if (resultData.HomeworkStatus == 2) {
                        that.correctScore = resultData.Correct.CorrectScore == "" ? 0 : resultData.Correct.CorrectScore;
                        that.correctComment = resultData.Correct.CorrectComment;
                        that.correntList = JSON.parse(resultData.Correct.CorrectContent);
                        if (that.correntList != null) {
                            if (that.h && that.correntList[that.index - 1]) {
                                that.h.reducteCompList(that.correntList[that.index - 1]);
                            }
                        }
                    }
                    else//未批改作业
                    {
                        that.correntList = [];
                        //定义数组
                        for (var i = 0; i < that.maxCount; i++) {
                            that.correntList[i] = "";
                        }
                    }
                });

            }, function () {

            });
            
        },

        // check 某个元素是否绑定了某个事件
        checkBindEnvent:function(selector,eventName){
            //jQuery event封装支持判断元素上是否绑定了事件，此方法只适用于jQuery绑定的事件
            var $events = $._data(selector[0], "events");
            if ($events && $events[eventName]) {
                return true;
            }
            return false;
        },

        //update Progress Bar control 跟新进度条 add by lujf 2016-12-7
        updateBar: function (x) {
            var progress = $('.hd_progressBar');
            var maxduration = that.video[0].duration; //Video duraiton
            var position = x - progress.offset().left; //Click pos
            var percentage = 100 * position / progress.width();

            //Check within range
            if (percentage > 100) {
                percentage = 100;
            }
            if (percentage < 0) {
                percentage = 0;
            }

            //Update progress bar and video currenttime
            $('.hd_timeBar').css('width', percentage + '%');
            that.video[0].currentTime = maxduration * percentage / 100;
        },

        // 还原初始状态 add by lujf 2016-12-2
        refreshControls: function () {
            // 将video 控制条还原
            that.video[0].pause();
            $(".hd_play_btn img").attr("src", that.playImgSrc);
            $('.hd_timeBar').css('width', '0px');
            $('.hd_duration').text("00:00");
            $('.hd_current').text("00:00");
            $(".hd_fullscreen_btn img").attr("src", that.fullscreenImgSrc);
            $(".hd_video_div").removeClass("hd_video_div_full");
            $("#hd_videoshow").removeClass("hd_video_div_video_full");
        },

        //弹出信息
        noti: function (msg) {
            Util.info(msg);
        },

        //清空
        clean: function () {
            if (that.h) {
                that.h.clearCanvas();
            }
        },

        //上一页
        preClick: function () {
            that.correntList[that.index - 1] = that.h.getZebraCompList();

            that.clean();

            if (that.index > 1) {
                that.index -= 1;
                //FixedStart liyl 2016/12/28  https的判断
                var nextImg = "";
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    nextImg = "https://oivtg60a1.qnssl.com/next.png";
                } else {
                    nextImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/next.png";
                }
                //定义下一页按钮
                that.next = new ZebDev.imageButton.imageButton(window.innerWidth - 25, 200, 25, that.nextClick, nextImg).toZebraComp();
                //FixedEnd
                mainZebDevPanel.add(that.next);
                //FixedStart liyl 2016/12/28  https的判断
                var preImg = "";
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    preImg = "https://oivtg60a1.qnssl.com/pre.png";
                } else {
                    preImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/pre.png";
                }
                //FixedEnd
                $("#next").css({ "display": "block" });
                $("#hd_staff")[0].src = that.staffList[that.index - 1].StaffImgUrl;
                if (that.index != 1) {
                    that.pre = new ZebDev.imageButton.imageButton(0, 200, 25, that.preClick, preImg).toZebraComp();
                    mainZebDevPanel.add(that.pre);
                }
            }
            if (that.h && that.correntList[that.index - 1]) {
                that.h.reducteCompList(that.correntList[that.index - 1]);
            }
        },

        //下一页
        nextClick: function () {
            that.correntList[that.index - 1] = that.h.getZebraCompList();
            that.index += 1;

            that.clean();
            //FixedStart liyl 2016/12/28  https的判断
            var preImg = "";
            if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                preImg = "https://oivtg60a1.qnssl.com/pre.png";
            } else {
                preImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/pre.png";
            }
            //FixedEnd
            //定义上一页按钮和下一页按钮
            that.pre = new ZebDev.imageButton.imageButton(0, 200, 25, that.preClick, preImg).toZebraComp();
            mainZebDevPanel.add(that.pre);

            if (that.index < that.maxCount) {
                //定义上一页按钮和下一页按钮
                //FixedStart liyl 2016/12/28  https的判断
                var nextImg = "";
                if (Util.getSystemType() == "IOS" && enumKey.HappyMusic.IOSVersion >= "4.1.0") {
                    nextImg = "https://oivtg60a1.qnssl.com/next.png";
                } else {
                    nextImg = "http://7xkpii.com2.z0.glb.qiniucdn.com/next.png";
                }
                //FixedEnd
                that.next = new ZebDev.imageButton.imageButton(window.innerWidth - 25, 200, 25, that.nextClick, nextImg).toZebraComp();
                mainZebDevPanel.add(that.next);

                $("#hd_staff")[0].src = that.staffList[that.index - 1].StaffImgUrl;
            } else if (that.index == that.maxCount) {
                $("#hd_staff")[0].src = that.staffList[that.index - 1].StaffImgUrl;
            }

            if (that.h && that.correntList[that.index - 1]) {
                that.h.reducteCompList(that.correntList[that.index - 1]);
            }
        },

        //暂停播放视频
        stopVideo: function () {
            // fixed by lujf 2016-12-2 改用自定义的控制条 start
            //var myVideo = $("#hd_videoshow")[0];
            //myVideo.pause();
            $(".hd_play_btn img").attr("src", that.playImgSrc);
            that.video[0].pause();
            // fixed by lujf 2016-12-2 改用自定义的控制条 end
        },

        //显示评论
        showCommentPanel: function () {
            var payPanelId = "hd_comment_panel";
            var payPanel = document.createElement('div');
            document.body.appendChild(payPanel);
            payPanel.className = "hd_comment";
            payPanel.id = payPanelId;

            var html = '     <div class="hd_comment_title">'
                if (that.correctScore >= 1) {
                    html += '      <img src="images/homeworkTe/star.png"/>'
                } else {
                    html += '      <img src="images/homeworkTe/star_empty.png"/>'
                }
                if (that.correctScore >= 2) {
                    html += '      <img src="images/homeworkTe/star.png"/>'
                } else {
                    html += '      <img src="images/homeworkTe/star_empty.png"/>'
                }
                if (that.correctScore >= 3) {
                    html += '      <img src="images/homeworkTe/star.png"/>'
                } else {
                    html += '      <img src="images/homeworkTe/star_empty.png"/>'
                }
                if (that.correctScore >= 4) {
                    html += '      <img src="images/homeworkTe/star.png"/>'
                } else {
                    html += '      <img src="images/homeworkTe/star_empty.png"/>'
                }
                if (that.correctScore >= 5) {
                    html += '      <img src="images/homeworkTe/star.png"/>'
                } else {
                    html += '      <img src="images/homeworkTe/star_empty.png"/>'
                }
                html += '         <div class="hd_comment_close" onclick="HomeworkDetailCtrl.hideCommentPanel()">'
                html += '             <img src="images/homeworkTe/close.png"/>'
                html += '         </div>'
                html += '     </div>'
                html += '  <div class="hd_comment_content">' +( that.correctComment==null? "":that.correctComment) + '</div>';

            payPanel.innerHTML = html;
            payPanel.style.display = 'block';
            showHomeworkBg();
        },

        //隐藏评论
        hideCommentPanel: function () {
            hideHomeworkBg();
            $("#hd_comment_panel").remove();
        }
    };
    return new obj();
})();