﻿var StaffDetailCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            // 数据初始化
            that.staffList = [];
            that.curIndex = 0;
            that.videoInfo = [];
            var videoInfo = Cache.getCache("StaffDetail_videoInfo");
            if (videoInfo) {
                that.videoInfo = JSON.parse(videoInfo);
                //FixedStart byzhusj 2016/10/27
                // 显示数据
                $("#staffDetail_title").html(that.videoInfo.VideoName.split("", 12));
                //FixedEnd
                // 如果不是从曲谱搜索进入
                var pageType = Cache.getCache("BookList_PageType");
                if (pageType != "Staff") {
                    $("#staffDetail_button_view_video").hide();
                } else {
                    $("#staffDetail_button_view_video").show();
                }
                // 获取登录信息
                that.loginInfo = Cache.getCache("LoginUserInfo");
                if (that.loginInfo.UserType == enumKey.UserType.Student) {
                    $("#staffDetail_button_upload_homework").show();
                }
                else {
                    $("#staffDetail_button_upload_homework").hide();
                }
            }

            // 初始化scroller
            //that.listScroll = new devAfScroller("staffDetail_staffImg_panel", { refresh: false });
            //$("#staffDetail_staffImg_panel").height(window.innerHeight - $("#staffDetail_staffImg_panel").offset().top - $(".staffDetail_button_bar").height());

            // 获取图谱
            Util.ajax({
                method: "POST",
                data: {
                    videoId: that.videoInfo.VideoId,
                    userType: that.loginInfo.UserType
                },
                url: Util.getApiUrl("GetStaffByVideoId")
            }, function (data) {
                if (data.length > 0) {
                    that.staffList = data;
                    that.showData();
                }
            });


            // 定义窗口大小变更事件
            $(window).resize(function () {
                $("#staffDetail_staffImg_panel").height(window.innerHeight - $("#staffDetail_staffImg_panel").offset().top - $(".staffDetail_button_bar").height());
                var btnMargin = window.innerHeight * 0.35;
                $(".staffDetail_pre_btn").css("margin-top", btnMargin + "px");
                $(".staffDetail_next_btn").css("margin-top", btnMargin + "px")
            });
        },

        // 显示数据
        showData: function () {
            var showStr = "";
            var btnMargin=window.innerHeight*0.35;
            var maxLength = that.staffList.length;
            showStr += "<img src='" + that.staffList[that.curIndex].StaffImgUrl + "' class='staffDetail_staff_img'/>";
            if (maxLength > 1) {// 表示有多页
                if (that.curIndex > 0) {
                    // 上一页按钮
                    showStr += "<img src='images/learn/pre.png' class='staffDetail_pre_btn' style='margin-top:" + btnMargin + "px' onclick='StaffDetailCtrl.pre()'/>";
                }
                if (that.curIndex < maxLength-1) {
                    // 下一页按钮
                    showStr += "<img src='images/learn/next.png' class='staffDetail_next_btn' style='margin-top:" + btnMargin + "px' onclick='StaffDetailCtrl.next()'/>";
                }
            }
            $("#staffDetail_staffImg_template").html(showStr);
        },

        // 显示上一页
        pre:function(){
            that.curIndex -= 1;
            that.showData();
        },

        // 显示下一页
        next:function(){
            that.curIndex += 1;
            that.showData();
        },

        // 上传作业
        uploadHomework: function () {
            // fixed by lujf 2016-11-23 记录上传作业路径
            //var videoInfo = { BookId: that.videoInfo.BookId, BookType: that.videoInfo.BookType, VideoId: that.videoInfo.VideoId };
            showHomeworkPop(that.videoInfo, function () { });
        },

        // 观看视频
        viewVideo:function(){
            lookVideo(that.videoInfo.VideoId, function (result) {
                if (result) {
                    var videoInfo = Cache.getCache("StaffDetail_videoInfo");
                    Cache.setCache("MusicVideoDetail_videoInfo", videoInfo);
                    toPage('pnl_musicVideoDetail');
                }
            });
        },

        // 点击返回
        goBack: function () {
            $("#staffDetail_title").html("");
            $("#staffDetail_staffImg_template").html("");
            $.ui.goBack();
        }
    };
    return new obj();
})();