﻿var ModifypasswordCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            $("#password_password_input").val("");
            $("#password_repassword_input").val("");
            that.phone = Cache.getCache("PasswordPhone");
            // add by lijq 2016-12-16 屏蔽表情 start
            $("#password_password_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("password_password_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#password_password_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#password_password_input").val(content);
                }
            };
            $("#password_repassword_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("password_repassword_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#password_repassword_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#password_repassword_input").val(content);
                }
            };
            // add by lujf 2016-5-11 屏蔽表情 end
        },

        saveNewPassword: function () {
            var password = $("#password_password_input").val().trim();
            var repassword = $("#password_repassword_input").val().trim();

            if (!password) {
                Util.info("请输入新密码", false);
                return;
            }
            if (!Util.isPassword(password)) {
                Util.info("请设置6-16位数字或英文密码", false);
                return;
            }
            if (!repassword) {
                Util.info("请再一次输入新密码", false);
                return;
            }
            if (!Util.isPassword(repassword)) {
                Util.info("请设置6-16位数字或英文密码", false);
                return;
            }
            if (password != repassword) {
                $("#password_repassword_input").val("");
                Util.info("两次输入的密码不一致，请重新输入", false);
                return;
            }
            debugger;
            Util.ajax({
                method: "POST",
                data: {
                    password: password,
                    phone: that.phone,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("SetPassword")
            }, function (data) {
                debugger;
                if (data.ResponseCode == 1) {
                    Util.info(data.ResponseMessage, true);
                    Cache.clearCache("PasswordPhone");
                    toPage("pnl_login");
                }
            });
        }
    };
    return new obj();
})();