﻿var RegisterCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            var isGoAgreement = Cache.getCache("isGoAgreement");
           
            if (isGoAgreement == true ) {
            } else {
                that.IsStartTiming = false;
                $("#register_tel_input").val("");
                $("#register_authcode_input").val("");
                $("#register_password_input").val("");
                document.getElementById('register_authcode_button').innerHTML = "获取验证码";
                document.getElementById('register_authcode_button').style.background = "#FF4D4D";
                that.CurrUserType = 0;
                $("#register_usertype_te").attr("src", "images/login/paytype_unselected.png");
                $("#register_usertype_st").attr("src", "images/login/paytype_unselected.png");
                // add by lijq 2016-12-16 屏蔽表情 start
                $("#register_tel_input").keypress(function (event) {
                    if (event.which > 65535) {
                        return false;
                    }
                });
                document.getElementById("register_tel_input").oninput = function () {
                    var ranges = [
                       '\ud83c[\udf00-\udfff]',
                       '\ud83d[\udc00-\ude4f]',
                       '\ud83d[\ude80-\udeff]'
                    ];
                    var content = $("#register_tel_input").val().trim();
                    if (Util.isEmojiCharacter(content)) {
                        content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                        $("#register_tel_input").val(content);
                    }
                };
                $("#register_authcode_input").keypress(function (event) {
                    if (event.which > 65535) {
                        return false;
                    }
                });
                document.getElementById("register_authcode_input").oninput = function () {
                    var ranges = [
                       '\ud83c[\udf00-\udfff]',
                       '\ud83d[\udc00-\ude4f]',
                       '\ud83d[\ude80-\udeff]'                       
                    ];
                    var content = $("#register_authcode_input").val().trim();
                    if (Util.isEmojiCharacter(content)) {
                        content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                        $("#register_authcode_input").val(content);
                    }
                };
                $("#register_password_input").keypress(function (event) {
                    if (event.which > 65535) {
                        return false;
                    }
                });
                document.getElementById("register_password_input").oninput = function () {
                    var ranges = [
                       '\ud83c[\udf00-\udfff]',
                       '\ud83d[\udc00-\ude4f]',
                       '\ud83d[\ude80-\udeff]'
                    ];
                    var content = $("#register_password_input").val().trim();
                    if (Util.isEmojiCharacter(content)) {
                        content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                        $("#register_password_input").val(content);
                    }
                };
                // add by lujf 2016-5-11 屏蔽表情 end
                
            }
        },

        //发送短信验证码
        SendAuthcode: function () {
            
            if (!that.IsStartTiming) {
                var Phone = $("#register_tel_input").val().trim();
                if (!Phone) {
                    Util.info("请输入手机号",false);
                    return;
                }
                if (!Util.isMobile(Phone)) {
                    Util.info("请输入有效的手机号", false);
                    return;
                }
                Util.ajax({
                    method: "POST",
                    data: {
                        phone: Phone,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("SendAuthcode")
                }, function (data) {
                    if (data == "SUCCESS") {
                        Util.info("发送验证码成功",true);
                        that.currPhone = Phone;
                        that.showTime();
                    }
                });
            }          
        },
        //显示倒计时
        showTime: function () {
            that.IsStartTiming = true;
            //计时器
            that.leftSeconds = 60;
            that.cdtime = setInterval(function () {
                that.leftSeconds--;
                document.getElementById('register_authcode_button').innerHTML = that.leftSeconds+"s后重新获取";
                document.getElementById('register_authcode_button').style.background = "#A2A2A2";
                if (that.leftSeconds <= 0) {
                    that.IsStartTiming = false;
                    clearInterval(that.cdtime);
                    document.getElementById('register_authcode_button').innerHTML = "获取验证码";
                    document.getElementById('register_authcode_button').style.background = "#FF4D4D";
                }
            }, 1000);
        },
        NextRegister: function () {
            if (!that.currPhone) {
                Util.info("请获取验证码", false);
                return;
            }

            var Authcode = $("#register_authcode_input").val().trim();
            if (!Authcode) {
                Util.info("请输入您收到的5位验证码", false);
                return;
            }

            var Password = $("#register_password_input").val().trim();
            if (!Password) {
                Util.info("请输入密码", false);
                return;
            }
            if (!Util.isPassword(Password)){
                Util.info("请设置6-16位数字或英文密码", false);
                return;
            }
            if (that.CurrUserType == 0) {
                Util.info("请选择用户类型", false);
                return;
            }
            Util.ajax({
                method: "POST",
                data: {
                    phone: that.currPhone,
                    authcode: Authcode,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("CheckAuthcode")
            }, function (data) {
                if (data == enumKey.CheckAuthcodeEnum.Success) {
                    Cache.setCache("RegisterPhone", that.currPhone);
                    Cache.setCache("RegisterPassword", Password);
                    Cache.setCache("GoAgreement", false);
                    Cache.setCache("RegisterUserOrOpenId","");
                    Cache.setCache("RegisterloginType", 0);
                    Cache.setCache("RegisterUserType", that.CurrUserType);
                    // fixed by lujf 2016-11-28 start
                    if (that.IsStartTiming) {
                        clearInterval(that.cdtime);
                    }
                    // fixed by lujf 2016-11-28 end
                    toPage('pnl_perfectinfo');
                } else if (data == enumKey.CheckAuthcodeEnum.Wrong) {
                    Util.info("您输入的验证码错误，请重新输入", false);
                    $("#register_authcode_input").val("");
                } else if (data == enumKey.CheckAuthcodeEnum.TimeOut) {
                    Util.info("您输入的验证码已过期，请重新输入", false);
                    $("#register_authcode_input").val("");
                }
            });
        },
        GoAgreementPage: function () {
            Cache.setCache("GoAgreement", true);
            toPage('pnl_agreement');
        },
        registerBack: function () {
            if (that.IsStartTiming) {
                clearInterval(that.cdtime);
            }
            $.ui.goBack();
        },
        clickUserType: function (index) {
            if (index == 1) {
                that.CurrUserType = enumKey.UserType.Student;
                $("#register_usertype_st").attr("src", "images/login/radio_active.png");
                $("#register_usertype_te").attr("src", "images/login/paytype_unselected.png");
            } else if (index == 2) {
                that.CurrUserType = enumKey.UserType.Teacher;
                $("#register_usertype_te").attr("src", "images/login/radio_active.png");
                $("#register_usertype_st").attr("src", "images/login/paytype_unselected.png");
            }
        }
    };
    return new obj();
})();