﻿var ChangePhoneCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };
   
    obj.prototype = {        
        ctrl: function () {
            $("#cp_text1_div_right_input").val("");
            $("#cp_text2_div_center_input").val("");
            that.IsStartTiming = false;
            document.getElementById("cp_text2_div_right_button").innerHTML = "获取验证码";
            document.getElementById("cp_text2_div_right_button").style.color = "#FF4D4D";

            // add by lijq 2016-12-16 屏蔽表情 start
            $("#cp_text1_div_right_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("cp_text1_div_right_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#cp_text1_div_right_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#cp_text1_div_right_input").val(content);
                }
            };
            $("#cp_text2_div_center_input").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("cp_text2_div_center_input").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#cp_text2_div_center_input").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#cp_text2_div_center_input").val(content);
                }
            };
            // add by lujf 2016-5-11 屏蔽表情 end
        },


        //获取验证码
        SendAuthcode: function () {
            if (!that.IsStartTiming) {
                var Tel = $("#cp_text1_div_right_input").val().trim();
                if (!Tel) {
                    Util.info("手机号码不能为空");
                    return;
                }
                if (!Util.isMobile(Tel)) {
                    Util.info("请输入有效的手机号码");
                    return;
                }
                Util.ajax({
                    method: "POST",
                    data: {
                        phone: Tel,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("SendAuthcode")
                }, function (data) {
                    if (data == "SUCCESS") {
                        Util.info("发送验证码成功", true);
                        that.currPhone = Tel;
                        that.showTime();
                    }
                });
            }
        },

        //显示倒计时
        showTime: function () {
            that.IsStartTiming = true;
            //计时器
            that.leftSeconds = 60;
            that.cdtime = setInterval(function () {
                that.leftSeconds--;
                document.getElementById("cp_text2_div_right_button").innerHTML = that.leftSeconds + "s后重新获取";
                document.getElementById("cp_text2_div_right_button").style.background = "#ffffff";
                document.getElementById("cp_text2_div_right_button").style.color = "#A9A9A9";
                if (that.leftSeconds <= 0) {
                    that.IsStartTiming = false;
                    clearInterval(that.cdtime);
                    document.getElementById("cp_text2_div_right_button").innerHTML = "获取验证码";
                    document.getElementById("cp_text2_div_right_button").style.color = "#FF4D4D";
                }
            }, 1000);
        },
            
        doOk: function () {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            if (!that.currPhone) {
                Util.info("请获取验证码", false);
                return;
            }
            var Authcode = $("#cp_text2_div_center_input").val().trim();
            if (!Authcode) {
                Util.info("请输入您收到的5位验证码", false);
                return;
            }
            var Tel = $("#cp_text1_div_right_input").val().trim();
            Util.ajax({
                method: "POST",
                data: {
                    userId: that.LoginUser.UserId,//userId: 1,
                    phone: that.currPhone,
                    authcode: Authcode,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("ModifyTel")
            }, function (data) {
                if (data.ResponseCode == 0) {
                    that.LoginUser.Phone = Tel;
                    Cache.setCache("RegisterPhone", that.currPhone);
                    Cache.setCache("LoginUserInfo", that.LoginUser);
                    Util.info(data.ResponseMessage, true);
                    toPage('pnl_personalData');
                } else {
                    Util.info(data.ResponseMessage, false);
                    $("#cp_text2_div_center_input").val("");
                }
            });
        },
        changePhoneBack: function () {
            if (that.IsStartTiming) {
                clearInterval(that.cdtime);
            }
           inputPageBack();
        }
    };
    return new obj();
})();