﻿var ModifyPswCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            document.getElementById("mp_div_oldpsw").value = "";
            document.getElementById("mp_div_newpsw").value = "";
            document.getElementById("mp_div_confirmpsw").value = "";
            // add by lijq 2016-12-21 屏蔽表情 start
            $("#mp_div_oldpsw").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("mp_div_oldpsw").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#mp_div_oldpsw").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#mp_div_oldpsw").val(content);
                }
            };
            $("#mp_div_newpsw").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("mp_div_newpsw").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#mp_div_newpsw").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#mp_div_newpsw").val(content);
                }
            };
            $("#mp_div_confirmpsw").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("mp_div_confirmpsw").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]',
                   '\ud83d[\udc00-\ude4f]',
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#mp_div_confirmpsw").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#mp_div_confirmpsw").val(content);
                }
            };
            // add by lujf 2016-12-21 屏蔽表情 end
        },

        doModify: function () {
            var oldPsw = $("#mp_div_oldpsw").val().trim();
            var newPsw = $("#mp_div_newpsw").val().trim();
            var comfirmPsw = $("#mp_div_confirmpsw").val().trim();
            if (!Util.isPassword(newPsw)) {
                Util.info("请设置6-16位数字或英文密码", false);
                return;
            }
            if (comfirmPsw != newPsw) {
                Util.info("两次填写的密码不一致", false);
                return;
            }
            if (oldPsw == newPsw) {
                Util.info("新密码和旧密码一致", false);
                return;
            }
            Util.ajax({
                method: "POST",
                data: {
                    newPassword:newPsw,
                    oldPassword:oldPsw,
                    userId: that.LoginUser.UserId,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("ModifyPassword")
            },function(data){
                if (data.ResponseCode == 1) {
                    Util.info(data.ResponseMessage, true);
                    //toPage("pnl_install");
                    $.ui.goBack();
                }
                else {
                    Util.info(data.ResponseMessage,false);
                }
            });
        }       
    };
    return new obj();
})();