﻿var MyCollectionCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.changeTab(1);
            that.LoginUser = Cache.getCache("LoginUserInfo");
            document.getElementById("vc_list_content").style.height = document.getElementById("content").offsetHeight - $("#vc_title_div").height()-35 + "px";
            document.getElementById("ma_list_content").style.height = document.getElementById("content").offsetHeight - $("#vc_title_div").height()-35 + "px";
            //初始化收藏视频列表
            that.videoListScroll = new devAfScroller("vc_list_content", {
                refreshFunc: that.loadVideoList,
                loadMoreFunc: that.loadVideoMore
            });
            //初始化好友关注列表
            that.AttentionListScroll = new devAfScroller("ma_list_content", {
                refreshFunc:false //that.loadAttentionList,
                // loadMoreFunc: that.loadAttentionMore
                
            });
            that.loadAttentionList();
            that.videoListScroll.scrollTo({ x: 0, y: 0 });
            //that.AttentionListScroll.scrollTo({ x: 0, y: 0 });
            that.videoDataList = [];
            that.attentionDataList = [];           
        },

        

        //已关注或取消关注
        doAttent: function (AttentionUserId) {
            Util.popConfirm("提示", "是否确定取消", function (result) {
                if (result) {
                    that.cancelAttention(AttentionUserId);                    
                }             
            }, false);
           
        },

        //改变选择内容
        changeTab: function (index) {
            $("#vc_title_div_left").css('border-bottom', 'none');
            $("#vc_title_div_right").css('border-bottom', 'none');
            $("#vc_list_content").css('display', 'none');
            $("#ma_list_content").css('display', 'none');
            if (index == 1) {
                document.getElementById("vc_list_template").innerHTML = "";
                $("#vc_title_div_left").css('border-bottom', '2px solid red');
                $("#vc_list_content").css('display', 'block');
                $("#vc_list_content").addClass('vc_list_content');
                $("#ma_list_content").removeClass('ma_list_content');
                that.loadVideoList();               
            }
            else {
                document.getElementById("ma_list_template").innerHTML = "";
                $("#vc_title_div_right").css('border-bottom', '2px solid red');
                $("#ma_list_content").addClass('ma_list_content');
                $("#ma_list_content").css('display', 'block');
                $("#vc_list_content").removeClass('vc_list_content');
                that.loadAttentionList();                
            }
        },

        //获取收藏视频列表
        getVideoList: function (pageIndex) {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            Util.ajax({
                method: "POST",
                data: {
                    userId: that.LoginUser.UserId,
                    videoName: "",
                    pageSize: 10,
                    pageIndex: pageIndex,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("CollectList")
            }, function (data) {
                if (data.DataList.length > 0) {
                    //FixedStart byzhusj 2016/11/10
                    if (pageIndex == 0) {
                        that.videoDataList = [];
                        $("#vc_list_template").html("");
                    }
                    that.videoDataList = that.videoDataList.concat(data.DataList);
                    //FixedEnd
                    that.showVideoList(data.DataList);
                    that.videoListScroll.setMoreRecord(data.DataList.length == 10 ? true : false);
                    that.videoListScroll.pullback();
                }
                //FixedStart byzhusj 2016/11/10
            }, function () {
                that.videoListScroll.pullback();
                //FixedEnd
            });
        },

        //获取好友关注列表
        getAttentionList: function (pageIndex) {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            Util.ajax({
                method: "POST",
                data: {
                    userId: that.LoginUser.UserId,
                    userName: "",
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("AttentionList")
            }, function (data) {
                if (data.length > 0) {
                    //FixedStrat byzhusj 2016/11/10
                    if (pageIndex == 0) {
                        that.attentionDataList = [];
                        $("#ma_list_template").html("");
                    }
                    that.attentionDataList = data;
                    //that.attentionDataList = that.attentionDataList.concat(data);
                    //FixedEnd
                    that.showAttentionList(data);
                    //that.AttentionListScroll.setMoreRecord(data.length == 10 ? true : false);
                    //that.AttentionListScroll.pullback();
                }
                //FixedStart byzhusj 2016/11/10
            //}, function () {
            //    that.AttentionListScroll.pullback();
            //    //FixedEnd
            });
        },

        //取消收藏
        cancelVide:function(){
            Util.ajax({
                method: "POST",
                data: {
                    userVideoId:that.videoDataList.UserVideoId,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("CancelCollect")
            }, function (data) {

            });
        },

        //取消关注
        cancelAttention: function (AttentionUserId) {
            that.LoginUser = Cache.getCache("LoginUserInfo");
            Util.ajax({
                method: "POST",
                data: {
                    userId:that.LoginUser.UserId,
                    attentionUserId:AttentionUserId,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("CancelAttention")
            }, function (data) {
                if (data.ResponseCode == 1) {
                    $("#ma_list_template").html("");
                    that.loadAttentionList();
                    Util.info(data.ResponseMessage,true)
                }
                else {
                    Util.info(data.ResponseMessage, false)
                }
            });
        },
        
        loadVideoList:function(){
            that.getVideoList(0);
        },

        loadVideoMore: function () { 
            that.getVideoList(that.videoDataList.length);
        },

        loadAttentionList:function(){
            that.getAttentionList(0);
        },

        //loadAttentionMore: function () {
        //    that.getAttentionList(that.attentionDataList.length);
        //},
        
        //显示收藏视频列表
        showVideoList: function (obj) {
            var videoList = obj;
            var showStr = "";
            for (var i = 0; i < videoList.length; i++) {
                showStr += '<div id="vc_list_template" class="vc_list_template">'
                        + '<div class="vc_item_left">'
                        + '<img src="images/learn/1.png" />'
                        + '</div>'
                        + '<div class="vc_item_content">'
                        + '<div class="vc_item_content_name">' + videoList[i].VideoName + '</div>'
                        + '<div class="vc_item_content_playcount">'
                        + '<img src="images/learn/play_count.png" />'
                        + '<span>' + videoList[i].ClickCount + '</span>'
                        + '</div>'
                        + '</div>';
                if (that.LoginUser.UserType == 1) {
                    showStr += '<div class="vc_item_right">'
                            + '<div class="vc_item_right_top" data="' + videoList[i].VideoId + '*' + videoList[i].CustomType + '*' + videoList[i].VideoName + '">观看视频</div>'
                            + '<div class="vc_item_right_bottom" data="' + videoList[i].VideoId + '">上传作业</div>';
                }
                else {
                    showStr += '<div class="vc_item_right" style="padding-top:25px;">'
                            + '<div class="vc_item_right_top" data="' + videoList[i].VideoId + '*' + videoList[i].CustomType + '*' + videoList[i].VideoName + '">观看视频</div>';
                }
                showStr += '</div></div>';
            }
            $("#vc_list_template").append(showStr);
            //FixedStart by lijq 2016/11/4  
            CommonClickEvent(".vc_item_right_top", function (isClick, value) {
                if (isClick) {
                    var index = value.split("*");
                    that.toPageVideo(index[0], index[1],index[2]);
                }
            });
            CommonClickEvent(".vc_item_right_bottom", function (isClick, value) {
                if (isClick) {
                    that.showPop(value);
                }
            });
            //FixedEnd
        },

        //显示好友关注列表
        showAttentionList: function (obj) {
            var attentionList = obj;
            var showStr = "";
            for (var j = 0; j < attentionList.length; j++) {
                showStr += '<div class="ma_list_template" id="ma_list_template">'
                       + '<div class="ma_left">'
                       + '<div class="ma_left_image" ><img src="' + attentionList[j].HeadImg + '"/></div>'
                       + '<div class="ma_left_font">' + attentionList[j].Nickname + '</div></div>'
                       + '<div class="ma_right" data="' + attentionList[j].AttentionUserId + '">'
                       + '<img src="images/person/not_attent.png" style="width:33px;text-align:right;" id="ma_right_image1" /></div></div>';
            }
            
            $("#ma_list_template").append(showStr);
            //FixedStart by lijq 2016/11/4  
            CommonClickEvent(".ma_right", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.doAttent(index);
                }
            });
            //FixedEnd
        },

        //跳转到播放视频画面
        toPageVideo: function (videoId, type, videoName) {
            var videoInfo = JSON.stringify({ BookId: 0, BookType: 0, VideoId: videoId, VideoName: videoName });
            lookVideo(videoId, function (res) {
                if (!res) { return; }
                //乐器类
                if (type == 1) {
                    lookVideo(videoId, function (result) {
                        if (result) {
                            Cache.setCache("MusicVideoDetail_videoInfo", videoInfo);
                            toPage("pnl_musicVideoDetail");
                        }
                    });
                }
                //舞蹈类
                if (type == 2) {
                    lookVideo(videoId, function (result) {
                        if (result) {
                            Cache.setCache("DanceVideoDetail_videoInfo", videoInfo);
                            toPage("pnl_danceVideoDetail");
                        }
                    });
                }
            });
        },

        //弹出选择框
        showPop: function (videoId) {
            // fixed by lujf 2016-11-24 记录上传作业路径 start
            var getDataSql = "select v.VideoId,v.VideoName,v.BookId,b.BookName,b.BookType from t_video v left join t_book b on v.BookId = b.BookId where v.VideoId =" + videoId;
            // 取出本地数据
            db.fetchAll(getDataSql, function (ret) {
                if (ret.length > 0) {
                    var videoInfo = {
                        BookId: ret[0].BookId,
                        BookName: ret[0].BookName,
                        BookType: ret[0].BookType,
                        VideoId: ret[0].VideoId,
                        VideoName: ret[0].VideoName
                    };
                    showHomeworkPop(videoInfo, function () { });
                }
                else {
                    // todo 去后台取数据
                    Util.ajax({
                        method: "POST",
                        data: {
                            videoId: videoId,
                            userType: enumKey.HappyMusic.CurrUserVersion
                        },
                        url: Util.getApiUrl("GetVideoInfoForUpdateHomework404")
                    }, function (data) {
                        if (data.length > 0) {
                            var videoInfo = {
                                BookId: data[0].BookId,
                                BookName: data[0].BookName,
                                BookType: data[0].BookType,
                                VideoId: data[0].VideoId,
                                VideoName: data[0].VideoName
                            };
                            showHomeworkPop(videoInfo, function () { });
                        }
                    });
                    
                }
            }, function () {
            });
            // fixed by lujf 2016-11-24 记录上传作业路径 end
        },
    };
    return new obj();
})();