﻿var CommentWorkCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            $("#commentWork_textarea_content").val("");
            that.loginUser = Cache.getCache("LoginUserInfo");
            that.WorkId = Cache.getCache("CurrWorkId");
            that.WorkPersonInfo = Cache.getCache("CurrWorkPersonInfo");
            if (that.loginUser == undefined) {
                Cache.getDbCache("LoginUserInfo", function (result) {
                    if (result) {
                        that.loginUser = result;
                    } else {
                        toPage("pnl_login");
                    }
                });
            }
            // add by lijq 2016-12-16 屏蔽表情 start
            $("#commentWork_textarea_content").keypress(function (event) {
                if (event.which > 65535) {
                    return false;
                }
            });
            document.getElementById("commentWork_textarea_content").oninput = function () {
                var ranges = [
                   '\ud83c[\udf00-\udfff]', 
                   '\ud83d[\udc00-\ude4f]', 
                   '\ud83d[\ude80-\udeff]'
                ];
                var content = $("#commentWork_textarea_content").val().trim();
                if (Util.isEmojiCharacter(content)) {
                    content = content.replace(new RegExp(ranges.join('|'), 'g'), '');
                    $("#commentWork_textarea_content").val(content);
                }
            };
            // add by lujf 2016-5-11 屏蔽表情 end
        },

        saveComment: function () {
            var content = $("#commentWork_textarea_content").val().trim();
            if (!content) {
                Util.info("请输入您评论的内容", false);
                return;
            }
            if (content.length > 200) {
                Util.info("内容长度不能超过200个字符", false);
                return;
            }
            Util.ajax({
                method: "POST",
                data: {
                    userId: that.loginUser.UserId,
                    workId: that.WorkId,
                    personId: that.WorkPersonInfo.UserId,
                    content:content,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("AddCommentWork")
            }, function (data) {
                if (data.ResponseCode == 1) {
                    Util.info("评论成功", true);
                    $.ui.goBack();
                } else {
                    Util.info("系统正在努力加载，请稍后重试!", false);
                    return;
                }
            });
        },
        
    };
    return new obj();
})();