﻿var WorkDetailCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginUser = Cache.getCache("LoginUserInfo");
            that.WorkId = Cache.getCache("CurrWorkId");
            that.dataCommentlist = [];
            that.dataWorkDetail = {};
            debugger;
            if (that.loginUser == undefined) {
                Cache.getDbCache("LoginUserInfo", function (result) {
                    if (result) {
                        that.loginUser = result;
                        that.GetWorkDetail();
                        that.GetCommentList();
                        that.workDetailScroller = new devAfScroller("workDetail_content_container", { refresh: false });
                        that.workDetailScroller.scrollToTop();
                    } else {
                        toPage("pnl_login");
                    }
                });
            } else {
                that.GetWorkDetail();
                that.GetCommentList();
                that.workDetailScroller = new devAfScroller("workDetail_content_container", { refresh: false });
                that.workDetailScroller.scrollToTop();
            }
            //FixedStart byzhusj 2016/11/4
            CommonClickEvent(".workDetail_headerimg_div", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.goMyWorkList();
                }
            });
            CommonClickEvent(".workDetail_attention_div", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.attentionBtn();
                }
            });
            CommonClickEvent(".workDetail_comment_div", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.commentWorkBtn();
                }
            });
            CommonClickEvent(".flower_click", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.flowerClick();
                }
            });
            CommonClickEvent(".share_click", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    that.shareClick();
                }
            });
            //FixedEnd
       
            //fixedby lijq 2016/11/15  如果不是ios系统，则添加唤醒进度条的功能
            if (Util.getSystemType() != "IOS") {  
                that.setControl();
            }
            that.init();
        },

        //fixedby lijq 2016/11/15 安卓手机，播放视频时，controllers 进度条一直显示
        setControl: function (){
            var video = document.getElementById("workDetail_content_video");
            video.controls = false;
            setTimeout(function () { that.setControl() }, 10);
        },


        //获取作品详情
        GetWorkDetail: function () {
            
            Util.ajax({
                method: "POST",
                data: {
                    wordId: that.WorkId,
                    userId: that.loginUser.UserId, //that.loginUser.UserId,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("GetWorkDetail")
            }, function (data) {
                that.loadWorkDetail(data);
                that.dataWorkDetail = data;
                Cache.setCache("CurrWorkPersonInfo", data);
            }, function () {
               
            });
        },
        //获取评论列表
        GetCommentList: function (pageIndex) {
           
            Util.ajax({
                method: "POST",
                data: {
                    wordId: that.WorkId,
                    userType: enumKey.HappyMusic.CurrUserVersion
                },
                url: Util.getApiUrl("CommentList")
            }, function (data) {
                document.getElementById("workDetail_commentList_box").innerHTML = "";
                that.dataCommentlist = data;
                that.loadComment();
            }, function () {

            });
        },
        loadWorkDetail: function (workDetail) {
            $("#workDetail_headerimg").attr("src", (workDetail.HeadImg == null || workDetail.HeadImg == "") ? "images/background_img.jpg" : workDetail.HeadImg);
            $("#workDetail_name").html(workDetail.Nickname == null ? "" : workDetail.Nickname);
            $("#workDetail_time").html(workDetail.CreateTimeYearStr);
            $("#workDetail_attention_span").html(workDetail.isAttention ? "取消关注" : "+关注");
            $("#workDetail_cell_title").html(workDetail.WorkName == null ? "" : workDetail.WorkName);
            $("#workDetail_cell_desc").html(workDetail.WorkDescription == null ? "" : workDetail.WorkDescription);
            $("#workDetail_content_video").attr("src", (workDetail.WorkVideoStr == null || workDetail.WorkVideoStr == "") ? "" : workDetail.WorkVideoStr);
            $("#workDetail_comment_count").html(workDetail.CommentCount);
            $("#workDetail_flower_count").html(workDetail.Flower);
           
        },
        loadComment: function () {
            var commentList = that.dataCommentlist;
            for (var i = 0; i < commentList.length; i++) {
                var item = document.createElement("div");
                var str = '<div class="workDetail_commentList_headerimg_box">'
                        + '<div class="workDetail_commentList_headerimg_div">'
                        + '<img src="' + ((commentList[i].UserHeadImg == null || commentList[i].UserHeadImg == "") ? "images/background_img.jpg" : commentList[i].UserHeadImg) + '" />'
                        + ' </div>'
                        + ' </div>'
                        + '<div class="workDetail_commentList_content_div">'
                        + '<div class="workDetail_commentList_content_name">' + (commentList[i].UserName == null ? "" : commentList[i].UserName) + '</div>'
                        + '<div class="workDetail_commentList_content_time">' + commentList[i].CreateTimeStr + '</div>'
                        + '<div style="word-wrap:break-word;">' + (commentList[i].Content == null ? "" : commentList[i].Content) + '</div>'
                        + '</div>';
                item.innerHTML = str;
                document.getElementById("workDetail_commentList_box").appendChild(item);
            }
        },
        goMyWorkList: function () {
            var isShowMyWorkList = Cache.getCache("isShowMyWorkList");
            $("#workDetail_content_video")[0].pause();
            if (isShowMyWorkList) {
                toPage('pnl_myWorkList');
            }
        },
        attentionBtn: function () {
            if (that.dataWorkDetail.isAttention) {
                //已关注--取消关注
                Util.ajax({
                    method: "POST",
                    data: {
                        userId: that.loginUser.UserId, //that.loginUser.UserId,
                        attentionUserId: that.dataWorkDetail.UserId,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("CancelAttention")
                }, function (data) {
                    if (data.ResponseCode == 1) {
                        $("#workDetail_attention_span").html("+关注");
                        that.dataWorkDetail.isAttention = false;
                    } else {
                        Util.info("系统正在努力加载，请稍后重试!", false);
                        return;
                    }
                }, function () {

                });

            } else {
                //未关注--关注
                Util.ajax({
                    method: "POST",
                    data: {
                        userId: that.loginUser.UserId, //that.loginUser.UserId,
                        attentionUserId:that.dataWorkDetail.UserId,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("AddAttentionWork")
                }, function (data) {
                    if (data.ResponseCode == 1) {
                        $("#workDetail_attention_span").html("取消关注");
                        that.dataWorkDetail.isAttention = true;
                    } else {
                        Util.info("系统正在努力加载，请稍后重试!", false);
                        return;
                    }
                }, function () {

                });
            }
        },
        flowerClick: function () {

            if (that.loginUser.Flower > 0) {
                //直接献花
                Util.ajax({
                    method: "POST",
                    data: {
                        userId: that.loginUser.UserId, //that.loginUser.UserId,
                        workId: that.WorkId,
                        userType: enumKey.HappyMusic.CurrUserVersion
                    },
                    url: Util.getApiUrl("LayFlowersWork")
                }, function (data) {
                    if (data.ResponseCode == 1) {
                       
                        Util.info("恭喜您献花成功啦~", true);
                        $("#workDetail_flower_count").html(that.dataWorkDetail.Flower + 1);
                        that.loginUser.Flower = that.loginUser.Flower - 1;
                        that.dataWorkDetail.Flower = that.dataWorkDetail.Flower + 1;
                        Cache.setCache("LoginUserInfo", that.loginUser);
                        Cache.setDbCache("LoginUserInfo", that.loginUser);
                    } else {
                        Util.info(data.ResponseMessage, false);
                        return;
                    }
                }, function () {

                });

            } else {

                var content = '<div style=" text-align: center;padding: 8px 0px;">您还没有鲜花 &nbsp&nbsp 是否购买</div>';
                Util.popConfirm("提示", content, function (result) {
                    if (result) {
                        //更新数据库里面的积分等信息
                        IndexRefreshGoldInfo(function (dataInfo) {
                            if (dataInfo) {
                                that.loginUser = Cache.getCache("LoginUserInfo");
                                //购买献花-》献花
                                BuyFlowers(that.loginUser.UserId, that.WorkId, dataInfo.Integral, true, function (result) {
                                    if (result != null) {
                                        //更新页面及缓存数据
                                        $("#workDetail_flower_count").html(that.dataWorkDetail.Flower + 1);
                                        that.loginUser.Flower = result.Flower;
                                        that.loginUser.Integral = result.Integral;
                                        that.dataWorkDetail.Flower = that.dataWorkDetail.Flower + 1;
                                        Cache.setCache("LoginUserInfo", that.loginUser);
                                        Cache.setDbCache("LoginUserInfo", that.loginUser);
                                    }
                                });
                            }
                        });
                      
                    }
                }, false);
            }
        },
        shareClick: function () {
            showSharePop(2);
        },
        uploadWorkBtn: function () {
            $("#workDetail_content_video")[0].pause();
            Util.ajax({
                method: "POST",
                data: {
                    spaceName: "video"
                },
                url: Util.getApiUrl("GetUptoken")
            }, function (data) {
                DDVideo.upload(data, that.loginUser.UserId, function (key) {
                    if (key != "") {
                        Cache.setCache("UploadWork_key", key);
                        toPage("pnl_uploadWork");
                    }
                });
            }, function () {
                Util.info("您的网络有问题哦~");
                callBack(false);
            });
        },

        //本页面返回，暂停播放
        myBack: function () {
            videoPageBack("workDetail_content_video");
            that.refreshControls();
        },
        commentWorkBtn: function () {
            $("#workDetail_content_video")[0].pause();
            $(".workDetail_play_btn img").attr("src", "images/homeworkTe/pause.png");
            toPage('pnl_commentWork');
        },

        //自定义video控制条
        init: function () {
            that.timeDrag = false;
            that.isFullScreen = false;
            var playImgSrc = "images/homeworkTe/play.png";
            var pauseImgSrc = "images/homeworkTe/pause.png";
            var fullscreenImgSrc = "images/homeworkTe/fullscreen.png";
            var cancelFullscreenImgSrc = "images/homeworkTe/cancelFullscreen.png";
            var myVideo = document.getElementById("workDetail_content_video");
            // 监听播放/暂停点击事件
            if (!that.checkBindEnvent($('.workDetail_play_btn'), 'click')) {
                $('.workDetail_play_btn').on('click', function () {
                    if (myVideo.paused) {
                        $(".workDetail_play_btn img").attr("src", pauseImgSrc);
                        myVideo.play();
                    }
                    else {
                        $(".workDetail_play_btn img").attr("src", playImgSrc);
                        myVideo.pause();
                    }
                });
            }

            //get HTML5 video time duration 获取video的总时间
            if (!that.checkBindEnvent($("#workDetail_content_video"), 'loadedmetadata')) {
                $("#workDetail_content_video").on('loadedmetadata', function () {
                    $('.workDetail_duration').text(Util.formatTimeSpan(myVideo.duration));
                });
            }

            //update HTML5 video current play time 获取video当前时间
            if (!that.checkBindEnvent($("#workDetail_content_video"), 'timeupdate')) {
                $("#workDetail_content_video").on('timeupdate', function () {
                    $('.workDetail_current').text(Util.formatTimeSpan(myVideo.currentTime));
                    var currentPos = myVideo.currentTime; //Get currenttime
                    var maxduration = myVideo.duration; //Get video duration
                    var percentage = 100 * currentPos / maxduration; //in %
                    $('.workDetail_timeBar').css('width', percentage + '%');
                });
            }

            // 监听全屏事件
            if (!that.checkBindEnvent($('.workDetail_fullscreen_btn'), 'click')) {
                $('.workDetail_fullscreen_btn').on('click', function () {
                    // 如果是全屏的状态
                    if (that.isFullScreen) {
                        that.refreshControls();
                        that.isFullScreen = false;
                    } else {// 如果是非全屏状态
                        $(".workDetail_fullscreen_btn img").attr("src", cancelFullscreenImgSrc);
                        $(".workDetail_video_div").addClass("workDetail_video_div_full");
                        $("#workDetail_video").addClass("workDetail_video_div_video_full");
                        $(".workDetail_content_video video").css("height", "100%");
                        $(".workDetail_content_video").css("height", "100%");
                        $(".workDetail_content_box").css("height", "100%");
                        $(".workDetail_content_box").css("position", "absolute");
                        $(".workDetail_content_video").css("position", "fixed");
                        $(".workDetail_content_video").css("top", "0");
                        $(".workDetail_content_video").css("left", "0");
                        $(".workDetail_commentList_box").css("display", "none");
                        that.isFullScreen = true;
                    }
                });
            }

            //进度条
            if (!that.checkBindEnvent($('.workDetail_progressBar'), 'touchstart')) {
                $('.workDetail_progressBar').on('touchstart', function (e) {
                    that.timeDrag = true;
                    that.updateBar(e.touches[0].pageX);
                });
            }
            if (!that.checkBindEnvent($('.workDetail_progressBar'), 'touchend')) {
                $('.workDetail_progressBar').on('touchend', function (e) {
                    if (that.timeDrag) {
                        that.timeDrag = false;
                    }
                });
            }
            if (!that.checkBindEnvent($('.workDetail_progressBar'), 'touchmove')) {
                $('.workDetail_progressBar').on('touchmove', function (e) {
                    if (that.timeDrag) {
                        that.updateBar(e.touches[0].pageX);
                    }
                });
            }
        },

        //查看某个元素是否绑定了某个事件
        checkBindEnvent: function (selector, eventName) {
            //jQuery event封装支持判断元素上是否绑定了事件，此方法只适用于jQuery绑定的事件
            var $events = $._data(selector[0], "events");
            if ($events && $events[eventName]) {
                return true;
            }
            return false;
        },

        //更新进度条
        updateBar: function (x) {
            var myVideo = document.getElementById("workDetail_content_video");
            var progress = $('.workDetail_progressBar');
            var maxduration = myVideo.duration; //Video duraiton
            var position = x - progress.offset().left; //Click pos
            var percentage = 100 * position / progress.width();

            //Check within range
            if (percentage > 100) {
                percentage = 100;
            }
            if (percentage < 0) {
                percentage = 0;
            }

            //Update progress bar and video currenttime
            $('.workDetail_timeBar').css('width', percentage + '%');
            myVideo.currentTime = maxduration * percentage / 100;
        },

        //还原初始状态
        refreshControls: function () {
            $(".workDetail_fullscreen_btn img").attr("src", "images/homeworkTe/fullscreen.png");
            $(".workDetail_video_div").removeClass("workDetail_video_div_full");
            $("#workDetail_video").removeClass("workDetail_video_div_video_full");
            $(".workDetail_content_video video").css("height", "");
            $(".workDetail_content_video").css("height", "");
            $(".workDetail_content_box").css("height", "");
            $(".workDetail_content_box").css("position", "");
            $(".workDetail_content_video").css("position", "");
            $(".workDetail_content_video").css("top", "");
            $(".workDetail_content_video").css("left", "");
            $(".workDetail_commentList_box").css("display", "block");
        },
       
    };
    return new obj();
})();