﻿var WorkListCtrl = (function () {
    var that;
    var obj = function () {
        that = this;
    };

    obj.prototype = {
        ctrl: function () {
            that.loginUser = Cache.getCache("LoginUserInfo");

            if (!that.loginUser) {
                Cache.getDbCache("LoginUserInfo", function (result) {
                    if (result) {
                        that.loginUser = result;
                    } else {
                        toPage("pnl_login");
                    }
                });
            }
          
            that.type = Cache.getCache("CurrWorkListType");

            that.datalist = [];
            that.workScroller = new devAfScroller("workList_listContent", {
                refreshFunc: that.loadList,
                loadMoreFunc: that.loadMore
            });
            that.workScroller.scrollTo({ x: 0, y: 0 });
            debugger;
            that.tabWorkIndex(that.type);

        },

        //获取作品列表
        getworkList: function (pageIndex) {
            Util.ajax({
                method: "POST",
                data: {
                    searchValue: "",
                    userId:0, //此参数在个人中心使用
                    size:5, 
                    index:pageIndex, 
                    userType: enumKey.HappyMusic.CurrUserVersion,
                    classificationId : 0, 
                    type: that.type
                },
                url: Util.getApiUrl("ListWork")
            }, function (data) {
                if (data.DataList.length > 0) {
                    if (pageIndex == 0) {
                        that.datalist = [];
                        document.getElementById("workList_list_template").innerHTML = "";
                    }
                    that.datalist = that.datalist.concat(data.DataList);
                    that.loadWork(data.DataList);
                    that.workScroller.setMoreRecord(data.DataList.length >= 5 ? true : false);
                    that.workScroller.pullback();
                }
            }, function () {
                that.workScroller.pullback();
            });
        },

        loadList: function () {
            that.getworkList(0);
        },

        loadMore: function () {
            that.getworkList(that.datalist.length);
        },

        loadWork: function (obj) {
            var commentList = obj;
            for (var i = 0; i < commentList.length; i++) {
                var str = '<div  class="workList_cell_box workList_cell_click" data="' + commentList[i].WorkId + '">'
                        + '<div class="workList_cell_top_box">'
                        +'<div class="workList_headerimg_div">'
                        +'<img src="' +( ( commentList[i].HeadImg == null || commentList[i].HeadImg == "") ? "images/background_img.jpg" : commentList[i].HeadImg ) + '" />'
                        +'</div>'
                        +'<div class="workList_name_div">'
                        +'<div class="workList_name" >' +(commentList[i].Nickname == null ? "":commentList[i].Nickname) + '</div>'
                        +'<div class="workList_time">' + commentList[i].CreateTimeYearStr + '</div>'
                        +'</div>'
                        +'</div>'
                        +'<div class="workList_cell_title">'
                        +'' + (  commentList[i].WorkName== null ? "": commentList[i].WorkName ) + ''
                        +'</div>'
                        +'<div class="workList_cell_content_img">'
                        +'<img src="' + commentList[i].WorkImg + '" /> '
                        +'</div>'
                        +'<div class="workList_cell_bottom_div">'
                        +'<img src="images/work/comment.png"  /><span>' + commentList[i].CommentCount + '</span>'
                        +'<img src="images/work/flower.png" /><span>' + commentList[i].Flower + '</span>'
                        + '</div>'
                        + '<div style="height:10px;width:100%;background-color:#EFEFEF"></div>'
                        + '</div>';
                 $("#workList_list_template").append(str);
                 //item.innerHTML = str;
                 //(function (el, vl) {
                 //    el.addEventListener("click", function () { that.goWorkDetail(vl); });
                 //})(item, commentList[i].WorkId);
                 //document.getElementById("workList_list_template").appendChild(item);                
            }
            //FixedStart by lijq 2016/11/4  
            CommonClickEvent(".workList_cell_click", function (isClick, value) {
                if (isClick) {
                    var index = parseInt(value);
                    debugger;
                    that.goWorkDetail(index);
                }
            });
            //FixedEnd
        },
        goWorkDetail: function (workId) {
            debugger;
            Cache.setCache("CurrWorkId", workId);
            Cache.setCache("isShowMyWorkList",true);
            toPage("pnl_workDetail");
        },
        tabWorkIndex: function (index) {
            $(".workList_header_title_btn").removeClass("workList_header_title_btn_active");
            //最新
            if (index==1) {
                $("#workList_header_title_new").addClass("workList_header_title_btn_active");
                that.type = 1;
                that.getworkList(0);

            } else if (index == 2) {
                //最热
                $("#workList_header_title_hot").addClass("workList_header_title_btn_active");
                that.type = 2;
                that.getworkList(0);
            }
        },
        uploadWorkBtn: function () {
            $("#workDetail_content_video")[0].pause();
            Util.ajax({
                method: "POST",
                data: {
                    spaceName: "video"
                },
                url: Util.getApiUrl("GetUptoken")
            }, function (data) {
                debugger;
                DDVideo.upload(data, that.loginUser.UserId, function (key) {
                    if (key != "") {
                        Cache.setCache("UploadWork_key", key);
                        toPage("pnl_uploadWork");
                    }
                });
            }, function () {
                Util.info("您的网络有问题哦~");
                callBack(false);
            });
        },
        backBtn: function () {
            if (that.loginUser.UserType == 1) {
                $.ui.goBack();
            } else if (that.loginUser.UserType == 2) {
                changeTecTab(1);
            }
        }
    };
    return new obj();
})();