﻿//*******作者 zhoucx 2016-07-14 v1.0.0********//
var PageLoading = function (options) {
    var that = this;
    that.imgUrl = options.loadingImg ? options.loadingImg : null;
    that.cover = document.createElement("div");
    that.cover.className = "PageLoading_Cover";
    that.cover.style.position = "fixed";
    that.cover.style.width = "100%";
    that.cover.style.height = "100%";
    that.cover.style.top = 0;
    that.cover.style.left = 0;
    that.cover.style.backgroundColor = "#FFFFFF";
    that.cover.style.textAlign = "center";
    that.cover.style.zIndex = 99;
    if (that.imgUrl) {
        var img = new Image();
        img.src = that.imgUrl;
        img.style.width = "25%";
        img.style.marginTop = "35%";
        //var textDiv = document.createElement("div");
        //textDiv.style.fontSize = "14pt";
        //textDiv.style.textAlign = "center";
        //textDiv.style.color = "#17B96E";
        //textDiv.style.marginTop = "20px";
        //textDiv.innerHTML = "页面加载中…";
        that.cover.appendChild(img);
        //that.cover.appendChild(textDiv);
    }
    else {
        var textDiv = document.createElement("div");
        textDiv.style.fontSize = "14pt";
        textDiv.style.textAlign = "center";
        textDiv.style.color = "#17B96E";
        textDiv.style.marginTop = "20%";
        textDiv.innerHTML = "页面加载中…";
        that.cover.appendChild(textDiv);
    }

    that.show = function (pageId) {
        var parent = document.getElementById(pageId);
        if (parent.getElementsByClassName(that.cover.className).length == 0) {
            parent.appendChild(that.cover);
        }
    };

    that.hide = function () {
        if (document.getElementsByClassName(that.cover.className).length > 0) {
            that.cover.remove();
        }
    }
}