var enumKey ={

	CommonResp : {
			Success:1,
			Failed:0
	},
	
	/**
	 * 课程搜索类型
	 */
	BookSearchType :{
			New:1,
			Hot:2
	},
	
	DanceType :{
			Sports:102,
			Ballet:111,
			ChineseDance:112
	},
	
	//视频播放速度
	VideoSpeed : {
			Fast:3,
			Normal:2,
			Slow:1
	},
	//视频播放方位
	VideoPosition :{
			Left:1,
			Middle:2,
			Right:3
	},
	//视频类型
	 VideoType :{
			Gold:1,
			Argentine:2,
			Copper:3,
			Gold1:4,
			Gold2:5,
			Gold3:6
	},
	
	  /// <summary>
    /// code表value
    /// </summary>
	 CodeValue : {

    },

    /// <summary>
    /// 金币变动原因
    /// </summary>
	 GoldChange : {
        /// <summary>
        /// 充值
        /// </summary>
        Recharge:1,
        /// <summary>
        /// 看视频
        /// </summary>
        Video:2,
        /// <summary>
        /// 交作业
        /// </summary>
        Homework:3,
        /// <summary>
        /// 购买产品
        /// </summary>
        Buy:4,
        /// <summary>
        /// 任务奖励
        /// </summary>
        Task:5,
        /// <summary>
        /// 玩游戏
        /// </summary>
        Game: 6,
	     /// <summary>
	     /// 批改作业
	     /// </summary>
        CorrectHomework:7,
	     /// <summary>
	     /// 首次登录赠送50金币
	     /// </summary>
        FirstTimeRecharge : 8,
	     /// <summary>
	     /// 人工充值
	     /// </summary>
        Artifical : 9,
	     /// <summary>
	     /// 提现
	     /// </summary>
        WithDraw:10,
	     /// <summary>
	     /// CDK兑换
	     /// </summary>
        CDKExcharge : 11,
	     // add by lujf 2016-8-25 start
	     /// <summary>
	     /// 答题对20题得50积分
	     /// </summary>
        Game_20 : 12,
	     /// <summary>
	     /// 填写邀请码获得20金币
	     /// </summary>
        Invite : 13,
	     /// <summary>
	     /// 机构充值
	     /// </summary>
        PlatRecharge : 14
	     // add by lujf 2016-8-25 end
    },

    /// <summary>
    /// 用户类型
    /// </summary>
	 UserType : {
        /// <summary>
        /// 学生
        /// </summary>
        Student:1,
        /// <summary>
        /// 老师
        /// </summary>
        Teacher:2,
    },

    /// <summary>
    /// 订单状态
    /// </summary>
	 OrderStatus : {
        /// <summary>
        /// 已服务
        /// </summary>
        AfterService:1,
        /// <summary>
        /// 退款中
        /// </summary>
        Refunding:2,
        /// <summary>
        /// 成交待评价
        /// </summary>
        ToDealComment:3,
        /// <summary>
        /// 退款待评价
        /// </summary>
        ToRefundComment:4,
        /// <summary>
        /// 已完成
        /// </summary>
        Finish:5,
    },

    /// <summary>
    /// 支付方式
    /// </summary>
	 PayType :  {
        /// <summary>
        /// 支付宝
        /// </summary>
        Zfb:1,
        /// <summary>
        /// 微信
        /// </summary>
        Wx:2
    },

    /// <summary>
    ///登录方式
    /// </summary>
	 LoginType : {
        /// <summary>
        /// 账号登录
        /// </summary>
       Common:0,
        /// <summary>
        /// 微信
        /// </summary>
        Wx:1,
        /// <summary>
        /// QQ
        /// </summary>
        QQ:2,
        /// <summary>
        /// 微博
        /// </summary>
        Wb:3
    },
    /// <summary>
    /// 登录状态
    /// </summary>
	 LoginRespEnum : {
        /// <summary>
        /// 登录成功
        /// </summary>
        Success:0,
        /// <summary>
        /// 用户名或密码错误
        /// </summary>
        Passwr_Id_Wrong:1,
        /// <summary>
        /// QQ第三方登录
        /// </summary>
        QQ_LoginRepeat:2,
        /// <summary>
        /// 微信第三方登录
        /// </summary>
        Weixin_LoginRepeat:3,
        /// <summary>
        /// 微博第三方登录
        /// </summary>
        Weibo_LoginRepeat:4,
        /// <summary>
        ///其他方式
        /// </summary>
        Other : 5,
        /// <summary>
        ///用户不存在
        /// </summary>
        User_Not_Exist:6
    },

    /// <summary>
    /// 货币单位
    /// </summary>
	 Unit : { 
        /// <summary>
        /// 人民币
        /// </summary>
        RMB:1,
        /// <summary>
        /// 金币
        /// </summary>
        Gold:2,
        /// <summary>
        /// 积分
        /// </summary>
        Integral:3
    },

    /// <summary>
    /// 作品订单状态
    /// </summary>
	 WorkStatus : {     
        /// <summary>
        /// 审核通过
        /// </summary>
        Approve:1,
        /// <summary>
        /// 未审核
        /// </summary>
        UnApprove:2
    },
    /// <summary>
    /// 电话号码修改状态
    /// </summary>
	 ModifyTelRespEnum : {
        /// <summary>
        /// 重置登录电话成功
        /// </summary>
        Success : 0,
        /// <summary>
        /// 重置登录电话失败
        /// </summary>
        ModifyTelErr :1,
        /// <summary>
        /// 验证码验证失败
        /// </summary>
        AuthcodeErr : 2
    },
    /// <summary>
    /// 家庭作业状态
    /// </summary>
	 HomeworkStatus : {
        /// <summary>
        /// 已批改
        /// </summary>
        Rendering :2,
        /// <summary>
        /// 未批改
        /// </summary>
        UnRendering:3
    },

    /// <summary>
    /// 返回值
    /// </summary>
	 RespCode : { 
        /// <summary>
        /// 成功
        /// </summary>
        Success:1,
        /// <summary>
        /// 失败
        /// </summary>
        Fail:2,
        /// <summary>
        /// 其他
        /// </summary>
        Other:3
    },
    //注册状态枚举
	 RegistRespEnum :  {
        Success :0,//注册成功

        Exists:1,//注册账户已存在

        AuthcodeErr:2//验证码验证错误
    },
	//产品类型
	 ProductType : {
		Virtual:1,//虚拟
		Entity:2	//实体		
	},
	
	//注册状态枚举
	 Ad :  {
        Main :0,//主页

        Game:1,//游戏

        Shop:2//商户
    },
	
	// 浮层  add by lujf 2016-7-25 start
	 FloatPageIndex:{
			Homework:0,
			Main:1,
			Setting:2
	},
	
	 FloatPage:{
			Homework:"homework",
			Main:"main",
			Setting:"setting"
	},
	// 浮层  add by lujf 2016-7-25 end
	
	//当前版本
	 HappyMusic:{
			AndroidVersion:"4.0.5",
			IOSVersion:"4.1.2",
			CurrUserVersion: 1// 1:Student,2:Teacher,
	 },

	 CheckAuthcodeEnum: {
	     /// <summary>
	     /// 正确
	     /// </summary>
	     Success : 1,
	     /// <summary>
	     /// 错误
	     /// </summary>
	     Wrong : 2,
	     /// <summary>
	     /// 过期
	     /// </summary>
	     TimeOut : 3
	 },

    /// <summary>
    /// 视频状态
    /// </summary>
	 VideoStatus:
    {
        /// <summary>
        /// 上架
        /// </summary>
        OnSale: 1,
        /// <summary>
        /// 下架
        /// </summary>
        OffSale: 2
    },
    /// <summary>
    /// 视频状态
    /// </summary>
     GoldLogShowType:
    {
            /// <summary>
            /// 增加
            /// </summary>
            Increase:1,

            /// <summary>
            /// 减少
            /// </summary>
            Decrease :2

    }


}